Change notes from older releases. For current info, see RELEASE-NOTES-1.44.

= MediaWiki 1.43 =

PHP 8.1 workboard: https://phabricator.wikimedia.org/tag/php_8.1_support/
PHP 8.2 workboard: https://phabricator.wikimedia.org/tag/php_8.2_support/
PHP 8.3 workboard: https://phabricator.wikimedia.org/tag/php_8.3_support/
PHP 8.4 workboard: https://phabricator.wikimedia.org/tag/php_8.4_support/

=== Changes since MediaWiki 1.43.1 ===

* Localisation updates.
* (T382987) $wgDnsBlacklistUrls now defaults to an empty array. See the comment
  in the "Configuration changes for system administrators" section.

== MediaWiki 1.43.0 ==

=== Changes since MediaWiki 1.43.0-rc.0 ===
* (T381728) Use PHP 8.3 in MediaWiki-Docker
* (T382375) Misaligned label margins on Special:MathStatus
* (T382196) \overbrace rendered below (not above) in MathML and client-side
  Mathjax
* (T381310) Math Popup not working in newer version of Popup-Extension
* (T380079) This page is using the deprecated ResourceLoader module
  "mediawiki.Uri" on page load
* (T381311) Preview has wrong location in MathML mode
* (T381046) Preview not working with MathML rendering
* (T381102) <math>\left(a\right)'</math> in MathML and MathJax renders
  with one prime symbol too much
* (T380184) <math>\operatorname{vec}</math> crashes with native MathML
* (T380654) vertical space between multline equations is ignored
* (T375274) mediawiki_function_names math functions eat the following paren in
  native MML mode
* (T373732) Audit SUL3 shared-domain i18n messages for XSS
* (T381068) PHP Deprecated: Creation of dynamic property
  MediaWiki\\Auth\\ButtonAuthenticationRequest::$skipReset is deprecated
  at AuthenticationRequest.php:182
* (T20110) Define AbuseFilter consequence to display a CAPTCHA
* (T332743) On private wikis the ellipsis should not appear above 720px
  (wikitech, office, translate wiki)

== Upgrading notes for 1.43 ==
Don't forget to always back up your database before upgrading!

See the file UPGRADE for more detailed per-version upgrade instructions from the
oldest supported upgrading version, MediaWiki 1.35.

Some specific notes for MediaWiki 1.43 upgrades are below:

* It is now necessary that the OpenSSL PHP extension is installed.
* update.php updates the Linter database table with two migration scripts that
  can take a long time to run: with the provided settings, each migration
  script update roughly 500 rows per second. If at all possible, it is
  highly recommended to let update.php run these migration scripts.

  If this is deemed too long a maintenance operation (depending on the number
  of rows in the Linter database table), it is possible, for a upgrade from
  1.40 onwards, to run the migration scripts before updating the MediaWiki
  and extensions files to 1.43. Set $wgLinterWriteNamespaceColumnStage and
  $wgLinterWriteTagAndTemplateColumnsStage to true, and run the
  extensions/Linter/maintenance/migrateNamespace.php and
  extensions/Linter/maintenance/migrateTagTemplate.php migration scripts
  before proceeding with any other code update.
  When upgrading from a version <= 1.39, a multi-step update is necessary to
  be able to run the migration scripts independently from update.php: first
  update to 1.42, then proceed as indicated.

For notes on 1.42.x and older releases, see HISTORY.

=== Configuration changes for system administrators in 1.43 ===

* $wgBlockTargetMigrationStage, which was introduced in 1.42, is now deprecated
  and has no effect.
* (T382987) The default value of 'http.dnsbl.sorbs.net.' in $wgDnsBlacklistUrls
  has been removed. This is because sorbs.net have stopped providing their
  services. This means that if you have $wgEnableDnsBlacklist set to true, it
  will no longer provide any value unless you add other servers to
  $wgDnsBlacklistUrls.

==== New configuration ====

* (T13555) $wgParserEnableLegacyHeadingDOM - Defaults to `true`, can be set to
  `false` to enable new, more accessible HTML markup for wikitext headings.
  Note that each skin must also use the 'supportsMwHeading' option to allow it.
  More information: https://www.mediawiki.org/wiki/Heading_HTML_changes
  In a future release the new markup will become the default,
  and later this option will be removed.
* (T12347) $wgEnableProtectionIndicators - Defaults to false, setting it to true
  shows a lock icon indicator on protected pages.
* (T373480) $wgSortedCategories - Defaults to false, setting it to true will
  sort the categories shown on article pages.  This is an experimental setting;
  its future will depend on community adoption and feedback on the phab task
  is welcome.
* (T45646) $wgAllowRawHtmlCopyrightMessages - Defaults to true, can be set to
  false to disable the use of the localisation messages 'copyright' and
  'history_copyright' and the hook 'SkinCopyrightFooter', which have been
  deprecated in this release. This helps protect your wiki against attacks by
  a rogue administrator account and will become the default in the future.
* (T4085) $wgParserEnableUserLanguage - Defaults to false, can be set to
  true to let {{USERLANGUAGE}} magic word return the user's language,
  instead of the page language. Beware that accessing the user language may
  reduce the efficiency of the parser cache.

==== Changed configuration ====

* wgPageLinksSchemaMigrationStage – (T299947) This temporary setting, which
  controls the database schema migration for the page links table, is now set
  by default to write to both old and new data and read from the new data.
* wgFooterIcons – (T256190) The default "Powered by MediaWiki" button icon has
  been updated to an SVG icon, and the footer icons are now wrapped as buttons
  in HTML, rather than faking it within the icons themselves. You should adjust
  any footer icons you provide or over-ride to match.
* The "error-json" channel, configurable via $wgDebugLogGroups, has been
  removed. For structured logging, use the "error" channel directly instead.
  Since MediaWiki 1.25, structured logging is supported via Monolog for all
  channels, including the "error" channel. For silenced errors, you use the
  "silenced-error" channel added in MediaWiki 1.42. (T193472)
* wgResourceLoaderUseObjectCacheForDeps - (T343492) This is now enabled by
  default. This means ResourceLoader writes information to the MainStash
  instead of a core database table, which can be set to a separate database
  via wgMainStash. If you find issues, please drop a comment on T343492.
  It is now deprecated and will be removed in MediaWiki 1.44.

==== Removed configuration ====

* wgSessionInsecureSecrets has been removed since OpenSSL is now a required
  PHP extension.
* $wgTemplateLinksSchemaMigrationStage has been removed.
* $wgSamplingStatsdClient has been removed. It was introduced in MW 1.28 for
  use in the Wikibase extension, but never used. The new StatsFactory service
  should be used for new instrumentations, which already supports sampling.
  Beware that sampling is generally not needed even at scale, and that sampling
  does not significantly reduce runtime overhead, thus making it slow to
  instrument very hot code even with built-in sampling.
* (T294397) The 'writeapi' userright, which controlled access to some API
  modules, has been removed.
* (T331883) The variables $wgLinterWriteTagAndTemplateColumnsStage,
  $wgLinterUserInterfaceTagAndTemplateStage, $wgLinterWriteNamespaceColumnStage,
  and $wgLinterUseNamespaceColumnStage have been removed. The namespace,
  tag and template column of the Linter database table are now written and used.
  The existing data from the Linter database is migrated to the new columns
  by extensions/Linter/maintenance/migrateNamespace.php and
  extensions/Linter/maintenance/migrateTagTemplate.php, which are both called
  by the update script (T367207).

=== New user-facing features in 1.43 ===

* (T338341) Support reading XMP and EXIF from WebP files
* (T365636) Wiki's with wgAllowExternalImages enabled now detect urls
  with AVIF, SVG and WebP images.
* (T242346) Special:TalkPage is a new special page that will redirect to the
  associated talk namespace page, e.g. [[Special:TalkPage/Foo]] redirects to
  [[Talk:Foo]]; [[Special:TalkPage/Project:Foo]] goes to [[Project talk:Foo]].
  This allows for links by templates and tools without having to parse what
  namespaces are valid and have associated talk pages.
* New preference: "Send password reset emails only when both email address
  and username are provided."
* (T4085) Added new magic word {{USERLANGUAGE}} which returns the language code
  of the interface set by the user.
* (T263513) Special:NamespaceInfo is a new special page that displays a list
  of namespaces available on the wiki, their descriptions and configuration.

=== New developer features in 1.43 ===

* StatusValue class gained new method getMessages(): MessageSpecifier[],
  allowing the errors to be inspected and displayed more easily, for example:
    foreach ( $status->getMessages() as $msg ) {
      if ( $msg->getKey() !== 'ignored-message' ) {
        $this->getOutput()->addWikiMsg( $msg );
      }
    }
* (T358779) The MessageValue class can now be used instead of Message in most
  places (in methods that accept the MessageSpecifier interface). This allows
  using localisation messages in code that doesn't know the user's language,
  such as many hooks, without relying on global state. To convert between them,
  use MessageValue::newFromSpecifier() and Message::newFromSpecifier().
* The REST API framework now supports defining redirects in route definition
  files. See MediaWiki\Rest\Handler\RedirectHandler for details.
* (T13555) Skins can enable the 'supportsMwHeading' option for new, more
  accessible HTML markup for wikitext headings. MediaWiki's own styles and
  scripts have been updated to support it, but your skin may also need updates.
  More information: https://www.mediawiki.org/wiki/Heading_HTML_changes
  A future release will emit deprecation warnings for skins with
  'supportsMwHeading' set to false.
* The AuthPreserveQueryParams hook was added.
* (T219397) New `Language::formatDurationBetweenTimestamps()` function added
  which takes two timestamps and a precision in order to calculate a more
  accurate text representation of duration.
* Added an interactive mode to the install.php maintenance script.
* The ResourceLoaderModifyEmbeddedSourceUrls hook was added.
* The AuthManagerFilterProviders hook was added.
* The AuthManagerVerifyAuthentication hook was added.
* The OutputPageRenderCategoryLink hook was added, as a replacement for the
  deprecated OutputPageMakeCategoryLinks hook.
* PreAuthenticationProvider, PrimaryAuthenticationProvider, and
  SecondaryAuthenticationProvider now receive a `canAlwaysAutocreate` flag in
  the options of the `testUserForCreation` invocation. This flag is true when
  the session provider is exempt from autocreate user permissions checks.
* The CentralIdLookup service gained the isOwned() method, which can be used
  to check if a local username is reserved for a central user, even if a local
  user account does not exist yet. This can be used by extensions to look
  up information about the central user.
* (T251790) A Jest-based test suite has been introduced for testing front-end
  code such as Vue components. Tests can be run via `npm run jest`, and test
  files live in `tests/jest/`. See https://www.mediawiki.org/wiki/Jest
  for more information.
* The SpreadAnyEditBlock hook was added.
* The ConditionalDefaultOptionsAddCondition hook was added.

=== External library changes in 1.43 ===

* The OOjs Router library has been merged into core and will be archived
  upstream.

===== New development-only external libraries =====

* (T251790) Some development-only external libraries have been added for the new
  testing tools for front-end Vue components:
  * Added jest and jest-environment-jsdom at v29.7.0.
  * Added @vue/test-utils v2.4.6.
  * Added @vue/vue3-jest v29.2.6.
  * Added @babel/preset-env v7.25.4.
  * Added pinia v2.0.16 (already available via ResourceLoader).
  * Added @pinia/testing v0.0.12.
  * Codex, already available via ResourceLoader, now has the npm versions, i.e.
    @wikimedia/codex and @wikimedia/codex-icons, also installed for testing.

==== Changed external libraries ====

* Updated codex, codex-design-tokens and codex-icons
  from v1.3.6 to v1.14.0.
* Updated composer/semver from 3.4.0 to 3.4.3.
* Updated guzzlehttp/guzzle from 7.7.1 to 7.9.2.
* Updated jquery.i18n from 1.0.7 to 1.0.10.
* Updated justinrainbow/json-schema from 5.2.13 to 5.3.0.
* Updated pear/mail from 1.6.0 to 2.0.0.
* Updated pear/net_smtp from 1.11.1 to 1.12.1.
* Updated mck89/peast from v1.16.2 to 1.16.3.
* Updated monolog/monolog from 2.9.2 to 2.9.3.
* Updated symfony/yaml from 5.4.35 to 5.4.45.
* Updated OOUI from v0.49.1 to v0.51.2.
* Updated wikimedia/at-ease from 2.1.0 to 3.0.0.
* Updated wikimedia/json-codec from 3.0.1 to 3.0.3.
* Updated wikimedia/less.php from 4.2.1 to 5.1.2.
* Updated wikimedia/minify from 2.7.0 to 2.8.0.
* Updated wikimedia/normalized-exception from 1.0.1 to 2.0.0.
* Updated wikimedia/php-session-serializer from 2.0.1 to 3.0.0.
* Updated wikimedia/purtle from 1.0.8 to 2.0.0.
* Updated wikimedia/relpath from 4.0.0 to 4.0.1.
* Updated wikimedia/remex-html from 4.1.0 to 4.1.1.
* Updated wikimedia/request-timeout from 1.2.0 to 2.0.0.
* Updated wikimedia/scoped-callback from 4.0.0 to 5.0.0.
* Updated wikimedia/services from 3.0.0 to 4.0.0.
* Updated wikimedia/shellbox from 4.0.2 to 4.1.1.
* Updated wikimedia/xmp-reader from 0.9.1 to 0.9.4.
* Updated vue from 3.3.9 to 3.4.27.
* Updated symfony/polyfill-php80 from 1.29.0 to 1.31.0.
* Updated symfony/polyfill-php81 from 1.29.0 to 1.31.0.
* Updated symfony/polyfill-php82 from 1.29.0 to 1.31.0.
* Updated symfony/polyfill-php83 from 1.29.0 to 1.31.0.

===== Changed development-only external libraries =====

* Updated doctrine/dbal from 3.7.2 to 3.8.4.
* Updated eslint-config-wikimedia from 0.26.0 to 0.28.2.
* Updated mediawiki/mediawiki-codesniffer from 43.0.0 to 45.0.0.
* Updated phpunit/phpunit from 9.6.16 to 9.6.19.
* Updated seld/jsonlint from 1.10.1 to 1.10.2.

=== Bug fixes in 1.43 ===

* When using the 'runMaintenance' method in a LoadExtensionSchemaUpdates hook
  handler, only the script's class name is required, not its path. (T367918)
* QueryPage::recache() (used by the updateSpecialPages.php maintenance script)
  no longer attempts to ignore database errors. (T278543)

=== Action API changes in 1.43 ===

* APIQueryUserInfo now returns null in the field registrationdate for users
  created before December 2005 (their registration date was not recorded).

=== Languages updated in 1.43 ===
MediaWiki supports over 350 languages. Many localisations are updated regularly.
Below only new and removed languages are listed, as well as changes to languages
because of Phabricator reports.

* (T375891) Updated the autonym for Kadazan Dusun (dtp)
* (T357853) Added unidirectional script conversion for Meitei to Bengali script.
* (T367377) Updated the autonym for Tai Nuea (tdd)
* (T375947) Updated the autonym for Komering (kge)
* (T354937, T362041) Added language support for Minnan (Traditional Han script)
  (nan-hant).
* (T290657) Added language support for Levantine Arabic (apc).
* (T364291) Added language support for Musi, also known as Palembang (mui).
* (T364737) Added language support for Haryanvi (bgc).
* (T365365) Added language support for Chakma (ccp).
* (T367991) Added language support for Iban (iba).
* (T367688) Added language support for Interslavic (Latin) (isv-latn).
* (T375360) Added language support for Interslavic (Cyrillic) (isv-cyrl).
* (T370123) Added language support for Nupe (nup).
* (T371051) Added language support for Saint Lucian Creole (acf).
* (T354937, T370987) Added language support for Minnan (Pe̍h-ōe-jī)
  (nan-latn-pehoeji).
* (T354937, T369899) Added language support for Minnan (Tâi-lô)
  (nan-latn-tailo).
* (T375052) Added language support for Tigre (tig).
* (T375999) Added language support for Luba-Lulua (lua).
* (T376248) Added language support for Duala (dua).
* (T375377) Added language support for Southern Ndebele (nr).
  This is done experimentally, with only a Names.php entry and
  namespace translations, before we have actual localized strings.
  For details, see https://www.mediawiki.org/wiki/Future_of_Language_Incubation.
* (T356144) Deprecated the Kanuri language (kr) and replaced it
  with Central Kanuri (knc). The language code kr is kept for
  backwards compatibility and falls back to knc.

=== Breaking changes in 1.43 ===

* (T358779) The format of parameters used by the Message class has changed.
  Instead of arrays in a special format, they are now MessageParam objects.
  Code that simply called methods like Message::numParam() and didn't look
  inside the values they return should be unaffected. Code that depended on
  the formatted params being arrays or accessed their keys will need updates.
  Example patches: https://gerrit.wikimedia.org/r/q/topic:message-param
* ErrorPageError public properties 'msg' and 'title' may now contain
  any MessageSpecifier object, not just Message.
* Reset button functionality suppressReset() and $mShowReset from HTMLForm
  was removed without replacement.
* UserGroupMembership::getGroupName(), deprecated in 1.38, and
  UserGroupMembership::getGroupMemberName(), deprecated in 1.40, have
  been removed.
* SerializedValueContainer::isUnified(), deprecated in 1.42, has been
  removed.
* Parser::getFreshParser(), deprecated in 1.39, has been removed.
* ParserOutput::getLanguageLinks() no longer returns a reference to the
  internal array.
* ConfigFactory::getDefaultInstance(), deprecated since 1.27, has been
  removed.
* wfGetLangObj(), deprecated since 1.41, has been removed in favor of
  LanguageFactory::getLanguage().
* wfRemoveDotSegments(), deprecated in 1.39, has been removed.
* IReadableDatabase::getReplicaPos() has been removed without deprecation
  as it's not used anywhere.
* CommentFormatter::formatStringsAsBlock() has been removed without deprecation
  as it's not used anywhere.
* ILoadBalancer::laggedReplicaUsed() has been moved to ILoadBalancerForOwner::
  effectively making it internal.
* Define DB_MASTER, deprecated since 1.36, has been removed.
* ILoadBalancer::DB_MASTER, deprecated since 1.36, has been removed.
* Overriding MWException::getHTML(), ::getText(), ::getPageTitle(), and
  ::reportHTML() in order to display custom exception messages is no
  longer supported.
* In PageHandlerTestTrait, the newRouter() method was renamed to
  newRouterForPageHandler() to avoid a conflict with a method of the same
  name in RestTestTrait. Also, PageHandlerTestTrait is no longer marked as
  "stable to use". It was marked this way by accident, the functionality it
  provides is specific to certain handlers implemented in MediaWiki core.
* MediaWikiIntegrationTestCase::addCoreDBData(), deprecated since 1.41, has
  been removed.
* wfUnpack(), deprecated since 1.42, has been removed in favor of
  StringUtils::unpack().
* UIDGenerator, deprecated since 1.35, has been removed.
* TablePager::getBody(), final and deprecated since 1.24, has been removed.
  Use ::getBodyOutput() or ::getFullOutput() instead.
* ImportableUploadRevisionImporter::downloadSource(), deprecated in 1.31, is now
  private. Its only known external caller was removed in 1.40.
* The following methods in the User class have been removed:
  * Deprecated in 1.33:
    * User::isBlockedFrom()
  * Deprecated in 1.34:
    * User::isBlocked()
  * Deprecated in 1.35:
    * User::addGroup()
    * User::getAllGroups()
    * User::getGroups()
    * User::getGroupMemberships()
    * User::getImplicitGroups()
    * User::getOption()
    * User::removeGroup()
  * Deprecated in 1.37:
    * User::isBlockedFromCreateAccount()
* BotPassword::invalidateAllPasswordsForCentralId() and
  BotPassword::removeAllPasswordsForCentralId(), deprecated in 1.37,
  have been removed.
* Title::getBrokenLinksFrom(), deprecated in 1.42, has been removed.
* The $type parameter to Skin::getCopyright(), deprecated in 1.40, has been
  removed.
* The module `mediawiki.icon`, deprecated in 1.42, has been removed.
* The `@vue/composition-api` module, a deprecated alias for `vue` since 1.41,
  has been removed. Use `vue` directly.
* SiteConfiguration::extractVar() and ::extractGlobal(), deprecated in 1.41,
  have been removed.
* Skin::footerLink(), deprecated in 1.40, has been removed.
* Skin::getAction(), deprecated in 1.39, has been removed.
* Skin::makeSearchInput(), deprecated in 1.35, has been removed.
* Skin::makeSearchButton(), deprecated in 1.39, has been removed.
* SkinTemplate::buildContentNavigationUrls(), deprecated in 1.38,
  has been removed.
* Title::getCdnUrls() and Title::purgeSquid(), deprecated in 1.35, have been
  removed.
* The `mediawiki.pager.tablePager` module, deprecated in 1.38, has been
  removed in favor of the more generic `mediawiki.pager.styles`.
* BagOStuff::setNewPreparedValues(), deprecated in 1.40, has been removed.
* Constructing MWHttpRequest objects now requires timeout and connectTimeout to
  be set; this was deprecated in 1.35.
* Hooks that were run from SpecialContributions are now run from the parent,
  ContributionsSpecialPage. The page passed in is a ContributionsSpecialPage
  type, and documentation and type comparisons may need to be updated. Affected
  hooks are: ContributionsBeforeMainOutputHook, ContributionsToolLinksHook,
  SpecialContributions__getForm__filtersHook.
* Hooks that were run from ContribsPager are now run from the parent,
  ContributionsPager. If a pager is passed in, it is a ContributionsPager type,
  and documentation and type comparisons may need to be updated. Affected
  hooks are: ContribsPager__reallyDoQueryHook, ContribsPager__getQueryInfoHook,
  ContributionsLineEndingHook, SpecialContributions__formatRow__flagsHook.
* Hooks that were run from DeletedContribsPager are now run from the parent,
  ContributionsPager. If a pager is passed in, it is a ContributionsPager type,
  and documentation and type comparisons may need to be updated. Affected
  hooks are: DeletedContribsPager__reallyDoQueryHook and
  DeletedContributionsLineEndingHook.
* The public method ContributionsSpecialPage::getUserLinks has been made
  protected. Although not marked @internal, the method was public to be called
  from SpecialDeletedContributions (call now removed), and was not called from
  anywhere else.
* DatabaseBlock::purgeExpired, deprecated since 1.38, has been removed.
* AbstractBlock::getPermissionsError, deprecated since 1.35, has been removed.
* IDatabase::namedLocksEnqueue() has been removed without deprecation.
* IDatabase::getTopologyRole() has been removed without deprecation.
* IDatabase::getTopologyBasedServerId() has been removed without deprecation.
  Use IDatabase::getServerName() instead.
* IReadableDatabase::wasReadOnlyError() has been removed without deprecation.
  Use IDatabase::isReadOnly() instead.
* IReadableDatabase::wasDeadlock() has been removed without deprecation.
* ILoadBalancer::getWriterIndex() has been removed without deprecation.
  Use ServerInfo::WRITER_INDEX constant instead.
* MaintainableDBConnRef, deprecated since 1.39, has been removed.
* ILoadBalancer::reuseConnection(), deprecated since 1.39, has been removed.
* The $domain parameter to ILoadBalancer::getReadOnlyReason(), deprecated in
  1.40, has been removed.
* WikiPage::doDeleteArticleBatched, hard deprecated since 1.37, has been
  removed.
* SpecialEmailUser::submit, deprecated since 1.41, has been removed.
* SpecialEmailUser::validateTarget, deprecated since 1.41, has been removed.
* SpecialEmailUser::getPermissionsError, deprecated since 1.41 has been
  removed.
* SpecialBlock::getTargetAndType, deprecated since 1.36, has been removed.
* ApiQueryBlockInfoTrait::addBlockInfoToQuery(), deprecated since 1.42, has been
  removed.
* Linker::makeExternalLink() has been deprecated in favor of
  LinkRenderer::makeExternalLink(), which has a improved API to help phan's
  SecurityCheckPlugin provide more accurate checks for escaping issues.
* Linker::makeHeadline(), Linker::generateTOC(), Linker::tocIndent(),
  Linker::tocUnindent(), Linker::tocLine(), Linker::tocLineEnd(), and
  Linker::tocList(), deprecated in 1.42, have been removed.
* Linker::formatComment(), Linker::formatLinksInComment(),
  Linker::commentBlock(), and Linker::revComment(), deprecated in 1.38,
  have been removed.
* UserCache::singleton(), deprecated in 1.43, now emits deprecation warnings.
  Use MediaWikiServices::getInstance()->getUserCache() instead.
* DummyLinker has been removed. The former DummyLinker parameter
  to the 'ImageBeforeProduceHTML' hook is now null.
* The following methods of IDatabase have been moved to internal interface
  IDatabaseForOwner without deprecation. These methods are internal and
  shouldn't be used outside of rdbms library:
  - ::pendingWriteCallers()
  - ::flushSession()
  - ::lastDoneWrites()
  - ::setTransactionListener()
  - ::serverIsReadOnly()
  - ::getPrimaryPos()
  - ::pendingWriteQueryDuration()
  - ::writesOrCallbacksPending()
  - ::writesPending()
  - ::primaryPosWait()
* IMaintainableDatabase::listViews(), deprecated since 1.42, has been removed.
* IMaintainableDatabase::truncate(), deprecated since 1.42, has been removed.
* IMaintainableDatabase::textFieldSize() was removed without deprecation.
* ReplicatedBagOStuff, deprecated since 1.42, has been removed.
* The 'replicaOnly' option to SqlBagOStuff has been removed without deprecation.
  It existed for internal use by SqlBagOStuff only.
* Support for WinCache as local server cache has been removed, because WinCache
  is not available for supported versions of PHP. The WinCacheBagOStuff class
  has been removed. Use MediaWikiServices::getLocalServerObjectCache() instead,
  or the CACHE_ACCEL type instead, which automatically selects APCu when
  available.
  The "wincache" cache type (e.g. to ObjectCache::getInstance, and in
  "wg*CacheType" configuration) remains supported as an alias for CACHE_ACCEL.
* LockManager::sha1Base16Absolute(), has been removed without deprecation.
* The "options" parameter to User::createNew() and the $data parameter to
  UserOptionsManager::loadUserOptions() were removed.
* `.list-style-image()` mixin from mediawiki.mixins.less, deprecated since 1.38,
  has been removed.
* `.background-image()` mixin from mediawiki.mixins.less, deprecated since 1.38,
  has been removed.
* IDatabase::nextSequenceValue(), deprecated since 1.30, was removed.
* $wgAPIRequestLog was removed without deprecation. Use "api" and "api-request"
  wgDebugLogGroups channels or SPI instead.
* The setStats() method in MediaWiki\Rest\Router now expects a StatsFactory
  rather than a StatsdDataFactoryInterface. The method has been marked @internal
  and should not be called by extensions.
* All `@width-breakpoint-*` Less variables have been removed. Use
  `@min-width-breakpoint-*`/`@max-width-breakpoint-*` instead.
* The MessageContent class, deprecated since 1.38, is now removed. This also
  means that the Message::content() method is also removed.
* The following ParserOption methods, deprecated since 1.35, were removed:
  - ::setAllowExternalImages()
  - ::setAllowExternalImagesFrom()
  - ::setEnableImageWhitelist()
* Sanitizer::removeHTMLtags(), deprecated since 1.38, has been removed.
* OutputPage::getCSPNonce(), deprecated since 1.35, has been removed.
* UserMailer::rfc822Phrase(), deprecated since 1.38, has been removed.
* QueryPage::getSQL(), deprecated since 1.39, has been removed. The replacement
  QueryPage::getQueryInfo() is now abstract.
* update-keys.sql was removed. It is not recommended to install MediaWiki by
  manually sourcing SQL files, but if you are doing this, run
  `update.php --initial` instead of sourcing update-keys.sql.
* MediaWikiVersionFetcher, deprecated since 1.42 has been removed.
* Support for using Skin::addToBodyAttributes() method, which was deprecated
  in 1.35, has been removed. Use OutputPageBodyAttributesHook instead.
* Skins since 1.39 have not supported rendering content outside the body tag.
The bodyOnly=false option has now been removed, meaning this is no longer
supported.
* CentralIdLookup::factoryNonLocal(), deprecated since 1.37, has been removed.
* CryptHKDF and MWCryptHKDF were removed without deprecation, in part because no
  past or present use could be found. hash_hkdf() can be used instead of HKDF().
  While generate() and generateHex() have no direct replacement, random_bytes()
  and MWCryptRand::generateHex() can be used instead.

=== Deprecations in 1.43 ===

* The methods StatusValue::getErrors() and StatusValue::getErrorsByType(),
  as well as Status::getErrorsArray() and Status::getWarningsArray(), have
  been deprecated in favor of new method StatusValue::getMessages().
* PermissionManager::getPermissionErrors() has been deprecated in favor
  of getPermissionStatus().
* PermissionStatus::toLegacyErrorArray() is deprecated with no replacement.
* PermissionsError properties $errors and $permission are deprecated.
  To display the error, throw it or use ->report().
* (T166010) All PHP code in MediaWiki is slowly being moved to be in a class
  namespace as appropriate, so that we can use PSR-4 auto-loading, which will
  speed up general code loading of MediaWiki. The old global namespace class
  names are being left behind as deprecated aliases.

  In this release of MediaWiki, 2236 classes now have a namespace and 509 do
  not yet (81% done, up from 69% in MediaWiki 1.42.0). The following have newly
  been moved:
  - MediaWiki\Api:
    - ApiAMCreateAccount
    - ApiAcquireTempUserName
    - ApiAuthManagerHelper
    - ApiBase
    - ApiBlock
    - ApiBlockInfoTrait
    - ApiCSPReport
    - ApiChangeAuthenticationData
    - ApiChangeContentModel
    - ApiCheckToken
    - ApiClearHasMsg
    - ApiClientLogin
    - ApiComparePages
    - ApiContinuationManager
    - ApiCreateTempUserTrait
    - ApiDelete
    - ApiDisabled
    - ApiEditPage
    - ApiEmailUser
    - ApiErrorFormatter
    - ApiErrorFormatter_BackCompat
    - ApiExpandTemplates
    - ApiFeedContributions
    - ApiFeedRecentChanges
    - ApiFeedWatchlist
    - ApiFileRevert
    - ApiFormatBase
    - ApiFormatFeedWrapper
    - ApiFormatJson
    - ApiFormatNone
    - ApiFormatPhp
    - ApiFormatRaw
    - ApiFormatXml
    - ApiFormatXmlRsd
    - ApiHelp
    - ApiHelpParamValueMessage
    - ApiImageRotate
    - ApiImport
    - ApiImportReporter
    - ApiLinkAccount
    - ApiLogin
    - ApiLogout
    - ApiMain
    - ApiManageTags
    - ApiMergeHistory
    - ApiMessage
    - ApiMessageTrait
    - ApiModuleManager
    - ApiMove
    - ApiOpenSearch
    - ApiOpenSearchFormatJson
    - ApiOptions
    - ApiOptionsBase
    - ApiPageSet
    - ApiParamInfo
    - ApiParse
    - ApiPatrol
    - ApiProtect
    - ApiPurge
    - ApiQuery
    - ApiQueryAllCategories
    - ApiQueryAllDeletedRevisions
    - ApiQueryAllImages
    - ApiQueryAllLinks
    - ApiQueryAllMessages
    - ApiQueryAllPages
    - ApiQueryAllRevisions
    - ApiQueryAllUsers
    - ApiQueryAuthManagerInfo
    - ApiQueryBacklinks
    - ApiQueryBacklinksprop
    - ApiQueryBase
    - ApiQueryBlockInfoTrait
    - ApiQueryBlocks
    - ApiQueryCategories
    - ApiQueryCategoryInfo
    - ApiQueryCategoryMembers
    - ApiQueryContributors
    - ApiQueryDeletedRevisions
    - ApiQueryDeletedrevs
    - ApiQueryDisabled
    - ApiQueryDuplicateFiles
    - ApiQueryExtLinksUsage
    - ApiQueryExternalLinks
    - ApiQueryFileRepoInfo
    - ApiQueryFilearchive
    - ApiQueryGeneratorBase
    - ApiQueryIWBacklinks
    - ApiQueryIWLinks
    - ApiQueryImageInfo
    - ApiQueryImages
    - ApiQueryInfo
    - ApiQueryLangBacklinks
    - ApiQueryLangLinks
    - ApiQueryLanguageinfo
    - ApiQueryLinks
    - ApiQueryLogEvents
    - ApiQueryMyStashedFiles
    - ApiQueryPagePropNames
    - ApiQueryPageProps
    - ApiQueryPagesWithProp
    - ApiQueryPrefixSearch
    - ApiQueryProtectedTitles
    - ApiQueryQueryPage
    - ApiQueryRandom
    - ApiQueryRecentChanges
    - ApiQueryRevisions
    - ApiQueryRevisionsBase
    - ApiQuerySearch
    - ApiQuerySiteinfo
    - ApiQueryStashImageInfo
    - ApiQueryTags
    - ApiQueryTokens
    - ApiQueryUserContribs
    - ApiQueryUserInfo
    - ApiQueryUsers
    - ApiQueryWatchlist
    - ApiQueryWatchlistRaw
    - ApiRawMessage
    - ApiRemoveAuthenticationData
    - ApiResetPassword
    - ApiResult
    - ApiRevisionDelete
    - ApiRollback
    - ApiRsd
    - ApiSerializable
    - ApiSetNotificationTimestamp
    - ApiSetPageLanguage
    - ApiStashEdit
    - ApiTag
    - ApiUnblock
    - ApiUndelete
    - ApiUpload
    - ApiUsageException
    - ApiUserrights
    - ApiValidatePassword
    - ApiWatch
    - ApiWatchlistTrait
    - IApiMessage
    - SearchApi
  - MediaWiki\Content:
    - AbstractContent
    - CodeContentHandler
    - Content
    - ContentHandler
    - ContentModelChange
    - CssContent
    - CssContentHandler
    - FallbackContent
    - FallbackContentHandler
    - FileContentHandler
    - JavaScriptContent
    - JavaScriptContentHandler
    - JsonContent
    - JsonContentHandler
    - TextContent
    - TextContentHandler
    - WikitextContent
    - WikitextContentHandler
    - WikiTextStructure
  - MediaWiki\Debug:
    - DeprecationHelper
    - MWDebug
  - MediaWiki\Deferred:
    - RefreshSecondaryDataUpdate
  - MediaWiki\FileBackend:
    - FileBackendGroup – FIXME: Should this be in Wikimedia\FileBackend instead?
  - MediaWiki\Json:
    - FormatJson
  - MediaWiki\Language:
    - Language
    - LanguageCode
    - ILanguageConverter
    - LanguageConverter
    - ConverterRule
    - ReplacementArray
  - MediaWiki\Maintenance:
    - BackupDumper
    - Benchmarker
    - DeleteLocalPasswords
    - FakeMaintenance
    - LoggedUpdateMaintenance
    - MWDoxygenFilter
    - Maintenance
    - SchemaMaintenance
    - SevenZipStream
    - TextPassDumper
  - MediaWiki\Parser:
    - BlockLevelPass
    - CacheTime
    - CoreMagicVariables
    - CoreParserFunctions
    - CoreTagHooks
    - DateFormatter
    - DateFormatterFactory
    - LinkHolderArray
    - MWTidy
    - PPCustomFrame_Hash
    - PPDPart_Hash
    - PPDStackElement_Hash
    - PPDStack_Hash
    - PPFrame
    - PPFrame_Hash
    - PPNode
    - PPNode_Hash_Array
    - PPNode_Hash_Attr
    - PPNode_Hash_Text
    - PPNode_Hash_Tree
    - PPTemplateFrame_Hash
    - ParserCache
    - ParserFactory
    - ParserOptions
    - Preprocessor
    - Preprocessor_Hash
    - StripState
  - MediaWiki\RCFeed:
    - FormattedRCFeed
    - IRCColourfulRCFeedFormatter
    - JSONRCFeedFormatter
    - MachineReadableRCFeedFormatter
    - RCFeed
    - RCFeedFormatter
    - RedisPubSubFeedEngine
    - UDPRCFeedEngine
    - XMLRCFeedFormatter
  - MediaWiki\RenameUser:
    - RenameUserJob
  - MediaWiki\Registration:
    - ExtensionDependencyError
    - ExtensionJsonValidationError
    - ExtensionJsonValidator
    - ExtensionProcessor
    - ExtensionRegistry
    - MissingExtensionException
    - Processor
    - VersionChecker
  - MediaWiki\RevisionList:
    - RevisionItem
    - RevisionItemBase
    - RevisionList
    - RevisionListBase
  - MediaWiki\Watchlist:
    - ActivityUpdateJob
    - ClearUserWatchlistJob
    - ClearWatchlistNotificationsJob
    - NoWriteWatchedItemStore
    - WatchedItem
    - WatchedItemQueryService
    - WatchedItemQueryServiceExtension
    - WatchedItemStore
    - WatchedItemStoreInterface
    - WatchlistExpiryJob
  - MediaWiki\Xml:
    - Xml
    - XmlSelect
  - Wikimedia\FileBackend:
    - FSFileBackend
    - FSFileBackendDirList
    - FSFileBackendFileList
    - FSFileBackendList
    - FileBackend
    - FileBackendError
    - FileBackendMultiWrite
    - FileBackendStore
    - FileBackendStoreShardDirIterator
    - FileBackendStoreShardFileIterator
    - FileBackendStoreShardListIterator
    - FileOpBatch
    - HTTPFileStreamer
    - MemoryFileBackend
    - SwiftFileBackend
    - SwiftFileBackendDirList
    - SwiftFileBackendFileList
    - SwiftFileBackendList
    - Wikimedia\FileBackend\FileOps:
      - CopyFileOp
      - CreateFileOp
      - DeleteFileOp
      - DescribeFileOp
      - FileOp
      - FileStatePredicates
      - MoveFileOp
      - NullFileOp
      - StoreFileOp
    - Wikimedia\FileBackend\FileOpHandle:
      - FSFileOpHandle
      - SwiftFileOpHandle
      - FileBackendStoreOpHandle
    - Wikimedia\FileBackend\FSFile:
      - FSFile
      - TempFSFile
      - TempFSFileFactory
  - Wikimedia\Http:
    - MultiHttpClient
  - Wikimedia\Message:
    - MessageSpecifier
  - Wikimedia\Mime:
    - MSCompoundFileReader
    - MimeAnalyzer
    - XmlTypeCheck
  - Wikimedia\ObjectCache:
    - APCUBagOStuff
    - BagOStuff
    - CachedBagOStuff
    - EmptyBagOStuff
    - HashBagOStuff
    - IStoreKeyEncoder
    - MediumSpecificBagOStuff
    - MemcachedBagOStuff
    - MemcachedPeclBagOStuff
    - MemcachedPhpBagOStuff
    - MultiWriteBagOStuff
    - RESTBagOStuff
    - RedisBagOStuff
    - WANObjectCache
    - WinCacheBagOStuff
    - RedisConnectionPool
    - RedisConnRef
  - Wikimedia\Rdbms:
    - DBAccessObjectUtils
    - IDBAccessObject
  - Wikimedia\Stats:
    - BufferingStatsdDataFactory
    - IBufferingStatsdDataFactory
    - NullStatsdDataFactory
    - PrefixingStatsdDataFactoryProxy
    - SamplingStatsdClient
    - StatsdAwareInterface
* MessageCache::get() with $language other than Language or null is
  deprecated and emits deprecation warnings. For high-level access,
  use wfMessage() or RequestContext::msg() instead.
* Manually constructing a Language object, deprecated in 1.35, now emits
  deprecation warnings. Use LanguageFactory instead.
* MediaWiki\Languages\Data\Names::$names is deprecated.
* SearchEngineConfig::getConfig() has been deprecated, use DI with
  ServiceOptions to inject the required options.
* ObjectCache::isDatabaseId() and ::getLocalClusterInstance() have been
  deprecated. Use their equivalents in ObjectCacheFactory.
* Using the "post" source in parameter declarations returned from
  Handler::getParamSettings() is deprecated, use "body" instead.
* ISQLPlatform::tableNamesN() is now deprecated.
* The implementation in SQLPlatform of ISQLPlatform::tableNames(), deprecated in
  MediaWiki 1.39, now emits deprecation warnings.
* Title::getTitleProtection(), deprecated in 1.37, now emits warnings. You can
  use RestrictionStore::getCreateProtection() instead.
* Title::loadRestrictions(), deprecated in 1.37, now emits warnings.
* Title::flushRestrictions(), deprecated in 1.37, now emits warnings.
* Title::getPageViewLanguage(), deprecated in 1.42, now emits warnings.
* wfUrlProtocols(), deprecated in 1.39, now emits warnings.
* wfGetServerUrl(), deprecated in 1.39, now emits warnings.
* wfExpandIRI(), deprecated in 1.39, now emits warnings.
* The following methods, previously deprecated, now emit deprecation warnings:
  - ContentHandler::getDefaultModelFor(), deprecated since 1.33
  - ContentHandler::getAllContentFormats(), deprecated since 1.35
  - ContentHandler::getContentModels(), deprecated since 1.35
  - ContentHandler::getForContent(), deprecated since 1.35
  - ContentHandler::getForModelID(), deprecated since 1.35
  - ContentHandler::getContentText(), deprecated since 1.37
* Passing a Message argument to OutputPage::setPageTitle(), which was
  deprecated in 1.41, now emits warnings.
* OutputPage::showFatalError() is deprecated, use showErrorPage() instead.
* OutputPage::showPermissionsErrorPage() is deprecated,
  use showPermissionStatus() instead.
* OutputPage::formatPermissionsErrorMessage(), deprecated since 1.36,
  now emits deprecation warnings. Use formatPermissionStatus() instead.
* OutputPage::setCategoryLinks() has been deprecated and emits deprecation
  warnings.  Use ::addCategoryLinks() instead.
* OutputPage::setLanguageLinks() has been deprecated; use ::addLanguageLinks()
  instead.
* Passing 'index' to OutputPage::setIndexPolicy() and
  OutputPage::setRobotPolicy() after previously passing 'noindex' has
  been deprecated; in a future release OutputPage will behave like
  ParserOutput::setIndexPolicy(), where 'noindex' takes precedence
  over 'index'.
* (T375975) Language::embedBidi() has been deprecated; use <bdi> HTML tag
  instead.
* (T375975) Language::getDirMark() has been deprecated; use <bdi> HTML tag
  instead.
* (T375975) Language::getDirMarkEntity() has been hard deprecated; use
  <bdi> HTML tag instead.
* (T375975) The unused third parameter of Language::specialList is removed as
  the method isolates the title unconditionally from the details.
* LoadBalancer::getConnectionRef(), deprecated since 1.39, now emits deprecation
  warnings. Use ::getConnection() instead.
* DBAccessObjectUtils::getDBOptions() is deprecated, use
  SelectQueryBuilder::recency() instead.
* IDatabase::lockForUpdate is deprecated, use
  SelectQueryBuilder::acquireRowLocks instead.
* ILBFactory::flushReplicaSnapshots() is deprecated no longer needed.
* wfGetUrlUtils() is deprecated; instead, get a UrlUtils from services.
* DerivedPageDataUpdater::getPreparedEdit(), provided for back-compatibility, is
  now deprecated; use the getters directly, instead.
* AuthManager::forcePrimaryAuthenticationProviders(), provided for back-
  compatibility, is now deprecated.
* WikiPage::hasDifferencesOutsideMainSlot(), provided as a stop-gap before
  refactoring to support MCR, is now deprecated.
* ChangesList::getTimestamp() has been deprecated; use ::revDateLink() instead.
* RecentChange::doMarkPatrolled() is deprecated, use
  RecentChange::markPatrolled() instead.
* LogFormatter::newFromRow() and LogFormatter::newFromEntry(), deprecated since
  1.42, now emit deprecation warnings.
* LinksUpdate::getAddedLinks(), ::getRemovedLinks(), deprecated since 1.38, now
  emit deprecation warnings.
* TitleLinksTable::getTitleArray(), deprecated since 1.38, now emits deprecation
  warnings.
* SiteConfig::variants() has been deprecated; use ::variantsFor().
* ObjectCache::$instances and ::getInstance() have been deprecated; instead, use
  ObjectCacheFactory::getInstance().
* WANObjectCache::clearLastError() and BagOStuff::clearLastError have been hard
  deprecated, use ::watchErrors() together with ::getLastErrors() instead.
* BagOStuff::getSegmentationSize() and ::getSegmentedValueMaxSize() no longer
  have any usage. The subclass' method in MediumSpecificBagOStuff overrides also
  have no usage as well.
* ApiBase::errorArrayToStatus() is deprecated with no replacement.
* ApiTestCase::setExpectedApiException() has been deprecated; instead, use
  ::expectApiErrorCode() to test error codes instead of messages.
* ApiPageSet::getTitles(), ApiPageSet::getGoodTitles(),
  ApiPageSet::getMissingTitles(), ApiPageSet::getGoodAndMissingTitles(),
  ApiPageSet::getRedirectTitles() and ApiPageSet::getSpecialTitles, deprecated
  since 1.37, now emit deprecation warnings.
* QueryPage::setDBLoadBalancer() and ::getDBLoadBalancer() have been deprecated,
  use QueryPage::setDatabaseProvider() or ::getDatabaseProvider() instead.
* User::isBlockedGlobally(), deprecated since 1.40, now emits deprecation
  warnings.
* User::isBlockedFromEmailuser() and User::canSendEmail(), deprecated since
  1.41, now emit deprecation warnings.
* wfMergeErrorArrays() has been deprecated.
* wfArrayDiff2() has been deprecated.
* User::whoIs() and User::whoIsReal(), have been deprecated.
* UserCache class and MediaWikiServices::getUserCache(), have been deprecated.
* JsonUnserializable and related classes have been renamed to JsonDeserializable
  to make it clearer that they're related to converting serialized content back
  into JSON, rather than stating that things are not representable in JSON. The
  previous class names have been left behind as deprecated aliases:
   - JsonUnserializable -> JsonDeserializable
   - JsonUnserializableTrait -> JsonDeserializableTrait
   - JsonUnserializer -> JsonDeserializer
  Additionally, JsonCodec's unserialize() and unserializeArray() methods have
  also been renamed to deserialize() and deserializeArray(), with the old names
  deprecated.
* In the REST framework, the the BodyValidator interface and all functionality
  related to it are deprecated. They have been replaced by
  Handler::getBodyParamSettings() and Handler::parseBodyData(). The following
  interfaces, classes, and methods are affected:
  - interface BodyValidator
  - class JsonBodyValidator
  - class NullValidator
  - function Handler::getBodyValidator
  - function Validator::validateBody
* StatusValue will emit deprecation warnings when an error is given as
  a MessageSpecifier combined with a parameters array, which is usually
  a mistake, as the parameters have always been ignored.
* In StatusValue::replaceMessage(), ::hasMessage() and ::hasMessagesExcept()
  passing MessageSpecifier or MessageValue as $source has been deprecated.
* PageArchive::undeleteAsUser, deprecated since 1.35, now emits deprecation
  warnings.
* DatabaseBlock::getQueryInfo() and DatabaseBlock::getRangeCond() are
  deprecated and emit deprecation warnings. Use the equivalent methods in
  DatabaseBlockStore.
* DatabaseBlockStore::getReadStage() and ::getWriteStage() are deprecated.
  Use the new schema unconditionally.
* UserOptionsManager::resetOptions(), ::listOptionKinds and ::getOptionKinds are
  deprecated and will emit deprecation warnings. Use the corresponding methods
  in PreferencesFactory and UserOptionsManager::resetOptionsByName().
* The `i18n-all-lists-margins` and `interface-message-box` module of SkinModule
  are deprecated. The former has been merged into the `elements` module, the
  latter has no required replacement. See JavaScript console for instructions.
* ParsoidOutputAccess and all of its methods have been deprecated.  Use
  ParserOutputAccess with ParserOptions::setUseParsoid() instead.
* ParserOutput::addJsConfigVars(), deprecated since 1.38, now emits deprecation
  warnings. Use ParserOutput::setJsConfigVar() instead.
* The following methods of ParserOutput, most of which used to return an
  array by reference, have been deprecated.  Use the
  ParserOutput::getLinkList(...) method with an appropriate link type
  instead:
  * ParserOutput::getFileSearchOptions() - ParserOutputLinkTypes::MEDIA
  * ParserOutput::getImages()            - ParserOutputLinkTypes::MEDIA
  * ParserOutput::getInterwikiLinks()    - ParserOutputLinkTypes::INTERWIKI
  * ParserOutput::getLanguageLinks()     - ParserOutputLinkTypes::LANGUAGE
  * ParserOutput::getLinks()             - ParserOutputLinkTypes::LOCAL
  * ParserOutput::getLinksSpecial()      - ParserOutputLinkTypes::SPECIAL
  * ParserOutput::getTemplates()         - ParserOutputLinkTypes::TEMPLATE
  * ParserOutput::getTemplateIds()       - ParserOutputLinkTypes::TEMPLATE
* ParserOutput::setLanguageLinks(null) now emits deprecation warnings.  Use
  an empty array as an argument, not `null`.
* ParserOutput::setPageProperty() now emits deprecation warnings when called
  with non-string values, which has been deprecated since 1.42.
* Use of the reference to the internal array returned by
  ParserOutput::getExternalLinks() has been deprecated.  In a future release
  it will return a copy of the array.
* To support a future change allowing serializing of MessageValue objects
  as JSON, the methods MessageValue::objectParams(), Message::objectParams()
  and Message::objectParam() are deprecated. The UserGroupMembershipParam
  class and the ParamType::OBJECT constant are likewise deprecated.
* Passing null or boolean values as message parameters, which are converted
  to strings "" and "1", is deprecated.
* The Less mixin .column-break-after-avoid() is deprecated. Use just the
  CSS rule `break-after: avoid-column;` instead now.
* The Less mixins .horizontal-gradient and .vertical-gradient are deprecated.
  Use CSS rule linear-gradient directly.
* The following method are deprecated; instead call the appropriate
  constructor method in PageRestHelperFactory with the appropriate
  initialization arguments:
  * HtmlOutputRendererHelper::init()
  * HtmlMessageOutputHelper::init()
  * HtmlInputTransformHelper::init()
  Similarly, calling the constructor method in PageRestHelperFactory
  without the appropriate initialization arguments is now deprecated.
* Calling HtmlToContentTransform::setMetrics() and
  HtmlInputTransformHelper::setMetrics() with a StatsdDataFactoryInterface
  is deprecated and emits warnings. Pass a StatsFactory instead.
* HTMLForm methods getPreText, setPreText, addPreText, getPostText,
  setPostText, addPostText, getHeaderText, setHeaderText, addHeaderText,
  getFooterText, setFooterText and addFooterText, deprecated since 1.38, now
  emit deprecation warnings.
* FormSpecialPage methods preText and postText, deprecated since 1.38, now
  emit deprecation warnings.
* EditPage::internalAttemptSave() is deprecated as part of cleaning up how
  edits are saved, see T157658 for details.
* The MessageCache::get hook, deprecated since 1.41, now emits deprecation
  warnings.
* Twelve deprecated properties of OutputPage now will emit warnings; their
  relevant getters or setters should be used instead:
  * mCategoryLinks       - getCategoryLinks() and setCategoryLinks()
  * mCategories          - getCategories()
  * mIndicators          - getIndicators() and setIndicators()
  * mHeadItems           - getHeadItemsArray(), hasHeadItem(), addHeadItem(),
                           and addHeadItems()
  * mModules             - getModules() and addModules()
  * mModuleStyles        - getModuleStyles() and addModuleStyles()
  * mJsConfigVars        - getJsConfigVars() and addJsConfigVars()
  * mTemplateIds         - getTemplateIds()
  - mEnableClientCache   - Set with enableClientCache() and disableClientCache()
  - mNewSectionLink      - Get with showNewSectionLink()
  - mHideNewSectionLink  - Set with forceHideNewSectionLink()
  - mNoGallery           - getNoGallery()
* The following methods from the OutputPage class were deprecated; use
  corresponding methods on the ParserOutput returned from
  OutputPage::getMetadata() instead. (For example, instead of
  $output->setIndexPolicy() use $output->getMetadata()->setIndexPolicy().)
   - ::getIndexPolicy()
   - ::setIndexPolicy()  (setting 'index' after 'noindex' is deprecated)
   - ::getPreventClickjacking()
   - ::setPreventClickjacking()
* The hook OutputPageMakeCategoryLinks is deprecated. Use the new hook
  OutputPageRenderCategoryLink instead.
* mw.cookie.getCrossSite() has been deprecated due to the removal of
  $wgUseSameSiteLegacyCookies in MW 1.42. Use mw.cookie.get().
* The 'help' key in HTMLForm descriptors is deprecated. Use the 'help-raw'
  key instead.
* ImageGalleryBase::setWidths() and ::setHeights() will now emit a deprecation
  warning if they are called without ImageGalleryBase::setParser() having been
  called.  Please set the parser appropriately when using the image gallery.
* (T45646) The localisation messages 'copyright' and 'history_copyright' are
  deprecated in favor of 'copyright-footer' and 'copyright-footer-history'.
  The new messages are parsed as wikitext instead of being treated as raw HTML.
* (T45646) The hook 'SkinCopyrightFooter' is deprecated in favor of
  'SkinCopyrightFooterMessage'. The new hook allows specifying copyright
  messages that are parsed as wikitext instead of being treated as raw HTML.
* (T374314) The 'mw.Uri' module has been deprecated in favour of the browser-
  native URL interface, which is now provided in all supported user agents. For
  details, see <https://developer.mozilla.org/en-US/docs/Web/API/URL>.
* The parameter $default in WebRequest::getRawVal() is deprecated. Use ??
  instead.
* SpecialBlock::processForm(), SpecialBlock::parseExpiryInput() and
  SpecialBlock::canBlockEmail(), deprecated since 1.36, and
  SpecialBlock::getSuggestedDurations(), deprecated since 1.42, now emit
  deprecation warnings.
* The following soft deprecated Skin methods will now emit warnings:
  - Skin::makeSpecialUrl (use SkinComponentUtils::makeSpecialUrl instead)
  - Skin::makeSpecialUrlSubpage (use SkinComponentUtils::makeSpecialUrlSubpage
    instead)
* The SkinFactory::getSkinNames deprecated in 1.37 now emits warnings,
   use getInstalledSkins instead.

=== Other changes in 1.43 ===

* Class aliases to support the old PHPUnit 4 style un-namespaced `PHPUnit_`
  classes (such as PHPUnit_Framework_Error) have been removed.
* [Temporary accounts] If $wgAutoCreateTempUser is enabled, then MediaWiki
  will create a temporary account and log the user in for unsuccessful edit
  attempts and null edits, in addition to edits that change content. This is
  a change from the previous paradigm, where temporary accounts were created
  only for successful edits. This change is done to support better logging
  support and moderation, to ensure that hooks run in a pre-save context have
  a user object to associate log entries and other actions with.
* Several entries have been removed from the default list of interwikis used
  when installing new wikis. This does not affect existing wikis.
* User auto-creations are now performed as the target user instead of
  anonymous IP user.
* [Temporary accounts] T359043 Temporary accounts for anonymous edits are
  enabled in DevelopmentSettings.php. To disable the feature, set
  `$wgAutoCreateTempUser['enabled'] = false;` in LocalSettings.php
* Corrected the interpretation of empty arrays in extension configuration when
  the default value is null. Previously, an empty array specified by the
  administrator would transform into the default null value. It now
  appropriately retains its empty array state.
* (T362536) Exempted "deletedhistory", "deletedtext", and "viewsuppressed"
  rights from namespace protection ($wgNamespaceProtection) since that's
  only meant to prevent write actions.
* Image captions are no longer trimmed.
* 'SpecialPasswordResetOnSubmit' hook handlers can now receive both the
  username and the email provided by the user, instead of only one of them.
* (T231827, T249976) Searchindex now uses utf8mb4,
  si_page is marked as PK and si_title can handle longer title values.

== Compatibility ==

MediaWiki 1.43 requires PHP 8.1.0 or later and the following PHP extensions:

* ctype
* dom
* fileinfo
* iconv
* intl
* json
* mbstring
* openssl
* xml

MariaDB is the recommended database software. MySQL, PostgreSQL, or SQLite can
be used instead, but support for them is somewhat less mature.

The supported versions are:

* MariaDB 10.3 or higher
* MySQL 5.7.0 or higher
* PostgreSQL 10 or later
* SQLite 3.8.0 or later

== Online documentation ==
Documentation for both end-users and site administrators is available on
MediaWiki.org, and is covered under the GNU Free Documentation License (except
for pages that explicitly state that their contents are in the public domain):

  <https://www.mediawiki.org/wiki/Special:MyLanguage/Documentation>

== Mailing list ==
A mailing list is available for MediaWiki user support and discussion:

  <https://lists.wikimedia.org/postorius/lists/mediawiki-l.lists.wikimedia.org/>

A low-traffic announcements-only list is also available:

  <https://lists.wikimedia.org/postorius/lists/mediawiki-announce.lists.wikimedia.org/>

It's highly recommended that you sign up for one of these lists if you're
going to run a public MediaWiki, so you can be notified of security fixes.

== IRC help ==
There's usually someone online in #mediawiki on irc.libera.chat.


= MediaWiki 1.42 =

PHP 8.1 workboard: https://phabricator.wikimedia.org/tag/php_8.1_support/
PHP 8.2 workboard: https://phabricator.wikimedia.org/tag/php_8.2_support/
PHP 8.3 workboard: https://phabricator.wikimedia.org/tag/php_8.3_support/

== MediaWiki 1.42.3 ==

This is a maintenance release of the MediaWiki 1.42 branch.

=== Changes since MediaWiki 1.42.2 ===
* Fix issue related to backport of AbuseFilter patch for T372998.

== MediaWiki 1.42.2 ==

This is a security and maintenance release of the MediaWiki 1.42 branch.

=== Changes since MediaWiki 1.42.1 ===
* Localisation updates.
* Parser: Deprecate use of mOutput before initialization.
* (T365565) PrefixSearch: Make sure $prefix is a string.
* Clarify that $wgAllowCrossOrigin only applies to REST.
* composer.json: Add 5 more ext- to suggests.
* resources: Fix 404 Not Found for foreign Financial-Times/polyfill-library.
* ResourceLoader: Upgrade wikimedia/less.php to 4.4.1.
* SpecialExport: Prevent passing null to strtolower.

Additionally, some language support improvements which went out in 1.42.0 were
not noted; they are included here for completeness:

* (T343865) Added language support for Pu–Xian Min (Simplified Han script)
  (cpx-hans).
* (T343865) Added language support for Pu–Xian Min (Traditional Han script)
  (cpx-hant).
* (T284043) Added language support for Manchu (mnc).
* (T284043) Added language support for Manchu (Mongolian script) (mnc-mong).
* Added language converter for Central Moroccan Tamazigh (zgh).

== MediaWiki 1.42.1 ==

This is a maintenance release of the MediaWiki 1.42 branch.

=== Changes since MediaWiki 1.42.0 ===
* Localisation updates.
* Name the PagerTools array entries to allow hooks to unset them.

== MediaWiki 1.42.0 ==

=== Changes since MediaWiki 1.42.0-rc.0 ===
* Localisation updates.
* wrapOldPasswords: Improve progress output and decrease batch size.
* (T365060) Serialization test cases: fix filename after ParserOutput
  namespacing.
* Use virtual domain when running update maintenance scripts.
* (T361367) ApiFeedWatchlist: Fix handling of array parameters.
* (T366130) EncryptedPassword: Store default parameters as strings.

== MediaWiki 1.42.0-rc.0 ==

== Upgrading notes for 1.42 ==
Don't forget to always back up your database before upgrading!

See the file UPGRADE for more detailed per-version upgrade instructions from the
oldest supported upgrading version, MediaWiki 1.35.

Some specific notes for MediaWiki 1.42 upgrades are below:
* MediaWiki 1.42 requires PHP 8.1 or above (up from 7.4) (T359868).
* MediaWiki now requires Composer 2.x, and any related (vendor) files generated
  by Composer must be generated by Composer 2.x. Composer 1.x is mostly end of
  life by upstream, and using it will result in slower actions when downloading
  and installing packages. See the upstream blog post at
  https://blog.packagist.com/deprecating-composer-1-support/ for further
  information.

For notes on 1.41.x and older releases, see HISTORY.

=== Configuration changes for system administrators in 1.42 ===
* Composer 1.x is no longer supported, and can no longer be used with MediaWiki.

==== New configuration ====
* $wgMicroStashType: This setting allows for control of the object cache backend
  for the MicroStash service.
* $wgEditRecoveryExpiry: This setting sets the number of seconds for which to
  keep edit recovery data after each edit is stored.
* $wgDjvuUseBoxedCommand and $wgDjvuShell: The first is a temporary flag to
  control whether or not to use BoxedCommand when wrapping DejaVu rendering, and
  the second sets the command to call if so.
* $wgConditionalUserOptions: This setting makes it possible to define which user
  properties have defaults varying by user, without growing the user_properties
  table. The typical use-case is to enable a feature only for users created
  after a certain date when rolling out features on large wiki farms.
* $wgGrantRiskGroups: This setting controls the risk levels for each grant, used
  to indicate on various UIs which grants should be considered risky. (T290790)
* $wgTempAccountCreationThrottle: This setting is like AccountCreationThrottle,
  but to be used for managing temporary account creations.

==== Changed configuration ====
* $wgAutoCreateTempUser: This setting (in active development), which configures
  automatic 'temporary' user creation on page save, has had two changes:
  - it now supports multiple match patterns on the 'matchPattern' key; and
  - it now uses a different format for deciding how to label temporary accounts;
    if your wiki used temporary accounts before 1.42, you will need to override
    the configuration value to also match the old format of *$1.
* $wgLogActionsHandlers: This setting, which configures handlers for different
  log actions, is now ObjectFactory compatible.
* $wgBotPasswordsCluster and $wgBotPasswordsDatabase: These settings have been
  deprecated; use $wgVirtualDomainsMapping['virtual-botpasswords'] instead.
* $wgMainPageIsDomainRoot: This setting is no longer considered experimental.

==== Removed configuration ====
* $wgDisableCookieCheck: Removed without deprecation.
* $wgStatsCacheType: Removed without deprecation. Set $wgMicroStashType instead.
* $wgJobSerialCommitThreshold: Removed without deprecation. Any setups using
  this config will perform just fine, but might be less performant.
* $wgLogoHD: Deprecated since 1.35. Use $wgLogo instead.
* $wgContentHandlerTextFallback: Deprecated since 1.37. No longer customizable.
* $wgSquidPurgeUseHostHeader: Deprecated since 1.33. No longer customizable, and
  always true.
* $wgAllowImageTag: Deprecated since 1.35. Instead, you can register an
  extension tag named <img>.
* $wgMinimalPasswordLength and $wgMaximalPasswordLength: Deprecated since 1.26.
  Use $wgPasswordPolicy instead.
* $wgUseMediaWikiUIEverywhere: Experimental, removed without deprecation.
* $wgHTMLFormAllowTableFormat: Experimental, removed without deprecation.
* $wgOpenSearchTemplate: Deprecated since 1.25. Instead, you can use
  $wgOpenSearchTemplates['application/x-suggestions+json'].
* $wgUseSameSiteLegacyCookies: Removed without deprecation.

=== New user-facing features in 1.42 ===
* (T308160) filter: is now allowed in inline CSS in wikitext

=== New developer features in 1.42 ===
* (T326466) MediaWikiIntegrationTestCase's database and set-up code now avoids
  using dynamic properties, which was causing deprecation warnings in PHP 8.2.
* (T13555) MediaWiki now includes styles that allow more accessible markup for
  section headings. MediaWiki's own HTML output will be changed in the future.
  More information: https://www.mediawiki.org/wiki/Heading_HTML_changes
* (T193472) PHP Notice and Warning errors that are silenced (e.g. by the "@"
  operator, error_reporting directive, or Wikimedia\AtEase) are now logged to
  a new "silenced-error" channel.
* (T347347) The CLI installer accepts a "--with-developmentsettings" argument
  to require the DevelopmentSettings.php file at install time.
* (T350054) MediaWiki's ResourceLoader has been updated to add basic support
  for code-splitting (aka "tree-shaking") when using the Codex component
  library. A ResourceLoader module can now specify a list of "codexComponents"
  in its module defintion and ensure that only the code for those components
  gets sent to the client. More information:
  https://www.mediawiki.org/wiki/Codex#Subset_of_components
* (T345185) The SessionProviderInterface now allows defining providers that
  are exempt from rights checks when auto creating users.

=== External library changes in 1.42 ===

==== New external libraries ====
* Added mediawiki/json-codec at v2.2.1.
* Added mck89/peast at v1.16.2.

==== Changed external libraries ====
* Updated OOUI from v0.48.1 to v0.49.1.
* Updated OOjs Router from 0.3.0 to 0.5.0.
* Updated codex, codex-design-tokens and codex-icons
  from v1.0.0 to v1.3.6.
* Updated Vue from v3.2.37-compat to v3.3.9.
* Updated composer/semver from 3.3.2 to 3.4.0.
* Updated guzzlehttp/guzzle from 7.5.3 to 7.7.1.
* Updated monolog/monolog from 2.2.0 to 2.9.2.
* Updated pear/mail from 1.5.1 to 1.6.0.
* Updated pear/mail_mime from 1.10.11 to 1.10.12.
* Updated pear/net_smtp from 1.10.1 to 1.11.1.
* Updated psr/http-message from 1.0.1 to 1.1.
* Updated symfony/polyfill-php80 from 1.28.0 to 1.29.0.
* Updated symfony/polyfill-php81 from 1.28.0 to 1.29.0.
* Updated symfony/polyfill-php82 from 1.28.0 to 1.29.0.
* Updated symfony/polyfill-php83 from 1.28.0 to 1.29.0.
* Updated symfony/yaml from 5.4.23 to 5.4.35.
* Updated wikimedia/less.php from 4.1.1 to 4.2.1.
* Updated wikimedia/minify from 2.5.1 to 2.7.0.
* Updated wikimedia/relpath from 3.0.0 to 4.0.0.
* Updated wikimedia/remex-html from 4.0.1 to 4.1.0.
* Updated wikimedia/shellbox from 4.0.0 to 4.0.1.

===== Changed development-only external libraries =====
* Updated QUnit from v2.19.4 to v2.20.0.
* Updated composer/spdx-licenses from 1.5.7 to 1.5.8.
* Updated doctrine/dbal from 3.4.2 to 3.7.2.
* Updated doctrine/sql-formatter from 1.1.1 to 1.1.3.
* Updated grunt-banana-checker from 0.11.0 to 0.11.1.
* Updated mediawiki/mediawiki-codesniffer from 42.0.0 to 43.0.0.
* Updated mediawiki/mediawiki-phan-config from 0.13.0 to 0.14.0.
* Updated php-parallel-lint/php-parallel-lint from 1.3.2 to 1.4.0.
* Updated phpunit/phpunit from 9.5.28 to 9.6.16.
* Updated psy/psysh from ^0.11.1 to ^0.12.3.
* Updated seld/jsonlint from 1.8.3 to 1.10.1.
* Updated wikimedia/testing-access-wrapper from 2.0.0 to 3.0.0.

=== Action API changes in 1.42 ===
* APIQueryTags now includes "software" in the "source" array for software
  generated tags. Reliance on the "extension" entries in this array is now
  deprecated, but they will remain for backwards compatibility.

=== Languages updated in 1.42 ===
MediaWiki supports over 350 languages. Many localisations are updated regularly.
Below only new and removed languages are listed, as well as changes to languages
because of Phabricator reports.

* (T268143) Language variant conversion has been removed for Kazakh.
* (T352776) Updated autonym spelling for the Mon language (mnw).
* (T351874) Added language support for Komering (kge).
* (T351992) Added language support for Efik (efi).
* (T352954) Added language support for Rutul (rut).
* (T353058) Added language support for Arbëresh (aae).
* (T353307) Added language support for Guadeloupean Creole (gcf).
* (T353500) Added language support for Southeastern Kolami (nit).
* (T354519) Added language support for Tooro (ttj).
* (T354926) Added language support for Nyoro (nyo).
* (T356616) Added language support for Chinook Jargon (chn).
* (T357879) Added language support for Ibibio (ibb).

=== Breaking changes in 1.42 ===
* (T340802) ResourceLoader: The targets system is no longer active; all modules
  will load on all platforms even if they are marked as desktop- or mobile-only
  in the 'targets' field, which is no longer read. As part of this, the internal
  methods RL\Module::setTarget() & ::getTargets(), and OutputPage::setTarget(),
  have been removed.
* TitleArray, deprecated since 1.41, has been removed.
* UserRightsProxy, deprecated since 1.38, has been removed.
* SiteConfiguration::getConfig(), deprecated in 1.41, has been removed.
* UserLoginCompleteHook is always called with its $direct parameter set to
  boolean true. The false case has been removed.
* MagicWord::load() has been marked @internal, and may change in the future
  without further notice.
* All classes that implemented the IDBAccessObject interface and all interfaces
  that extended it, no longer do that. See https://w.wiki/9DAX for more info.
* The type of the last parameter of BeforeInitializeHook::onBeforeInitialize()
  and MediaWikiPerformActionHook::onMediaWikiPerformAction() changed from the
  MediaWiki class to the new ActionEntryPoint. Relevant methods are still
  available on the object.
* Classes that override Maintenance::finalSetup() must now declare the $settings
  parameter and pass it on when calling the parent implementation.
  MaintenanceRunner will always provide this parameter when calling
  finalSetup().
* WebResponse::disableForPostSend() is no longer static.
* MediaWiki's virtualrest internal library has been removed, in favor of just
  using other HTTP libraries: Guzzle, MultiHttpClient or MwHttpRequest.
* Several deprecated methods have been removed from the Content interface,
  in favor of the respective methods in ContentHandlers. Callers should
  use a more narrow interface like ContentRenderer or ContentTransformer
  when possible. The following methods have been removed from Content:
  - getParserOutput()
  - preSaveTransform()
  - preloadTransform()
  - prepareSave()
* User::blockedFor() and AbstractBlock::getReason(), deprecated in 1.35, have
  been removed. Use AbstractBlock::getReasonComment() instead.
* SerializedValueContainer::newUnified(), deprecated in 1.41 has been removed.
* Use of ActorMigration for any of the following tables, deprecated since 1.34,
  is no longer supported:
  - archive
  - image
  - oldimage
  - filearchive
  - recentchanges
  - logging
  - ipblocks
* ParserOutput::setFlag() and ::getFlag(), deprecated in 1.38, were removed. You
  should use ::setOutputFlag() and ::getOutputFlag() instead.
* ParserOutput::getCategories(), deprecated in 1.40, has been removed. You
  should use ::getCategoryNames() and ::getCategorySortKey() instead.
* ParserOutput::getTOCHTML(), deprecated in 1.40, has been removed. You should
  use ::getTOCData() instead.
* The parser does not substitute the default category sort key at parse time;
  this is substituted when the category links table is updated instead. As a
  result {{DEFAULTSORT}} will affect all the contents of the page (not just
  categories added after the location of {{DEFAULTSORT}} in the article) and
  ParserOutput::getCategorySortKey() will return the empty string (still
  meaning "use the default sort key") instead of the immediate value of
  {{DEFAULTSORT}}. ParserOutput::getCategorySortKey() will directly reflect the
  category link contents, instead of having post-processing done to it
  (character references decoded, new lines replaced, language conversion). That
  post-processing is now done when the category links table is updated, and so
  it consistently applies even when categories are added directly via API.
* PostgresUpdater::addPgEnumValue() unused everywhere, have been removed
  without deprecation. Use of ENUM is highly discouraged.
* ILoadBalancer::getAnyOpenConnection() has been removed without deprecation,
  use ::getConnection() instead.
* The unused method CommentStore::getFields() has been removed without
  depreaction.
* LanguageConverter's internal properties, all deprecated in 1.35 or 1.36, have
  now had their deprecated property accessors dropped:
  - mConvRuleTitle
  - mUserVariant
  - mHeaderVariant
  - mMaxDepth
  - mVarSeparatorPattern
  - mLangObj
  - mTablesLoaded
  - mTables
  - mVariants
  - mMainLanguageCode
  - mVariantFallbacks
  - mFlags
  - mVariantNames
  - mDescCodeSep
  - mDescVarSep
* OutputPage::addParserOutputText has been marked @internal since there are no
  known users of it. Its old behavior has been deprecated and will change
  in the future without further notice.
* A some methods of ConnectionManager and SessionConsistentConnectionManager,
  previously deprecated, have been removed:
  - ::releaseConnection(), deprecated in 1.38; do not use
  - ::getWriteConnectionRef(), deprecated in 1.39; use getWriteConnection()
  - ::getReadConnectionRef(), deprecated in 1.38; use getReadConnection()
  - ::getLazyWriteConnectionRef(), deprecated in 1.39; use getWriteConnection()
  - ::getLazyReadConnectionRef(), deprecated in 1.38; use getReadConnection()
* CoreParserFunctions::mwnamespace(), deprecated in 1.39, has been removed. Use
  CoreParserFunctions::namespace() instead.
* Processor:: and ExtensionProcessor::getExtraAutoloaderPaths(), deprecated in
  1.39, have been removed; use ::getExtractedAutoloadInfo() instead.
* MWExceptionHandler::rollbackMasterChangesAndLog(), deprecated in 1.37, has
  been removed. Use ::rollbackPrimaryChangesAndLog() instead.
* Passing a custom database connection to DatabaseBlockStore::insertBlock(),
  deprecated since 1.41, is no longer supported.
* LanguageConverterFactory::isTitleConversionDisabled(), deprecated in 1.36,
  has been removed. Use ::isLinkConversionDisabled() instead.
* MediaWikiIntegrationTestCase::$tablesUsed has been deprecated. The framework
  now detects these automatically.
* Passing an actor id to the constructor of UserIdentityValue, deprecated
  since 1.36, is no longer being supported.
* Support for setting dynamic property on StatusValue object has been removed.
  To pass your arbitrary data along the object, use StatusValue::statusData
  property (which is always declared).
* The global function wfReportTime(), deprecated since 1.40, has been removed.
* The skin template parameter 'reporttime', deprecated since 1.41, has been
  removed.
* WikiPage::getPageIsRedirectField(), deprecated since 1.41, has been removed.
* WikiPage::insertRedirect(), deprecated since 1.41, has been removed.
* Several methods in PageArchive, all deprecated in 1.38, have been removed:
  - ::listRevisions()
  - ::getRevisionRecordByTimestamp()
  - ::getArchivedRevisionRecord()
  - ::getPreviousRevisionRecord()
  - ::getLastRevisionId()
  - ::isDeleted()
  - ::getFileStatus()
  - ::getRevisionStatus()
* Database, DatabaseInstaller, DatabaseUpdater, DBPrimaryPos, ResultWrapper and
  SQLPlatform are no longer stable to extend. It is not possible to define
  database types in an extension.
* UserDef::PARAM_ALLOWED_USER_TYPES now differentiates between temporary account
  usernames and user accounts. Any endpoints that want temp users to be
  valid but were passing a name through will break. Temp users must now be
  explicitly allowed.
* The Hooks class, a legacy wrapper for HooksContainer, has been removed. All of
  its contents have been previously deprecated in 1.35 (or 1.41 for ::runner()):
  - ::register()
  - ::clear(),
  - ::isRegistered()
  - ::getHandlers()
  - ::run()
  - ::runWithoutAbort()
  - ::runner()
* Article::__get(), ::__set(), deprecated since 1.35, have been removed.
* Several API calls have been updated to return a 'temp' user flag:
  - ApiQueryImageInfo
  - ApiQueryLogEvents
  - ApiQueryRecentChanges
  - APIs extended from ApiQueryRevisionsBase
* Parser::getCustomDefaultSort() and ::setDefaultSort(), deprecated since 1.38,
  have been removed.
* UserOptionsLookup::getDefaultOptions() and ::getDefaultOption() now accept a
  UserIdentity, to take conditional defaults for user properties into account.
  When run on a wiki where conditional defaults are used, calling those methods
  without the UserIdentity might produce unexpected results.
* Installer-related classes have been namespaced without having aliases added.
  The following have been moved to MediaWiki\Installer:
  - CliInstaller
  - DatabaseInstaller
  - InstallDocFormatter
  - Installer
  - InstallerOverrides
  - InstallerSessionProvider
  - LocalSettingsGenerator
  - MysqlInstaller
  - PostgresInstaller
  - PostgresUpdater
  - SqliteInstaller
  - SqliteUpdater
  - WebInstaller
  - WebInstallerComplete
  - WebInstallerCopying
  - WebInstallerDBConnect
  - WebInstallerDBSettings
  - WebInstallerDocument
  - WebInstallerExistingWikis
  - WebInstallerInstall
  - WebInstallerLanguage
  - WebInstallerName
  - WebInstallerOptions
  - WebInstallerOutput
  - WebInstallerPage
  - WebInstallerReleaseNotes
  - WebInstallerRestart
  - WebInstallerUpgrade
  - WebInstallerUpgradeDoc
  - WebInstallerWelcome
* The file mediawiki.ui/variables.less, deprecated since 1.41, has been
  removed in favor of mediawiki.skin.variables.less.
* The file mediawiki.ui/utilities.less, with its three layout CSS classes, has
  been removed.
* The module `jquery.cookie` (deprecated as of 1.41) has been removed. Please
  use `mediawiki.cookie` instead
* The no-op module `es6-polyfills` (deprecated as of 1.41) has been removed.
* Log formatters (as defined in $wgLogActionsHandlers) are now created by
  ObjectFactory, which means their constructors must be public. Legacy log
  formatters using callbacks instead of class names are no longer supported.
* The old aliases for the namespaced ResourceLoader classes, deprecated since
  they were moved in MediaWiki 1.39, have now been dropped:
  - ResourceLoader – use MediaWiki\ResourceLoader\ResourceLoader
  - ResourceLoaderCircularDependencyError
    – use MediaWiki\ResourceLoader\CircularDependencyError
  - ResourceLoaderClientHtml – use MediaWiki\ResourceLoader\ClientHtml
  - ResourceLoaderCodexModule – use MediaWiki\ResourceLoader\CodexModule
  - ResourceLoaderContext – use MediaWiki\ResourceLoader\Context
  - ResourceLoaderFileModule – use MediaWiki\ResourceLoader\FileModule
  - ResourceLoaderFilePath – use MediaWiki\ResourceLoader\FilePath
  - ResourceLoaderForeignApiModule
    – use MediaWiki\ResourceLoader\ForeignApiModule
  - ResourceLoaderImage – use MediaWiki\ResourceLoader\Image
  - ResourceLoaderImageModule – use MediaWiki\ResourceLoader\ImageModule
  - ResourceLoaderLessVarFileModule
    – use MediaWiki\ResourceLoader\LessVarFileModule
  - ResourceLoaderModule – use MediaWiki\ResourceLoader\Module
  - ResourceLoaderMwUrlModule – use MediaWiki\ResourceLoader\MwUrlModule
  - ResourceLoaderOOUIFileModule – use MediaWiki\ResourceLoader\OOUIFileModule
  - ResourceLoaderOOUIIconPackModule
    – use MediaWiki\ResourceLoader\OOUIIconPackModule
  - ResourceLoaderOOUIImageModule
    – use MediaWiki\ResourceLoader\OOUIImageModule
  - ResourceLoaderOOUIModule – use MediaWiki\ResourceLoader\OOUIModule
  - ResourceLoaderSiteModule – use MediaWiki\ResourceLoader\SiteModule
  - ResourceLoaderSiteStylesModule
    – use MediaWiki\ResourceLoader\SiteStylesModule
  - ResourceLoaderSkinModule – use MediaWiki\ResourceLoader\SkinModule
  - ResourceLoaderStartUpModule – use MediaWiki\ResourceLoader\StartUpModule
  - ResourceLoaderUserModule – use MediaWiki\ResourceLoader\UserModule
  - ResourceLoaderUserOptionsModule
    – use MediaWiki\ResourceLoader\UserOptionsModule
  - ResourceLoaderUserStylesModule
    – use MediaWiki\ResourceLoader\UserStylesModule
  - ResourceLoaderWikiModule – use MediaWiki\ResourceLoader\WikiModule
  - DerivativeResourceLoaderContext
    – use MediaWiki\ResourceLoader\DerivativeContext
  - MessageBlobStore – use MediaWiki\ResourceLoader\MessageBlobStore
  - VueComponentParser – use MediaWiki\ResourceLoader\VueComponentParser
* (T318989) Skin::lastModified, deprecated since 1.40, has been removed.
* Composer 1.x is no longer supported, and can no longer be used with MediaWiki.
* Title::GAID_FOR_UPDATE, deprecated in 1.34, has been removed. Instead, your
  code should use IDBAccessObject::READ_LATEST.
* Six private Title class members, deprecated in 1.37, are now fully private;
  use their corresponding accessor methods:
   - $mTextform   -> getText()
   - $mUrlform    -> getPartialURL()
   - $mDbkeyform  -> getDBkey()
   - $mNamespace  -> getNamespace()
   - $mInterwiki  -> getInterwiki()
   - $mFragment   -> getFragment()
* Skin::bottomScripts, deprecated since 1.37, has been removed.
* Fallback index and options have been removed from
  DBAccessObjectUtils::getDBOptions() without deprecation.
* The deprecated class aliases for now-namespaced or renamed PHP classes that
  were added in or before 1.39 LTS have now been removed:
   - Blob -> Wikimedia\Rdbms\Blob
   - Block -> MediaWiki\Block\DatabaseBlock
   - DBAccessError -> Wikimedia\Rdbms\DBAccessError
   - DBConnectionError -> Wikimedia\Rdbms\DBConnectionError
   - DBError -> Wikimedia\Rdbms\DBError
   - DBExpectedError -> Wikimedia\Rdbms\DBExpectedError
   - DBQueryError -> Wikimedia\Rdbms\DBQueryError
   - DBReadOnlyError -> Wikimedia\Rdbms\DBReadOnlyError
   - DBReplicationWaitError -> Wikimedia\Rdbms\DBReplicationWaitError
   - DBTransactionError -> Wikimedia\Rdbms\DBTransactionError
   - DBTransactionSizeError -> Wikimedia\Rdbms\DBTransactionSizeError
   - DBUnexpectedError -> Wikimedia\Rdbms\DBUnexpectedError
   - DatabaseMysqlBase -> Wikimedia\Rdbms\DatabaseMySQL
   - DatabaseMysqli -> Wikimedia\Rdbms\DatabaseMySQL
   - EasyDeflate -> Deflate
   - Field -> Wikimedia\Rdbms\Field
   - IMaintainableDatabase -> Wikimedia\Rdbms\IMaintainableDatabase
   - LinksDeletionUpdate -> MediaWiki\Deferred\LinksUpdate\LinksDeletionUpdate
   - LinksUpdate -> MediaWiki\Deferred\LinksUpdate\LinksUpdate
   - LoadBalancer -> Wikimedia\Rdbms\LoadBalancer
   - LoadBalancerSingle -> Wikimedia\Rdbms\LoadBalancerSingle
   - RCFeedEngine -> FormattedRCFeed
   - RandomPage -> MediaWiki\Specials\SpecialRandomPage
* The return value of IDatabase::upsert(), deprecated since 1.33, has been
  removed.
* Instancing MediaWiki\Specials\SpecialRandomPage without injected services has
  been removed.
* SpecialPage::listed() and ::setListed(), deprecated since 1.35, have both been
  removed. Use ::isListed() to read, and over-ride by implementing isListed() or
  by sub-classing UnlistedSpecialPage.
* BlockListPager::getTotalAutoblocks() was removed.

=== Deprecations in 1.42 ===
* (T273239) wfGetDB(), deprecated in 1.39, now emits deprecation warnings. Most
  code can migrate to MediaWikiServices::getInstance()->getConnectionProvider()
  ->getReplicaDatabase() or …->getPrimaryDatabase() as appropriate.
* (T166010) All PHP code in MediaWiki is slowly being moved to be in a class
  namespace as appropriate, so that we can use PSR-4 auto-loading, which will
  speed up general code loading of MediaWiki. The old global namespace class
  names are being left behind as deprecated aliases.
  In this release of MediaWiki, 1868 classes now have a namespace and 821 do
  not yet (69% done, up from 63% in MediaWiki 1.41.0). The following have newly
  been moved:
  - MediaWiki\Cache:
    - BacklinkCache
    - FileCacheBase
    - GenderCache
    - HTMLCacheUpdater (and fix case for consistency with HTMLFileCache)
    - LinkBatch
    - LinkCache
    - UserCache
  - MediaWiki\Context:
    - ContextSource
    - DerivativeContextSource
    - IContextSource
    - MutableContext
    - RequestContext
  - MediaWiki\Deferred:
    - AtomicSectionUpdate
    - AutoCommitUpdate
    - CdnCacheUpdate
    - DataUpdate
    - DeferrableCallback
    - DeferrableUpdate
    - DeferredUpdates
    - DeferredUpdatesScope
    - DeferredUpdatesScopeMediaWikiStack
    - DeferredUpdatesScopeStack
    - EnqueueableDataUpdate
    - HtmlFileCacheUpdate
    - JobQueueEnqueueUpdate
    - MWCallableUpdate
    - MergeableUpdate
    - MessageCacheUpdate
    - SearchUpdate
    - SendPasswordResetEmailUpdate
    - SiteStatsUpdate
    - TransactionRoundAwareUpdate
    - TransactionRoundDefiningUpdate
    - UserEditCountInfo
    - UserEditCountUpdate
  - MediaWiki\HTMLForm:
    - CodexHTMLForm
    - CollapsibleFieldsetLayout
    - HTMLForm
    - HTMLFormActionFieldLayout
    - HTMLFormElement
    - HTMLFormField
    - HTMLFormFieldLayout
    - HTMLFormFieldRequiredOptionsException
    - HTMLNestedFilterable
    - OOUIHTMLForm
    - VFormHTMLForm
    - MediaWiki\HTMLForm\Field:
      - HTMLApiField
      - HTMLAutoCompleteSelectField
      - HTMLButtonField
      - HTMLCheckField
      - HTMLCheckMatrix
      - HTMLComboboxField
      - HTMLDateTimeField
      - HTMLEditTools
      - HTMLExpiryField
      - HTMLFileField
      - HTMLFloatField
      - HTMLFormFieldCloner
      - HTMLFormFieldWithButton
      - HTMLHiddenField
      - HTMLInfoField
      - HTMLIntField
      - HTMLMultiSelectField
      - HTMLNamespacesMultiselectField
      - HTMLRadioField
      - HTMLRestrictionsField
      - HTMLSelectAndOtherField
      - HTMLSelectField
      - HTMLSelectLanguageField
      - HTMLSelectLimitField
      - HTMLSelectNamespace
      - HTMLSelectNamespaceWithButton
      - HTMLSelectOrOtherField
      - HTMLSizeFilterField
      - HTMLSubmitField
      - HTMLTagFilter
      - HTMLTagMultiselectField
      - HTMLTextAreaField
      - HTMLTextField
      - HTMLTextFieldWithButton
      - HTMLTimezoneField
      - HTMLTitleTextField
      - HTMLTitlesMultiselectField
      - HTMLToggleSwitchField
      - HTMLUserTextField
      - HTMLUsersMultiselectField
  - MediaWiki\Installer:
    - DatabaseUpdater
    - MysqlUpdater
  - MediaWiki\LinkedData:
    - PageDataRequestHandler
  - MediaWiki\Maintenance:
    - Version
  - MediaWiki\Message:
    - Message
  - MediaWiki\Parser:
    - Parser
    - ParserOutput
  - MediaWiki\PoolCounter:
    - PoolCounter
    - PoolCounterNull
    - PoolCounterRedis
    - PoolCounterWork
    - PoolCounterWorkViaCallback
    - PoolWorkArticleView
    - PoolWorkArticleViewCurrent
    - PoolWorkArticleViewOld
  - MediaWiki\Site:
    - CachingSiteStore
    - DBSiteStore
    - HashSiteStore
    - MediaWikiSite
    - Site
    - SiteExporter
    - SiteImporter
    - SiteList
    - SiteLookup
    - SiteStore
  - (T352284) MediaWiki\User\Options:
    - DefaultOptionsLookup
    - UserOptionsLookup
    - UserOptionsManager
    - StaticUserOptionsLookup
* Some hook classes have been moved from the generic MediaWiki\Hooks namespace
  to live closer to the code which uses them:
  - MediaWiki\Output\Hook:
    - AfterBuildFeedLinksHook
    - AfterFinalPageOutputHook
    - BeforePageDisplayHook
    - BeforePageRedirectHook
    - GetCacheVaryCookiesHook
    - LanguageLinksHook
    - MakeGlobalVariablesScriptHook
    - OutputPageAfterGetHeadLinksArrayHook
    - OutputPageBeforeHTMLHook
    - OutputPageBodyAttributesHook
    - OutputPageCheckLastModifiedHook
    - OutputPageMakeCategoryLinksHook
    - OutputPageParserOutputHook
* API modules using ApiBase::requirePostedParameters() must also override
  mustBePosted() to return true.
* Overriding MWException::getHTML(), ::getText(), ::getPageTitle(), and
  ::reportHTML() in order to display custom exception messages is now
  deprecated. Provide the error message when constructing the Exception,
  or if you need a whole custom error page, use ErrorPageError instead.
* Using `new ImportReporter( … )` or `new ApiImportReporter( … )` without
  the $context parameter is now deprecated.
* Using `WikiImporterFactory::getWikiImporter()` without the $performer
  parameter is now deprecated.
* BlockManager::getUserBlock() was deprecated. Instead use
  BlockManager::getBlock(), which expects the caller to do ipblock-exempt
  checking.
* The `composer phpunit:entrypoint` entrypoint has been deprecated, along with
  bootstrap.integration.php and suite.xml. Run tests with `composer phpunit`
  instead, or simply `vendor/bin/phpunit`, which use bootstrap.php and
  phpunit.xml.dist.
* The global variable $wgCommandLineMode is deprecated. In most cases checks
  for `$wgCommandLineMode` can be replaced with `MW_ENTRY_POINT === 'cli'`.
* The global function wfUnpack is deprecated and emits deprecation
  warnings. Use StringUtils::unpack instead.
* BagOStuff::setNewPreparedValues() now emits deprecation warnings.
* SpecialEmailUser::getTarget() has been deprecated.
* User::isBlocked(), ::isBlockedFromCreateAccount() and ::isBlockedFrom() now
  emit deprecation warnings. They were deprecated since 1.34, 1.37 and 1.33
  respectively.
* DatabaseBlock::newFromID() was deprecated and will emit deprecation warnings.
  Instead use DatabaseBlockStore::newFromID().
* DatabaseBlock::getAutoblockExpiry() was deprecated without replacement.
* MagicWord::getId() has been deprecated.
* MagicWordFactory::getSubstIDs() has been deprecated.
* Status::setMessageLocalizer is deprecated. Callers that want to control the
  localization of the Status object should obtain a StatusFormatter from
  the StatusFormatterFactory.
* Html::buttonAttributes() and Html::getTextInputAttributes() methods
  no longer do anything and have been deprecated.
* DatabaseBlock::doAutoblock and ::updateTimestamp are now deprecated, use
  DatabaseBlockStore::doAutoblock and ::updateTimestamp instead.
* The MediaWiki class has been deprecated. Type hints in hooks should be
  changed to refer to MediaWikiEntryPoint instead. Note that extensions should
  not define their own entry points and should not interfere with the state of
  MediaWikiEntryPoint instances.
* Various methods in ObjectCache have been deprecated and their equivalent made
  available in ObjectCacheFactory, use them instead:
  - ::getInstance() -> ObjectCacheFactory::getInstance()
  - ::newFromParams() -> ObjectCacheFactory::newFromParams()
  - ::newAnything() -> ObjectCacheFactory::newInstance(
         ObjectCache::getAnythingId() )
  - ::getLocalServerInstance() -> ObjectCacheFactory::getLocalServerInstance()
  - ::clear() -> ObjectCacheFactory::clear()
  - In addition, the ObjectCache::$instances member has been deprecated as well.
* Vuex has been deprecated in favor of its successor, Pinia. Though deprecated,
  Vuex 4 will remain accessible for the foreseeable future. Pinia should be used
  for new projects.
* Linker::makeHeadline() has been deprecated.
* SerializedValueContainer::isUnified() has been deprecated and now emits
  deprecation warnings since 1.42.
* Linker::generateTOC(), Linker::tocIndent(), Linker::tocUnindent(),
  Linker::tocLine(), Linker::tocLineEnd(), Linker::tocList() are deprecated.
* Title::getBrokenLinksFrom() has been deprecated.
* LogFormatter subclasses now emit deprecation warnings unless they are
  constructed using LogFormatterFactory.
* ReplicatedBagOStuff has been deprecated since 1.42.
* The third argument to ContentRenderer::getParserOutput() now accepts a
  RevisionRecord or WikiRevision; passing an integer revision id has been
  deprecated and emits a warning.
* Passing a null value to ParserOutput::setPageProperty() has been deprecated
  and emits a warning; pass an empty string or use `::unsetPageProperty()`
  instead.
* Passing a non-string value to ParserOutput::setPageProperty() has been
  deprecated; use ::setNumericPageProperty() instead.
* Passing a non-scalar value to ParserOutput::setPageProperty() will emit
  a warning (it has never worked).
* ParserOutput::setLanguageLinks() has been deprecated.
* ParserOutput::getTimestamp() and ::setTimestamp() have been deprecated; use
  ::getRevisionTimestamp() and ::setRevisionTimestamp() instead.
* ParserOutput::setText() has been deprecated; use ::setRawText() instead which
  matches the name of the corresponding getter, ParserOutput::getRawText().
* ParserOutput::addTemplate() will emit a deprecation warning if it is called
  with a non-local title, such as an interwiki link. In a future release it will
  throw InvalidArgumentException.
* The use of dynamic properties of Parser has been deprecated and will emit
  deprecation warnings.
* The following deprecated public properties of Parser will emit deprecation
  warnings:
  - Parser::$ot, deprecated since 1.35
  - Parser::$mTitle, deprecated since 1.35
  - Parser::$mOptions, deprecated since 1.35
* The following deprecated public properties of Parser are now marked
  for internal use only:
  - Parser::$mPPNodeCount, deprecated since 1.35
  - Parser::$mHighestExpansionDepth, deprecated since 1.35
* ApiQueryBlockInfoTrait::addBlockInfoToQuery() will emit deprecation warnings
  and will soon stop working due to schema changes. Instead use
  addDeletedUserFilter() or getBlockDetailsForRows().
* UploadBase::getImageInfo was deprecated, subclasses of ApiUpload can use
  ApiUpload::getUploadImageInfo() instead.
* DatabaseBlockStore::updateTimestamp() is now internal and should not be
  called.
* The LocalisationCache helper class GlobalDependency has been deprecated,
  use MainConfigDependency instead.
* The module `mediawiki.icon` has been deprecated. Use the Codex mixin instead
  (T351681).
* ConfigRepository::class and MediaWikiServices::getConfigRepository() have been
  deprecated, they are unused.
* Passing a WikiPage to PageEditStash::parseAndCache() has been deprecated.
  Use PageUpdater instance.
* SpecialBlock::getSuggestedDurations() has been deprecated, use
  Language::getBlockDurations() instead.
* MediaWikiServices::getBlockErrorFormatter() has been deprecated, use
  MediaWikiServices::getFormatterFactory()->getBlockErrorFormatter() instead.
* DummyLinker has been deprecated. The DummyLinker parameter to the
  'ImageBeforeProduceHTML' hook will become null in the future.
* Database::listViews() has been deprecated. This was previously used to filter
  views out of the return value of Database::listTables(). Now listTables()
  will not include views. MediaWiki does not use views.
* (T207621) UserMailer::rfc822Phrase(), deprecated since 1.38, now emits
  deprecation warnings.
* TempUserConfig::getMatchPattern() has been deprecated, use getMatchPatterns()
  instead.
* (T230025) Title::purgeSquid(), deprecated in 1.35, now emits warnings.
* Title::getCdnUrls(), deprecated in 1.35, now emits warnings.
* The rarely-used convenience method Xml::wrapClass() is now deprecated. Instead
  you can use Xml::tags('span', ['class'=>'foo'], 'bar').
* WebRequest::getCrossSiteCookie() has been deprecated due to the removal of
  $wgUseSameSiteLegacyCookies. It will emit deprecation warnings. Use
  WebRequest::getCookie().
* Using the array_merge_recursive merge strategy in extension.json and skin.json
  now emits deprecation warnings.
* DBAccessObjectUtils::getDBFromIndex() is now deprecated, use
  ::getDBFromRecency() instead.
* Many Xml methods that are specific to HTML but not XML are deprecated:
  - Xml::buildForm
  - Xml::buildTable
  - Xml::buildTableRow
  - Xml::check
  - Xml::checkLabel
  - Xml::dateMenu
  - Xml::fieldset
  - Xml::input
  - Xml::inputLabel
  - Xml::inputLabelSep
  - Xml::label
  - Xml::languageSelector
  - Xml::listDropdown
  - Xml::listDropdownOptions
  - Xml::listDropdownOptionsOoui
  - Xml::monthSelector
  - Xml::option
  - Xml::password
  - Xml::radio
  - Xml::radioLabel
  - Xml::span
  - Xml::submitButton
  - Xml::textarea
  - Xml::attrib (only for use in HTML, not XML contexts)
* IMaintainableDatabase::truncate() has been deprecated. Use truncateTable()
  instead.
* TextConflictHelper->incrementStatsByUserEdits() is now deprecated. The action
  this function previously handled should be moved into incrementConflictStats()
  and incrementResolvedStats().
* SQLPlatform::getQueryVerb() is now deprecated.

=== Other changes in 1.42 ===
* Gallery: Image captions are no longer wrapped in <p> tags. Skins that
  customize rendering for galleries may need to tweak their CSS.
* Scripts under maintenance/dev/, for quickly setup a local MediaWiki for
  development purposes, have been removed, see DEVELOPERS.md for alternatives.

= MediaWiki 1.41 =

PHP 8.0 workboard: https://phabricator.wikimedia.org/tag/php_8.0_support/
PHP 8.1 workboard: https://phabricator.wikimedia.org/tag/php_8.1_support/
PHP 8.2 workboard: https://phabricator.wikimedia.org/tag/php_8.2_support/
PHP 8.3 workboard: https://phabricator.wikimedia.org/tag/php_8.3_support/

== MediaWiki 1.41.4 ==

This is a maintenance release of the MediaWiki 1.41 branch.

=== Changes since MediaWiki 1.41.3 ===
* Fix issue related to backport of AbuseFilter patch for T372998.

== MediaWiki 1.41.3 ==

This is a security and maintenance release of the MediaWiki 1.41 branch.

=== Changes since MediaWiki 1.41.2 ===
* Localisation updates.
* Parser: Deprecate use of mOutput before initialization.
* Clarify that $wgAllowCrossOrigin only applies to REST.
* composer.json: Add 5 more ext- to suggests.
* resources: Fix 404 Not Found for foreign Financial-Times/polyfill-library.
* ResourceLoader: Fix regression of color mapping in Less.php.
* ResourceLoader: Upgrade wikimedia/less.php to 4.4.1.
* SpecialExport: Prevent passing null to strtolower.

== MediaWiki 1.41.2 ==

This is a maintenance release of the MediaWiki 1.41 branch.

=== Changes since MediaWiki 1.41.1 ===
* Localisation updates.
* maintenance/generateSitemap.php: Partially revert 676fcf4.
* tests: Skip failing tests on php8.2 (and make pass).
* (T326480) ApiResult: Make array ordering consistent across PHP versions.
* (T352789, T287972) build: Raise TestingAccessWrapper from 2.0.0 to 3.0.0.
* (T326478) tests: Create new classes to hold dynamic properties in auth tests.
* (T353180) WANObjectCacheTest::testPreemptiveRefresh: Skip flaky test for PHP
  8.2+.
* tests: Remove es6 option from StartUpModuleTest.
* (T326478) tests: Avoid dynamic properties in AuthenticationProvider Test.
* tests: Skip failing tests on php8.3 (and make pass).
* (T326466) Introduce and use DynamicPropertyTestHelper.
* (T326478) tests: Avoid dynamic properties in auth tests.
* (T352910) tests: Use TestingAccessWrapper::newFromClass in session tests.
* (T326478) tests: Avoid dynamic properties in SessionManagerTest.
* ArticleTest: Skip testGetOrSetOnNewProperty() if PHP >= 8.2.
* tests: Remove dead code from WikiPageDbTest::assertPreparedEditNotEquals.
* (T326479, T361985) StatusValue: Allow passing arbitrary data to augment
  result.
* (T357760) Use i18n strings for truncated subpage message in SpecialMovePage.
* debug: Update PsySH 0.11.1 -> 0.12.3.
* (T361991) Fix slash-delimited regex from CLI on maintenence/grep.php.
* (T352695) tests: Only set $dbSetup if setupTestDB() ends without throwing.
* (T362272) api: Replace null $httpCode by 0 in ApiBase::dieWithErrorOrDebug.
* (T362740) api: Pass wikiId to UserIdentity instance for action=userrights.
* (T343994) SpecialPages: Document which class getDescription is returning a
  string from.
* (T150647, T216682) Make EncryptedPassword work with Argon2Password.
* (T364270) Fix long param names overlapping docs in API help pages.
* wrapOldPasswords: Improve progress output and decrease batch size.
* (T361367) ApiFeedWatchlist: Fix handling of array parameters.
* (T366130) EncryptedPassword: Store default parameters as strings.
* Name the PagerTools array entries to allow hooks to unset them.
* Do not mark HttpRequestFactory as @internal.

== MediaWiki 1.41.1 ==

This is a security and maintenance release of the MediaWiki 1.41 branch.

=== Changes since MediaWiki 1.41.0 ===
* Localisation updates.
* CategoryViewer: Fix "count(): Argument #1 ($value) must be of type
  Countable|array, null given".
* (T353929) ActiveUsersPager: Count actions only once.
* composer: Use @php instead of php.
* (T334992) Headings in the license pickers should not be selected.
* (T326065) Indent JsonContent using tabs.
* Correct deprecation version of mediawiki.ui resource loader module.
* Resources.php: Replace short urls with full urls.
* (T354541) authmanager: Improve AuthenticationRequest docs.
* Tweak docs for UseLegacyMediaStyles.
* (T353870) Parse custom edit intro as content to enable language conversion.
* (T330428) ForeignResourceManager: Add trailing newline in validateLicense.
* ForeignResourceManager: Make it clearer what is being skipped for
  documentation-only.
* (T355017) Add missing space in Special:RecentChangesLinked.
* (T355003) composer.json Add ext-bcmath and ext-gmp to suggests.
* PHPVersionCheck: Update text to match currently supported upstream PHP
  versions (8.1+).
* (T354045) API: mark HTML output as non-cacheable.
* (T355530) filerepo: Fix img_major_mime for files with a non-standard
  extensions.
* (T355530) MimeAnalyzer: Add @since to isValidMajorMimeType.
* (T352554) ZhConverter: Fix language variant fallback chain.
* (T347541) Add 'maxlength' and 'minlength' support to HTMLTextAreaField.
* (T357668) Parser::getExternalLinkAttribs: Don't set rel attribute to null.
* LockManagerGroupIntegrationTest: Remove test depending on DBLockManager.
* (T357808) LinkRendererTest: Add missing import for LinkTarget.
* (T353305) ApiResetPassword: Allow both user and email parameters to be passed
  for reset.
* (T358949) updateCollation: Explicitly cast $scale to int.
* (T359055) api: Improve linking of language codes lists in top level i18n
  messages.
* (T359294) Make sure MovePage::isValidFileMove matches UploadBase::getTitle.
* (T230245) Respect $maxConcurrency when queuing async FileOps.
* (T352554) Follow-up "ZhConverter: Fix language variant fallback chain".
* (T359139) Restore ability to disable footer links with "-".
* Fix use of array keys in SessionManager::getVaryHeaders().
* (T292237, T317451) build: Restore Doxygen output for MediaWiki release tags.
* (T324903) HistoryPager: Add #[AllowDynamicProperties].
* (T360850) Update Apache config syntax in .htaccess files.
* Update wikimedia/parsoid to 0.18.2.
* docs: Remove use of $IP from mwdocgen.php.
* (T317451) build: Restore Doxygen output for MediaWiki release tags (take 3).
* docs: Set stable permalink on markdown files.
* (T360608) WebRequest: detectServer appends default ports that should be
  omitted.
* (T357019) allow maintenance/deleteBatch.php to accept page ID.
* (T355538, CVE-2024-34507) SECURITY: XSS in edit summary parser.
* (T357760, CVE-2024-34506) SECURITY: Denial of service vector via GET request
  to Special:MovePage on pages with thousands of subpages.

=== Changes since MediaWiki 1.41.0-rc.0 ===
* Localisation updates.
* Update wikimedia/parsoid to 0.18.0.
* (T351758) DEVELOPERS.md: reword WSL instructions to include best practices.
* (T350615) PoolCounterConnectionManager: Add support for ipv6.
* (T321234) Make MagicWordArray not fail on old revs with broken UTF-8.
* thumb: Fix "PHP Deprecated: strlen(): Passing null to parameter".
* (T344971) Maintenance: Fix RebuildTextIndex.
* (T327007) htmlform: Correct validation for file input field.

== MediaWiki 1.41.0-rc.0 ==

== Upgrading notes for 1.41 ==
Don't forget to always back up your database before upgrading!

See the file UPGRADE for more detailed per-version upgrade instructions from the
oldest supported upgrading version, MediaWiki 1.35.

Some specific notes for MediaWiki 1.41 upgrades are below:
* (T178356) MediaWiki now requires browsers to support ES6 for them to receive
  JavaScript, up from ES5. In practice, this primarily means that users of
  Internet Explorer 11 (EOL in 2022) will no longer get JavaScript tools.

For notes on 1.40.x and older releases, see HISTORY.

=== Configuration changes for system administrators in 1.41 ===
* $wgGroupPermissions: The 'purge' permission is now considered an
  implicit right that can be rate limited, but not revoked. This has
  effectively already been the case for a long time, see T291316.

==== New configuration ====
* $wgPrivilegedGroups – Users belonging in some of the listed groups will be
  audited more aggressively.
* $wgPageLinksSchemaMigrationStage – This temporary flag lets you control the
  migration stage for converting the pagelinks database table into normal form.
* $wgExternalLinksDomainGaps – Can be used by large wikis to optimize certain
  external link queries.
* $wgResourceLoaderEnableSourceMapLinks - Add a SourceMap header to
  ResourceLoader responses for JavaScript modules (T47514).
* $wgVirtualDomainsMapping - Mapping of virtual domains to other dbs. It's
  useful to get connection to the external cluster.

==== Changed configuration ====
* $wgAuthManagerAutoConfig – When using this setting to modify the
  authentication system in MediaWiki, the classes
  TemporaryPasswordPrimaryAuthenticationProvider,
  LocalPasswordPrimaryAuthenticationProvider and
  EmailNotificationSecondaryAuthenticationProvider now require
  DBLoadBalancerFactory, not DBLoadBalancer, as a service.
* $wgUseFileCache is no longer used for ResourceLoader module caching.
* $wgLBFactoryConf['secret'] has been replaced by $wgChronologyProtectorSecret.

==== Removed configuration ====
* $wgCommentTempTableSchemaMigrationStage – This temporary flag did let you
  control the migration stage for the temporary comment database table, from
  revision.
* $wgExternalLinksSchemaMigrationStage – This temporary flag did let you
  control the migration stage for the externallinks database table.
* $wgParserOutputHooks - This array interacted with
  ParserOutput::addOutputHook(), which has been deprecated since 1.38 and was
  removed in this release.

=== New user-facing features in 1.41 ===
* Special:RandomPage can now take multiple namespaces in its URL, split by ','.
* The aria-level HTML attribute is now allowed in wikitext by the Sanitizer.

=== New features for sysadmins in 1.41 ===
* $wgDBssl can now enabled in the installer when the database type is
  Postgres or MariaDB/MySQL (T335828).
* MWHttpRequest will forward 'tracestate' and/or 'traceparent' headers when
  those are present in the original request and $wgAllowExternalReqID is set
  to true.
* MultiHttpClient will send X-Request-Id header and additionally will forward
  'tracestate' and/or 'traceparent' headers when those are present in the
  original request and $wgAllowExternalReqID is set to true.

=== New developer features in 1.41 ===
* Added ForeignResourcesDir extension.json / skin.json attribute, which should
  point to the directory holding your foreign-resources.yaml file. See
  https://www.mediawiki.org/wiki/Foreign_resources for background.
* Added PrivilegedGroups attribute for extension.json / skin.json, which lets
  you add any new user groups you define to wgPrivilegedGroups (see above).
* Added a .gitmessage commit template. To use it, run:
  `git config commit.template .gitmessage`
* A new hook, TextSlotDiffRendererTablePrefixHook, has been added to allow
  extensions to add content within #mw-content-text but after the
  DifferenceEngineViewHeader or DifferenceEngineShowDiffPage hooks have been
  run. The new hook is used to add elements within a horizontal display area,
  where their order can be explicitly set. Examples of uses for this include
  adding the VisualEditor diff-type switch, and the legend for inline diffs that
  is displayed if Wikidiff2 is installed.
* validation callbacks for HTMLForm fields can now return Status objects.
  HTMLForm::validate will convert good Status instances to true and Status
  instances to a string containing a list with the errors.
* ?action=rollback, if successful, will fire core's postEdit JavaScript hook;
  for now, we do *not* display a success message to the user via mw.notify(),
  as the RollbackAction form's success page is already shown
* MultiHttpClient constructor will accept `headers` property which defines a
  set of headers attached to every request performed by the client.
* New `Wikimedia/Http/TelemetryHeadersInterface` interface that provides a
  telemetry information which could be attached to HTTP Requests
* Wikimedia/Http/TelemetryHeadersInterface can be passed to MultiHttpClient
  via 'telemetry' option.
* UserRegistrationLookup adds support for multiple kinds of registration dates
  Extensions providing support for wiki-farm can use this to provide a global
  registration date (across all wikis), for example.
* When $wgUseXssLanguage is set to true (enabled by default in
  DevelopmentSettings.php), ?uselang=x-xss can be used to easily test
  whether all messages are being escaped correctly.
* Html::noticeBox accepts new optional parameters, 'heading' & 'iconClassName'.
  'heading' allows to pass an string as title; 'iconClassName' overwrites the
  default info icon.

=== External library changes in 1.41 ===

==== New external libraries ====
* Added pinia at v2.0.16.
* Added symfony/polyfill-php81 at v1.28.0.
* Added symfony/polyfill-php82 at v1.28.0.
* Added symfony/polyfill-php83 at v1.28.0.

==== Changed external libraries ====
* Updated codex, codex-design-tokens and codex-icons
  from v0.6.2 to v1.0.0.
* Updated guzzlehttp/guzzle from 7.5.0 to 7.5.3.
* Updated jQuery from v3.6.1 to v3.7.0.
* Updated justinrainbow/json-schema from 5.2.12 to v5.2.13.
* Updated Mustache from 3.0.1 to 4.2.0.
* Updated OOjs from 6.0.0 to 7.0.1.
* Updated OOUI from v0.46.3 to v0.48.1.
* Updated pear/mail from 1.5.0 to 1.5.1.
* Updated symfony/polyfill-php82 from v1.27.0 to v1.28.0.
* Updated symfony/yaml from v5.4.17 to v5.4.23.
* Updated wikimedia/bcp-47-code from 1.0.0 to 2.0.0.
* Updated wikimedia/common-passwords from 0.4.0 to 0.5.0.
* Updated wikimedia/composer-merge-plugin from 2.0.1 to 2.1.0.
* Updated wikimedia/html-formatter from 3.0.1 to 4.0.3.
* Updated wikimedia/ip-utils from 4.0.0 to 5.0.0.
* Updated wikimedia/less.php from 4.0.0 to 4.1.1.
* Updated wikimedia/minify from 2.3.0 to 2.5.1.
* Updated wikimedia/remex-html from 3.0.3 to 4.0.1.
* Updated wikimedia/timestamp from 4.1.0 to 4.1.1.
* Updated wikimedia/utfnormal from 3.0.2 to 4.0.0.

===== Changed development-only external libraries =====
* Updated mediawiki/mediawiki-codesniffer from 41.0.0 to 42.0.0.
* Updated mediawiki/mediawiki-phan-config from 0.12.1 to 0.13.0.

==== Removed external libraries ====
* jquery.hoverIntent was removed.
* codex-search was removed, it's part of codex now.
* wikimedia/ip-set was removed, it's part of wikimedia/ip-utils now.
* jquery.color was removed.
* jquery.fullscreen was removed.
* jquery.form was removed.

=== Action API changes in 1.41 ===
* (T322944) `Authorization` was added to the default list of headers
  allowed for cross-origin API requests ($wgAllowedCorsHeaders).

=== Languages updated in 1.41 ===
MediaWiki supports over 350 languages. Many localisations are updated regularly.
Below only new and removed languages are listed, as well as changes to languages
because of Phabricator reports.

* (T345807) Added language support for Karekare (kai).
* (T333765) Removed language support for Akan (Ak).
* (T332113) Added language support for Northern Hindko (hno).
* (T333425) Added language support for Iraqi (Mesopotamian) Arabic (acm).
* (T336919) Added language support for Crimean Tatar (Romania) (crh-ro).
* (T338416) Added language support for Betawi (bew).
* (T341545) Added language support for West Coast Bajau (a.k.a. Sama; bdr).
* (T332118) Namespace translations for Angika (anp) were added
* (T341942) The autonym of the Buginese language is changed to the Latin-script
  name "Basa Ugi", and the localization in the language code "bug" is now only
  in the Latin script. It's possible to add localization in the Lontara script
  in translatewiki under the code "bug-bugi".
* (T341943) Main Page name translation was changed from "Leppa Indoë"
  to "Watangpola". If you manage a wiki in this language, make sure that
  links to the main page are correctly updated. See
  https://translatewiki.net/w/i.php?title=Support&oldid=11723654#Change_MediaWiki:Mainpage/bug

=== Breaking changes in 1.41 ===
* Article::doDelete(), deprecated since 1.37, has been removed.
* CommentStore::getStore(), deprecated since 1.31, has been removed.
* Article::getRedirectHeaderHtml() no longer accepts an array as $target.
  Passing an array was deprecated in 1.39.  (The method itself has also
  been deprecated.)
* BagOStuff::addBusyCallback(), deprecated since 1.39, has been removed.
* IExpiringStore has been removed, use either ExpirationAwareness or
  StorageAwareness constants instead.
* IDatabase::wasErrorReissuable(), deprecated since 1.40, has been removed.
* IDatabase::lastQuery and IReadableDatabase::lastQuery, deprecated in 1.40,
  have been removed.
* Database::queryMulti(), unused, has been removed without deprecation.
  The protected Database::doMultiStatementQuery method was removed, and the
  protected Database::executeQuery method signature was changed to take
  Query object as argument instead of a raw SQL string.
* Database::unionConditionPermutations(), unused, has been removed without
  deprecation.
* SimpleSearchResultSetWidget and SimpleSearchResultWidget classes, deprecated
  in 1.31, have been removed.
* Database::factory(), deprecated in 1.39, has been removed.
* Calling IDatabase::delete() or IDatabase::update() with empty conditions
  has been deprecated since 1.35. This now throws an error.
* Maintenance::shutdown() has been moved over into the MaintenanceRunner class
  without deprecation.
* The following DatabasePostgres methods were unused and have been removed:
  - ::currentSequenceValue()
  - ::triggerExists()
  - ::ruleExists()
* The following IDatabase methods were unused and removed without deprecation:
  - ::wasLockTimeout()
  - ::wasConnectionLoss()
* Database::getTempTableWrites(), previously protected, is now private.
* DatabasePostgres class parameter "keywordTableMap", deprecated since 1.37,
  has been removed.
* Database::doUpsert() and ::doReplace() have been removed without deprecation.
  Subclasses should override ::upsert() or ::replace() respectively.
* SelectQueryBuilder::lockForUpdate(), deprecated in 1.40 and unused,
  has been removed without hard deprecation.
* TransactionProfiler::setSilenced() deprecated in 1.40, has been removed.
* ILoadBalancer::closeConnection, unused, has been removed without deprecation.
* ILoadBalancer::waitFor, unused, has been removed without deprecation.
* ILBFactory::resolveDomainID and ::getChronologyProtectorTouched, unused,
  have been removed without deprecation.
* The following methods have been moved from ILoadBalancer to
  ILoadBalancerForOwner:
  - ::redefineLocalDomain()
  - ::hasPrimaryConnection()
  - ::setIndexAliases()
* LBFactory::makeCookieValueFromCPIndex() and ::getCPInfoFromCookieValue()
  has been moved to ChronologyProtector class without backward compatability
  as they are not supposed to be used outside of core.
* MWHttpRequest::factory(), deprecated since 1.34, has been removed.
* The Http class, deprecated since 1.34, with the functions ::request(),
  ::get(), ::post(), ::userAgent(), ::isValidURI(), ::getProxy(),
  ::createMultiClient() have been removed.
* WikiPage::factory(), ::newFromID() and ::newFromRow, deprecated in 1.36,
  have been removed.
* Maintenance::$mArgList, ::shouldExecute(), ::setAgentAndTriggers(),
  ::adjustMemoryLimit(), ::globals(), and ::loadSettings() have been removed.
* The GenericArrayObject class, deprecated in 1.40,
  has been removed.
* The $replace parameter has been removed from HookContainer::scopedRegister.
  This parameter was unused outside core, and the functionality was intended
  for testing.
* PrevNextNavigationRenderer class, deprecated in 1.39,
  has been removed.
* class alias MediaWiki\User\WatchlistNotificationManager, deprecated in 1.36,
  has been removed.
* MediaWikiServices::getWatchlistNotificationManager(), deprecated in 1.36,
  has been removed.
* Interface MediaWiki\Hook\ParserTestTablesHook, deprecated in 1.36,
  has been removed.
* The NewPagesLineEndingHook now takes NewPagesPager instead of
  SpecialNewpages as first argument.
* The following methods in the Title class, deprecated since 1.37, have been
  removed:
  - ::areCascadeProtectionSourcesLoaded()
  - ::areRestrictionsCascading()
  - ::areRestrictionsLoaded()
  - ::getAllRestrictions()
  - ::getCascadeProtectionSources()
  - ::getFilteredRestrictionTypes()
  - ::getRestrictionExpiry()
  - ::getRestrictionTypes()
  - ::getRestrictions()
  - ::isCascadeProtected()
  - ::isProtected()
  - ::isSemiProtected()
  - ::loadRestrictionsFromRows()
* Global function wfShowingResults, deprecated in 1.40, has been removed.
* Global function wfClearOutputBuffers, deprecated in 1.36, has been removed.
* LinkBatch::__construct() now requires that all parameters be passed. The
  fallback to MediaWikiServices emitted deprecation notices since 1.35.
* The methods IndexPager::getPagingLinks(), IndexPager::getLimitLinks() and
  IndexPager::buildPrevNextNavigation(), deprecated in 1.39,
  have been removed.
* Overriding the method IndexPager::makeLink(), deprecated in 1.39,
  is no longer possible.
* MagicWordFactory::getCacheTime() is deprecated and returns -1.
* Various mediawiki.less mediawiki.ui variables, deprecated in 1.35, have been
  removed. See also below that the remaining mediawiki.ui variables are now also
  deprecated.
* Calling getId() on an AbstractBlock from the wrong wiki, deprecated since
  1.38, now throws an exception.
* SQLite no longer supports raw MySQL queries.
* The following functions from the mediawiki.mixins Less import, deprecated
  since 1.37, have been removed: .transition(), .transition-transform(),
  .transform() and .transform-origin().
* Support was dropped for skins with paths relative to core which has been
  sending deprecation notices since 1.37. The skin `templateDirectory` key
  should now always be relative to the skin.
* The Skin public thisquery property was removed without deprecation. Only
  one skin was known to use it and that has been patched accordingly.
* The jquery.tipsy module, deprecated since 1.28, has now been removed.
* NamespaceInfo::getRestrictionLevels(), deprecated in 1.34, has been removed.
  Use PermissionManager::getNamespaceRestrictionLevels() instead.
* Proto-relative external links are now stored and indexed only as HTTPS
  instead of two rows, one for HTTP and one for HTTPS.
* MediaWikiIntegrationTestCase::getTestUser(), ::getTestSysop(), and
  ::getMutableTestUser() have been made protected and non-static.
* MediaWikiIntegrationTestCase::$supportedDBs has been changed to a private
  constant.
* MediaWikiIntegrationTestCase::addCoreDBData() has been deprecated. The method
  is now a no-op and is no longer called. Tests should create the fixtures
  they need.
* Saving preferences for a temporary user now throws an error (e.g. via
  UserOptionsManager::saveOptions)
* ApiQuery::getNamedDB() and ApiQueryBase::selectNamedDB(), deprecated in
  1.39, have been removed.
* ChangeTags::addTagsAccompanyingChangeWithChecks() and
  ChangeTags::undefineTag() unused everywhere, have been removed without
  deprecation.
* Usage of MediaWiki::preOutputCommit() with the $postCommitWork arg has been
  dropped. It's no longer used.
* SkinTemplateNavigation and SkinTemplateNavigation::SpecialPage hooks,
  deprecated in 1.39, have been removed.
* The PersonalUrls hook, deprecated in 1.39, has been removed.
* OutputPage::getCSPNonce(), soft deprecated in 1.35, now emits deprecation
  warnings.
* Support of the third parameter of LogEventsListGetExtraInputs hook,
  deprecated since 1.32, has been removed.
* JobSpecification::getTitle(), deprecated in 1.37, has been removed.
* The module mw.ui.anchor has been removed. Projects that need it should
  maintain a local copy or use the Codex link mixin. More information
  at T235961.
* ParsoidCachePrewarmJob::newSpec() now requires a PageRecord as the second
  parameter instead of a page ID.
* Public access to the DifferenceEngine properties mOldid, mNewid, mOldRev,
  mNewRev, mOldPage, mNewPage, mOldContent, mNewContent, mRevisionsLoaded,
  mTextLoaded and mCacheHit, deprecated in 1.32, was removed.
* SearchDatabase::db, deprecated since 1.38, has been removed.
* SearchDatabase::lb has been removed without deprecation, use ::dbProvider
  instead.
* StreamFile::STREAM_HEADLESS and StreamFile::STREAM_ALLOW_OB, deprecated
  in 1.34, have been removed.
* AbstractAuthenticationProvider::setLogger(), ::setManager(), ::setConfig()
  and ::setHookContainer() have been removed and also from it's related
  interface, AuthenticationProvider. The corresponding properties are set in
  AbstractAuthenticationProvider::init(). For side effects, you can override
  AbstractAuthenticationProvider::postInitSetup().
* Title::newFromTitleValue(), deprecated since 1.34, has been removed.
* Parser::OT_MSG, related to OT_MSG(3) MediaWiki constant, parameter for
  starting external parse has been dropped. This was kept since 2008 for B/C
  only and no longer used. Use instead Parser::OT_PREPROCESS as the
  replacement.
* SpecialPageAction has been removed without deprecation. There were no known
  uses outside of core.
* ConfigRepository::getValueOf() has been removed without deprecation. This
  method was introduced and never used for a long time now.
* BacklinkCache::get(), ::getLinks(), ::getCascadeProtectedLinks() which
  emitted deprecation warnings has no usage left. It has been removed.
* The following constants and methods in the Language class, hard deprecated
  since 1.40, have been removed:
  - ::ALL
  - ::SUPPORTED
  - ::MESSAGES_FALLBACKS
  - ::STRICT_FALLBACKS
  - ::factory()
  - ::isSupportedLanguage()
  - ::isWellFormedLanguageTag()
  - ::isValidCode()
  - ::isValidBuiltInCode()
  - ::isKnownLanguageTag()
  - ::getLocalisationCache()
  - ::fetchLanguageNames()
  - ::fetchLanguageName()
  - ::getConverter()
  - ::autoConvert()
  - ::autoConvertToAllVariants()
  - ::convert()
  - ::convertNamespace()
  - ::hasVariants()
  - ::hasVariant()
  - ::convertHtml()
  - ::convertCategoryKey()
  - ::getVariants()
  - ::getPreferredVariant()
  - ::getDefaultVariant()
  - ::getURLVariant()
  - ::getExtraHashOptions()
  - ::getParentLanguage()
  - ::getFileName()
  - ::getMessagesFileName()
  - ::getJsonMessagesFileName()
  - ::getFallbackFor()
  - ::getFallbacksFor()
  - ::getFallbacksIncludingSiteLanguage()
  - ::getMessagesFor()
  - ::getMessageFor()
  - ::getMessageKeysFor()
  - ::getConvRuleTitle()
* The parameter noSeparators to Language::formatNum, deprecated since 1.36,
  has been removed. Use Language::formatNumNoSeparators instead.
* The following methods in the ParserOutput class, deprecated since 1.38, have
  been removed:
  - ::addOutputHook()
  - ::addTrackingCategory()
  - ::addWarning()
  - ::getCategoryLinks()
  - ::getOutputHooks()
  - ::getProperties()
  - ::getProperty()
  - ::hasDynamicContent()
  - ::hideNewSection()
  - ::preventClickjacking()
  - ::setCategoryLinks()
  - ::setProperty()
  - ::unsetProperty()
* OutputPage::allowClickjacking() and ::preventClickjacking(), deprecated
  since 1.38, have been removed.
* ResourceFileCache has been removed without deprecation. There were no known
  uses outside of core.
* Many LocalisationCache constants, properties and methods that have no known
  usage outside of the class have been made private without deprecation.
* User::idFromName(), deprecated in 1.37, has been removed. Instead, you should
  use UserIdentityLookup::getUserIdentityByName().
* User::incEditCount(), deprecated in 1.37, has been removed. Instead, use
  UserEditTracker::incrementUserEditCount().
* Article::getTimestamp(), deprecated in 1.35, has been removed. Use WikiPage's
  or RevisionRecord's version of this method instead.
* ActionFactory::actionExists(), deprecated since 1.38, has been dropped.
* Action::exists(), deprecated since 1.38, has been dropped.
* ContentHandler::getForTitle(), deprecated since 1.35, has been dropped.
* LockManagerGroup::getDefault() and ::getAny(), deprecated since 1.35, have
  been dropped.
* BaseTemplate::getToolbox(), deprecated since 1.35, has been dropped. To add
  items to the toolbox, use the SidebarBeforeOutput hook. To get the toolbox,
  subclasses can use $this->data['sidebar']['TOOLBOX'].
* IndexPager::getHookContainer(), deprecated since 1.40, has been removed. You
  should instead inject a HookContainer into your code.
* Not specifying a manifest_version in your extension.json or skin.json file,
  deprecated since 1.26 and emitting warnings since 1.29, is no longer supported
  with a fallback; it will now have unspecified behaviour.
* RecentChange::getEngine(), deprecated since 1.29, has been removed. Use
  RCFeed::factory() instead.
* EditPage::showEditForm() no longer respects the $formCallback parameter, which
  was deprecated in 1.25. Use the EditPage::showEditForm:fields hook instead.
* The following properties in EditPage, deprecated in 1.38, were made private:
  - $mArticle
  - $mTitle
  - $isNew
  - $allowBlankArticle
  - $selfRedirect
  - $allowSelfRedirect
  - $diff
  - $undoAfter
  - $edit
  - $contentLength
* EditPage::addNewLineAtEnd(), deprecated since 1.38, was removed.
* AuthManager::checkAccountCreatePermissions(), deprecated in 1.39, has been
  removed. Use authorizeCreateAccount() or probablyCanCreateAccount() instead.
* LinkCache::addGoodLinkObj(), deprecated in 1.37, has been removed. You should
  use ::addGoodLinkObjFromRow().
* Constructing TextConflictHelper without a ContentHandlerFactory, deprecated
  since 1.35, will now trigger a type error.
* JobQueue::getWiki(), deprecated in 1.33, has been removed.
* ManualLogEntry::setTags(), deprecated in 1.33, has been removed.
* WikiPage::getDeletionUpdates(), deprecated in 1.37, has been removed.
* ResourceLoader\Context::getConfig(), deprecated in 1.34, has been removed.
* When creating a SearchUpdate instance, passing a non-Content string or Boolean
  as the $c parameter, deprecated since 1.34, will now trigger type errors.
* SkinTemplate::getNameSpaceKey(), deprecated in 1.35, has been dropped. Instead
  you should use Title::getNamespaceKey().
* The AddNewAccount hook, deprecated since 1.27, will now trigger deprecation
  warnings. You should use the LocalUserCreated hook instead.
* The PrefixSearchBackend hook, deprecated since 1.27, will now trigger
  deprecation warnings. Override SearchEngine::completionSearchBackend instead.
* PrefixSearch::validateNamespaces(), completely unused everywhere, has been
  removed without deprecation.
* BaseTemplate::getTrail() and ::printTrail(), deprecated since 1.39, have been
  dropped.
* Passing a second query parameter to Title::getFullURL(), Title::getLocalURL(),
  Title::getInternalURL(), or Title::getCanonicalURL(), each deprecated in 1.19,
  is now not supported. Pass it as a key,value pair in the first parameter array
  instead.
* Title::getBacklinkCache(), deprecated since 1.37, has been dropped. Instead,
  use BacklinkCacheFactory::getBacklinkCache().
* Title::newFromIDs and TitleFactory::newFromIDs, deprecated in 1.38, have been
  dropped; use a PageStore QueryBuilder instead.
* Title::getSelectFields(), deprecated since 1.36, has been dropped. You can use
  PageStore::newSelectQueryBuilder() instead.
* Title::getTouched() will now trigger an error if you pass it an instance of
  IDatabase rather than a READ_XXX constant. This legacy behaviour has been
  deprecated since 1.38.
* User::getGroupPermissions(), getGroupsWithPermission() & groupHasPermission(),
  all of which were deprecated since 1.34, have been removed. Instead, use the
  GroupPermissionsLookup service.
* Similarly, PermissionManager::getGroupPermissions(), getGroupsWithPermission()
  & groupHasPermission(), all of which were deprecated since 1.36, have also
  been removed. Instead, use the GroupPermissionsLookup service.
* The following old, deprecated aliases for classes in the RDBMS layer, have now
  been removed:
   - DBConnRef (use Wikimedia\Rdbms\DBConnRef)
   - Database (use Wikimedia\Rdbms\Database)
   - DatabaseBase (use Wikimedia\Rdbms\Database)
   - DatabaseMysqlBase (use Wikimedia\Rdbms\DatabaseMySQL)
   - DatabaseMysqli (use Wikimedia\Rdbms\DatabaseMySQL)
   - DatabasePostgres (use Wikimedia\Rdbms\DatabasePostgres)
   - DatabaseSqlite (use Wikimedia\Rdbms\DatabaseSqlite)
   - IDatabase (use Wikimedia\Rdbms\IDatabase)
   - FakeResultWrapper (use Wikimedia\Rdbms\FakeResultWrapper)
   - ResultWrapper (use Wikimedia\Rdbms\ResultWrapper)
* The following old, deprecated aliases for classes have now been removed:
   - MediaWiki\Rest\Handler\HtmlInputTransformHelper
   - MediaWiki\Rest\Handler\HtmlMessageOutputHelper
   - MediaWiki\Rest\Handler\HtmlOutputRendererHelper
   - MediaWiki\Rest\Handler\PageContentHelper
   - MediaWiki\Rest\Handler\PageRestHelperFactory
   - MediaWiki\Rest\Handler\ParsoidFormatHelper
   - MediaWiki\Rest\Handler\RevisionContentHelper
  (use the classes from namespace MediaWiki\Rest\Handler\Helper)
   - SearchNearMatcher (use MediaWiki\Search\TitleMatcher)
* $CHANGEDORCREATED argument of 'enotif_body' message was removed.
  It wasn't used in the default messages since 1.21.
* The AbstractBlock and DatabaseBlock public properties mExpiry, mHideName,
  mTimestamp, mAuto and mParentBlockId, deprecated since 1.34, have been
  removed.
* WikiPage::doDeleteUpdates() and ::getDeletionUpdates(), deprecated in 1.37,
  have been removed.
* The User public properties mOptions, mBlock, mBlockedby and mHideName,
  deprecated since 1.35, were removed.
* User::CHECK_USER_RIGHTS and User::IGNORE_USER_RIGHTS were removed. They were
  flags passed to methods which were previously removed.
* All public properties of LinksUpdate, deprecated in 1.38, were removed.
* The class Wikimedia\Rdbms\MySQLMasterPos, deprecated in 1.37, has been
  removed. Use Wikimedia\Rdbms\MySQLPrimaryPos instead.
* The class GetBlockErrorMessageKey, deprecated in 1.40, has been removed.
* The ability to set Parser::mTitle to null, deprecated in 1.34, was removed.
* The following MagicWord methods have been removed without deprecation. There
  were no known uses.
  - ::addToArray
  - ::compareStringLength
  - ::getVariableRegex
  - ::getVariableStartToEndRegex
  - ::getWasModified
  - ::matchStart
  - ::matchVariableStartToEnd
  - ::pregRemoveAndRecord
  - ::substituteCallback
* The following MagicWordArray methods have been removed or made private without
  deprecation. There were no known uses outside of the class.
  - ::addArray
  - ::getRegex, already marked as @internal, now private
  - ::getRegexStart, already marked as @internal, now private
  - ::getVariableRegex, deprecated since 1.36
  - ::getVariableStartToEndRegex, already marked as @internal, now private
  - ::parseMatch, now private
* AbstractContent::getRedirectChain() and ::getUltimateRedirectTarget(), both
  deprecated in 1.38, have been removed.

=== Deprecations in 1.41 ===
* The MessageCache::get hook is deprecated for performance reasons. Use
  MessageCacheFetchOverrides instead.
* EtcdConfig::setLogger() is deprecated as it was unused and could not be
  used correctly. As a standalone class, its warnings now surface
  unconditionally via the native PHP error log.
* The interface for hook ParserModifyImageHTML have been renamed from
  ParserModifyImageHTML to ParserModifyImageHTMLHook,
  the old name is deprecated.
* (T178356) The es6-polyfills module is deprecated and is now a no-op.
* SerializedValueContainer::newUnified() is unused and now emits deprecation
  warnings.
* Profiler::setProfileID() and ::getAllowOutput() are now deprecated and also
  emit deprecation warnings. For ::setProfileID(), override the related class
  member directly in sub-class.
* (T166010) All PHP code in MediaWiki is slowly being moved to be in a class
  namespace as appropriate, so that we can use PSR-4 auto-loading, which will
  speed up general code loading of MediaWiki. The old global namespace class
  names are being left behind as deprecated aliases.

  In this release of MediaWiki, 1661 classes now have a namespace and 972 do
  not yet (63% done, up from 54% in MediaWiki 1.40.0). The following have newly
  been moved:
  - MediaWiki\Config:
    - Config
    - ConfigException
    - ConfigFactory
    - EtcdConfig
    - EtcdConfigParseError
    - GlobalVarConfig
    - HashConfig
    - MultiConfig
    - MutableConfig
    - SiteConfiguration
  - MediaWiki\EventRelayer:
    - EventRelayer
    - EventRelayerNull
    - EventRelayerGroup
  - MediaWiki\Installer:
    - Pingback
  - MediaWiki\Libs:
    - Emptiable
  - MediaWiki\Output:
    - OutputPage
    - OutputHandler
    - StreamFile
  - MediaWiki\Pager:
    - ActiveUsersPager
    - AllMessagesTablePager
    - AlphabeticPager
    - BlockListPager
    - CategoryPager
    - ContribsPager
    - DeletedContribsPager
    - HistoryPager
    - ImageListPager
    - IndexPager
    - LogPager
    - MergeHistoryPager
    - NewFilesPager
    - NewPagesPager
    - Pager
    - PagerTools
    - ProtectedPagesPager
    - ProtectedTitlesPager
    - RangeChronologicalPager
    - ReverseChronologicalPager
    - TablePager
    - UsersPager
  - MediaWiki\Parser:
    - Sanitizer
  - MediaWiki\Request:
    - ProxyLookup
    - WebRequest
  - MediaWiki\SiteStats:
    - SiteStats
    - SiteStatsInit
  - MediaWiki\Specials:
    - SpecialActiveUsers
    - SpecialAllMessages
    - SpecialAncientPages
    - SpecialApiHelp
    - SpecialApiSandbox
    - SpecialAutoblockList
    - SpecialBlankpage
    - SpecialBlock
    - SpecialBlockList
    - SpecialBookSources
    - SpecialBotPasswords
    - SpecialBrokenRedirects
    - SpecialCategories
    - SpecialChangeContentModel
    - SpecialChangeCredentials
    - SpecialChangeEmail
    - SpecialChangePassword
    - SpecialComparePages
    - SpecialConfirmEmail
    - SpecialContribute
    - SpecialContributions
    - SpecialCreateAccount
    - SpecialDeadendPages
    - SpecialDeletePage
    - SpecialDeletedContributions
    - SpecialDiff
    - SpecialDoubleRedirects
    - SpecialEditPage
    - SpecialEditTags
    - SpecialEditWatchlist
    - SpecialEmailInvalidate
    - SpecialEmailUser
    - SpecialExpandTemplates
    - SpecialExport
    - SpecialFewestRevisions
    - SpecialFileDuplicateSearch
    - SpecialFilepath
    - SpecialGoToInterwiki
    - SpecialImport
    - SpecialJavaScriptTest
    - SpecialLinkAccounts
    - SpecialLinkSearch
    - SpecialListDuplicatedFiles
    - SpecialListFiles
    - SpecialListGrants
    - SpecialListGroupRights
    - SpecialListRedirects
    - SpecialListUsers
    - SpecialLockdb
    - SpecialLog
    - SpecialLonelyPages
    - SpecialLongPages
    - SpecialMIMESearch
    - SpecialMediaStatistics
    - SpecialMergeHistory
    - SpecialMostCategories
    - SpecialMostInterwikis
    - SpecialMostLinked
    - SpecialMostLinkedCategories
    - SpecialMostLinkedTemplates
    - SpecialMostRevisions
    - SpecialMute
    - SpecialMyLanguage
    - SpecialNewFiles
    - SpecialNewPages (and capitalisation corrected)
    - SpecialNewSection
    - SpecialPageData
    - SpecialPageHistory
    - SpecialPageInfo
    - SpecialPageLanguage
    - SpecialPagesWithProp
    - SpecialPasswordPolicies
    - SpecialPasswordReset
    - SpecialPermanentLink
    - SpecialPreferences
    - SpecialPrefixIndex (and capitalisation corrected)
    - SpecialProtectedPages (and capitalisation corrected)
    - SpecialProtectedTitles (and capitalisation corrected)
    - SpecialProtectPage
    - SpecialPurge
    - SpecialRandomInCategory
    - SpecialRandom
    - SpecialRandomRedirect
    - SpecialRandomRootPage
    - SpecialRecentChanges
    - SpecialRecentChangesLinked
    - SpecialRedirect
    - SpecialRedirectToSpecial
    - SpecialRemoveCredentials
    - SpecialRenameUser (and capitalisation corrected)
    - SpecialResetTokens
    - SpecialRevisionDelete
    - SpecialRunJobs
    - SpecialSearch
    - SpecialShortPages
    - SpecialSpecialPages (and capitalisation corrected)
    - SpecialStatistics
    - SpecialTags
    - SpecialTrackingCategories
    - SpecialUnblock
    - SpecialUncategorizedCategories
    - SpecialUncategorizedImages
    - SpecialUncategorizedPages
    - SpecialUncategorizedTemplates
    - SpecialUndelete
    - SpecialUnlinkAccounts
    - SpecialUnlockdb
    - SpecialUnusedCategories
    - SpecialUnusedImages
    - SpecialUnusedTemplates
    - SpecialUnwatchedPages
    - SpecialUpload
    - SpecialUploadStash
    - SpecialUserLogin
    - SpecialUserLogout
    - SpecialVersion
    - SpecialWantedCategories
    - SpecialWantedTemplates
    - SpecialWatchlist
    - SpecialWhatLinksHere
    - SpecialWithoutInterwiki
  - MediaWiki\Specials\Redirects:
    - SpecialAllMyUploads
    - SpecialListAdmins
    - SpecialListBots
    - SpecialMycontributions
    - SpecialMylog
    - SpecialMypage
    - SpecialMytalk
    - SpecialMyuploads
  - MediaWiki\SpecialPage:
    - AuthManagerSpecialPage
    - ChangesListSpecialPage
    - DisabledSpecialPage
    - FormSpecialPage
    - ImageQueryPage
    - IncludableSpecialPage
    - LoginSignupSpecialPage
    - PageQueryPage
    - QueryPage
    - RedirectSpecialArticle
    - RedirectSpecialPage
    - SpecialPage
    - SpecialRedirectToSpecial
    - SpecialRedirectWithAction
    - UnlistedSpecialPage
    - WantedQueryPage
  - MediaWiki\Status:
    - Status
  - MediaWiki\Title:
    - ForeignTitle
    - ForeignTitleFactory
    - ImportTitleFactory
    - MalformedTitleException
    - MediaWikiTitleCodec
    - NaiveForeignTitleFactory
    - NaiveImportTitleFactory
    - NamespaceAwareForeignTitleFactory
    - NamespaceImportTitleFactory
    - NamespaceInfo
    - SubpageImportTitleFactory
    - TitleFormatter
    - TitleParser
    - TitleValue
  - MediaWiki\User:
    - BotPassword
    - ExternalUserNames
    - LoggedOutEditToken
    - PasswordReset
    - User
    - UserArray
    - UserArrayFromResult
    - UserGroupMembership
    - UserRightsProxy
  - MediaWiki\User\CentralId:
    - CentralIdLookup
    - LocalIdLookup
  - MediaWiki\Utils:
    - MWTimestamp
    - GitInfo
    - ExtensionInfo (previously under MediaWiki\ExtensionInfo)
  - Wikimedia\Rdbms:
    - ConfiguredReadOnlyMode
    - ReadOnlyMode
* Various mediawiki.ui variables have been deprecated in favor of
  'mediawiki.skin.variables.less' Codex design tokens featuring replacements.
* Hook handlers must now be specified either as a PHP callable, or as a PHP
  object that has a method matching the hook name. Other ways to specify
  the handler are deprecated and will soon be removed. Deprecated ways to
  specify a hook handler include callables wrapped in an array. Handlers
  defined using a "HookHandlers" entry in extension.json are not affected.
* TitleArray::newFromResult() has been deprecated and now emits deprecation
  warnings, use TitleArrayFromResults instead.
* The MediaWikiIntegrationTestCase::$users has been deprecated. Use Authority
  if possible, or call ::getTestUser() or ::getTestSysop() directly.
* WebRequest::isSafeRequest() and ::markAsSafeRequest() has been deprecated
  and now emits deprecation warnings. Use ::hasSafeMethod() instead.
* The tests/phpunit/phpunit.php entrypoint has been deprecated. PHPUnit
  tests should be run with composer, for example with the
  `composer phpunit:entrypoint` command.
* The unnamespace UserNamePrefixSearch class, deprecated in 1.36, now emits
  deprecation warnings. Use the MediaWiki\User\UserNamePrefixSearch service.
* The jquery.cookie ResourceLoader module has been merged into the existing
  mediawiki.cookie module; jquery.cookie remains but is deprecated.
* Passing a database to DatabaseBlockStore::insertBlock() is deprecated.
  DatabaseBlockStoreFactory should be used to fetch a correct
  DatabaseBlockStore instead.
* The global function wfGetLangObj is deprecated and emits deprecation
  warnings. Use MediaWiki\Languages\LanguageFactory::getLanguage instead.
* The SwiftVirtualRESTService class is deprecated in 1.41 and now emits
  deprecation warnings.
* SqlBagOStuff::expireAll() is deprecated and now emits deprecation warnings,
  use SqlBagOStuff::deleteObjectsExpiringBefore() instead.
* SqlBagOStuff::deleteAll() is deprecated and now emits deprecation warnings.
* Passing an actor id to the UserIdentityValue constructor is now emits
  deprecation warnings, it is deprecated since 1.36.
* UserGroupMembership::getGroupName(), deprecated in 1.38, and
  UserGroupMembership::getGroupMemberName(), deprecated in 1.40, now emit
  deprecation warnings.
* UserGroupMembership::getLink() has been deprecated in favour of
  ::getLinkHTML() and ::getLinkWiki().
* Linker::formatComment(), ::formatLinksInComment(), ::commentBlock() and
  ::revComment(), deprecated in 1.38, now emit deprecation warnings.
* PageArchive::listRevisions(), ::getRevisionRecordByTimestamp(),
  ::getArchivedRevisionRecord(), ::getPreviousRevisionRecord(),
  ::getLastRevisionId() and ::isDeleted(), deprecated in 1.38,
  now emit deprecation warnings.
* SearchResultThumbnail::getSize() has been deprecated to be dropped in the
  future as it is resource intensive and degrades performance.
* The EmailUserPermissionsErrors and UserCanSendEmail hooks have been
  deprecated in favour of the EmailUserAuthorizeSend hook.
* The EmailUser hook has been deprecated in favour of the EmailUserSendEmail
  hook.
* The InterwikiLoadPrefix hook now emits deprecation warnings. Resetting the
  $wgInterwikiCache setting instead.
* SiteConfiguration::getConfig() now emits deprecation warnings, Use ::get()
  instead.
* SiteConfiguration::extractVar() and ::extractGlobal() have been deprecated
  and also emit deprecation warnings.
* JobQueueGroup::waitForBackups() is deprecated. JobQueue::waitForBackups()
  should be used instead.
* Hooks::isRegistered(), ::getHandlers(), ::run() and ::runWithoutAbort(),
  deprecated in 1.35, now emit deprecation warnings.
* VirtualRESTService class and its subclasses now emit deprecation warnings
  in 1.41 and as a replacement we can use MultiHttpClient.
* Calling the MediaWikiServices::getVirtualRESTServiceClient() function
  which creates the VirtualRESTServiceClient now emits deprecation warnings.
* Language::getMessage and Language::getAllMessages are deprecated. Use
  LocalisationCache or MessageCache as appropriate.
* VirtualRESTService class is deprecated in 1.41 and as a replacement
  we can use MultiHttpClient.
* MediaWikiServices::getConfiguredReadOnlyMode() is deprecated. Use
  ::getReadOnlyMode() instead. ReadOnlyMode::getConfiguredReason()
  and ::isConfiguredReadOnly() has been added to support that.
* UploadBase::isThrottled() has been deprecated and is emitting deprecation
  warnings. Rate limits are enforced by UploadBase::verifyTitlePermissions(),
  since rate limit checks are now implicit in permission checks.
* JobSpecification::toSerializableArray() now emits deprecation warnings.
* The following skin methods were deprecated:
  - Skin::makeSpecialUrl (use Title or Special class instead)
  - Skin::makeSpecialUrlSubpage (use Title or Special class instead)
* mw.jqueryMsg.parser, deprecated in 1.31, now emits deprecation warnings.
* ResourceLoader (T127268): The targets system is deprecated. Modules that
  have been marked as desktop or mobile only are no longer supported and
  will send deprecation warnings.
* TextSlotDiffRenderer::setLanguage() is deprecated, and calling it will
  have no effect. Use ContentHandler::getSlotDiffRenderer(), or in subclasses,
  ContentHandler::createTextSlotDiffRenderer(), to correctly inject
  dependencies into TextSlotDiffRenderer.
* The static methods encodeJsVar() and encodeJsCall() have been moved from the
  Xml class to the more appropriate MediaWiki\Html\Html one, and the old ones
  are now deprecated.
* Some work to rename classes was done in previous releases, but the renaming
  was not noted at the time. The old aliases work for now but are deprecated;
  this is now explicitly noted:
  From 1.40:
  - Category -> MediaWiki\Category\Category
  - CategoriesRdf -> MediaWiki\Category\CategoriesRdf
  - CategoryViewer -> MediaWiki\Category\CategoryViewer
  - TrackingCategories -> MediaWiki\Category\TrackingCategories
  - CommentStore -> MediaWiki\CommentStore\CommentStore
  - CommentStoreComment -> MediaWiki\CommentStore\CommentStoreComment
  - EditPage -> MediaWiki\EditPage\EditPage
  - TemplatesOnThisPageFormatter
    -> MediaWiki\EditPage\TemplatesOnThisPageFormatter
  - LinkFilter -> MediaWiki\ExternalLinks\LinkFilter
  - AtomFeed -> MediaWiki\Feed\AtomFeed
  - ChannelFeed -> MediaWiki\Feed\ChannelFeed
  - FeedItem -> MediaWiki\Feed\FeedItem
  - FeedUtils -> MediaWiki\Feed\FeedUtils
  - RSSFeed -> MediaWiki\Feed\RSSFeed
  - Html -> MediaWiki\Html\Html
  - FormOptions -> MediaWiki\Html\FormOptions
  - HtmlHelper -> MediaWiki\Html\HtmlHelper
  - ListToggle -> MediaWiki\Html\ListToggle
  - TemplateParser -> MediaWiki\Html\TemplateParser
  - RawMessage -> MediaWiki\Language\RawMessage
  - FileDeleteForm -> MediaWiki\Page\File\FileDeleteForm
  - MergeHistory -> MediaWiki\Page\File\MergeHistory
  - MovePage -> MediaWiki\Page\File\MovePage
  - ProtectionForm -> MediaWiki\Page\File\ProtectionForm
  - MediaWiki\BadFileLookup -> MediaWiki\Page\File\BadFileLookup
  - PageProps -> MediaWiki\Page\PageProps
  - MagicWord -> MediaWiki\Parser\MagicWord
  - MagicWordArray -> MediaWiki\Parser\MagicWordArray
  - MagicWordFactory -> MediaWiki\Parser\MagicWordFactory
  - Linker -> MediaWiki\Linker\Linker
  - DummyLinker -> MediaWiki\Linker\DummyLinker
  - ForkController -> MediaWiki\Maintenance\ForkController
  - OrderedStreamingForkController
    -> MediaWiki\Maintenance\OrderedStreamingForkController
  - ContentSecurityPolicy -> MediaWiki\Request\ContentSecurityPolicy
  - DerivativeRequest -> MediaWiki\Request\DerivativeRequest
  - FauxRequest -> MediaWiki\Request\FauxRequest
  - FauxRequestUpload -> MediaWiki\Request\FauxRequestUpload
  - PathRouter -> MediaWiki\Request\PathRouter
  - WebRequestUpload -> MediaWiki\Request\WebRequestUpload
  - FauxResponse -> MediaWiki\Request\FauxResponse
  - WebResponse -> MediaWiki\Request\WebResponse
  - MediaWiki\HeaderCallback -> MediaWiki\Request\HeaderCallback
  - StubObject -> MediaWiki\StubObject\StubObject
  - DeprecatedGlobal -> MediaWiki\StubObject\DeprecatedGlobal
  - StubGlobalUser -> MediaWiki\StubObject\StubGlobalUser
  - StubUserLang -> MediaWiki\StubObject\StubUserLang
  - Title -> MediaWiki\Title\Title
  - TitleArray -> MediaWiki\Title\TitleArray
  - TitleArrayFromResult -> MediaWiki\Title\TitleArrayFromResult
  - TitleFactory -> MediaWiki\Title\TitleFactory
  - ActorMigration -> MediaWiki\User\ActorMigration
  - ActorMigrationBase -> MediaWiki\User\ActorMigrationBase
  - WikiMap -> MediaWiki\WikiMap\WikiMap
  - WikiReference -> MediaWiki\WikiMap\WikiReference
  From 1.39:
  - ResourceLoader -> MediaWiki\ResourceLoader\ResourceLoader
  From 1.29:
  - IMaintainableDatabase -> Wikimedia\Rdbms\IMaintainableDatabase
* The WebRequest::getRequestId() and WebRequest::overrideRequestId() are
  deprecated. Use methods from MediaWiki\Http\Telemetry class instead.
* The XmlJsCode wrapper class has been renamed to MediaWiki\Html\HtmlJsCode,
  and the old name is now deprecated.
* The use of non-serializable arguments to ParserOutput::addWarningMsg() has
  been deprecated and will emit deprecation warnings.
* Class UserRightsProxy, deprecated since 1.38, now emits
  deprecation warnings from its factory functions.
* MediaWiki\ResourceLoader\Module::getDeprecationInformation() is deprecated.
  Use ::getDeprecationWarning() instead.
* Passing a Message to OutputPage::setPageTitle() is deprecated.
  Use ::setPageTitleMsg() instead (which escapes HTML metacharacters).
* Passing arguments to OutputPage::prepareErrorPage() is deprecated.
  Use explicit calls to OutputPage::setPageTitleMsg() and ::setHTMLTitle()
  instead.
* Returning a string from Action::getPageTitle() is deprecated;
  return a Message instead, which will be formatted using FORMAT_ESCAPED.
* Returning a string from SpecialPage::getDescription() is deprecated;
  return a Message instead, which will be formatted using FORMAT_ESCAPED.
* MediaWiki\Block\AbstractBlock::getReason(), deprecated since 1.35, now emits
  deprecation warnings. Use ::getReasonComment() instead.
* User::getGroups(), ::addGroup(), ::removeGroup(), ::getGroupMemberships(),
  ::getAllGroups(), ::getImplicitGroups(), deprecated since 1.35, now emit
  deprecation warnings.
* The global function wfReportTime(), deprecated since 1.40, now emits
  deprecation warnings. The SkinTemplate parameter 'reporttime' is deprecated.
* RevisionStore::getQueryInfo() and RevisionFactory::getQueryInfo() have been
  deprecated. Use ::newSelectQueryBuilder() instead.
* Following methods in rdbms library have been made internal:
  - IDatabase::getLBInfo()
  - IDatabase::setLBInfo()
  - IDatabase::insert() Use InsertQueryBuilder instead.
  - IDatabase::update() Use UpdateQueryBuilder instead.
  - IDatabase::replace() Use ReplaceQueryBuilder instead.
  - IDatabase::upsert() Use InsertQueryBuilder instead.
  - IDatabase::delete() Use DeleteQueryBuilder instead.
  - IReadableDatabase::selectField() Use SelectQueryBuilder instead.
  - IReadableDatabase::selectFieldValues() Use SelectQueryBuilder instead.
  - IReadableDatabase::select() Use SelectQueryBuilder instead.
  - IReadableDatabase::selectRow() Use SelectQueryBuilder instead.
  - IReadableDatabase::estimateRowCount() Use SelectQueryBuilder instead.
  - IReadableDatabase::selectRowCount() Use SelectQueryBuilder instead.
  - ISQLPlatform::unionQueries() Use UnionQueryBuilder instead.
* The core Wikimedia\Rdbms\DatabaseMysqlBase class has been renamed to reflect
  the earlier merger of Mysqli into it; it's now Wikimedia\Rdbms\DatabaseMySQL.
* The following methods in SpecialEmailUser have been deprecated:
  - SpecialEmailUser::validateTarget(), use EmailUser::validateTarget()
  - SpecialEmailUser::getPermissionsError(), use EmailUser::canSend() or
    EmailUser::authorizeSend()
  - SpecialEmailUser::submit(), use EmailUser::sendEmailUnsafe()
* User::isBlockedFromEmailuser() has been deprecated. EmailUser::canSend()
  checks blocks amongst other things. If you only need this check, use
  User::getBlock()->appliesToRight( 'sendemail' ).
* User::canSendEmail() has been deprecated. Use EmailUser::canSend() instead.
* The following methods, previously deprecated, now emit deprecation warnings:
  - ConfigFactory::getDefaultInstance(), deprecated since 1.27
  - AbstractContent::getNativeData(), deprecated since 1.33
  - TablePager::getBody(), deprecated since 1.24
  - ContentHandler::getSlotDiffRendererInternal(), deprecated since 1.35
  - ParserOutput::getCategories(), deprecated since 1.40
  - PasswordFactory::init(), deprecated since 1.32
* WikitextContent::getRedirectTargetAndText has been deprecated, use
  WikitextContentHandler::extractRedirectTargetAndText instead.
* WikiPage::doDeleteArticleBatched, deprecated in 1.37, now emits deprecation
  warnings.
* WikiPage::getPageIsRedirectField() is now deprecated.
* WikiPage::insertRedirect() is now deprecated.
* Parser::getFreshParser(), deprecated since 1.39, now emits deprecation
  warnings.
* The legacy MediaWiki UI ResourceLoader modules, such as `mediawiki.ui`, are
  all now emitting deprecation warnings in the JavaScript console. Please use
  Codex CSS components instead.
* Article::getRedirectHeaderHtml() has been deprecated and emits deprecation
  warnings, use LinkRenderer::makeRedirectHeader() instead.
* SpecialBlock::getTargetAndType(), deprecated since 1.36, now emits deprecation
  warnings.
* ApiBase::checkTitleUserPermissions() now type-forces a PageIdentity instead of
  a LinkTarget. Passing a LinkTarget has been deprecated since 1.36.
* Passing a User to ApiBase::checkUserRightsAny() in the second parameter, which
  was deprecated in 1.36, is no longer read. Instead, it will use the request
  context's set Authority via IContextSource::getAuthority().
* Sanitizer::escapeIdReferenceList(), deprecated since 1.36, has been dropped.
* RecentChange::getPerformer(), deprecated since 1.36, has been dropped.
* SpecialPage::getLanguageConverter(), deprecated since 1.36, has been dropped.
  Use LanguageConverterFactory::getLanguageConverter() directly.
* SpecialBlock::checkUnblockSelf(), deprecated since 1.36, has been dropped. Use
  BlockPermissionChecker instead.
* DifferenceEngine::localiseLineNumbers() has been deprecated in favor of
  BaseTextDiffer::localizeLineNumbers(). Subclasses such as PhpTextDiffer may
  make this available via a ::localize() method.
* ChangeTags::modifyDisplayQuery() and ChangeTagsStore::modifyDisplayQuery()
  have been deprecated in favor of ChangeTagsStore::modifyDisplayQueryBuilder()
* Calling SpecialRandomPage::__construct without services as parameters is
  deprecated and emit deprecation warnings.

=== Other changes in 1.41 ===
* ExternalLinksLookup::getExternalLinksForPage() now exists to centralize
  logic of looking up externallinks rows.
* The update script no longer accepts the --skip-compat-checks option.
* Use of the deprecated "Pragma: no-cache" HTTP response header on uncachable
  responses has been removed in favour of "Cache-Control: no-cache" (T345420).
* Type hints were added to:
   - The return value of WebRequest:: and DerivativeRequest::getSession()
   - The return value of WebRequest:: and DerivativeRequest::getIP()
   - The return value of User::getTitleKey()
   - The return value of User::getRequest()
   - The `$key` parameter to Skin::normalizeKey()
  None of the methods whose return value was updated belongs to a class
  stable to extend, and adding type hints to parameters is backwards
  compatible. Therefore, this is not considered a breaking change.
* The mergeMessageFileList script now only works for extensions and skins
  supporting extension registration (using extension.json or skin.json).
  It will no longer attempt to load PHP entry points.
* Parser will no longer fall back to $wgTitle if a null is provided as a
  Title or PageReference. To change the relevant title used for methods
  that do not offer an option to set the page, call Parser::setPage.
  This affects the methods cleanSig, getSection and replaceSection.
* (T347726, CVE-2023-51704) SECURITY: logging: Fix non-escaped messages
  used in rights log.

== Compatibility ==

MediaWiki 1.41 requires PHP 7.4.3 or later and the following PHP extensions:

* ctype
* dom
* fileinfo
* iconv
* intl
* json
* mbstring
* xml

MariaDB is the recommended database software. MySQL, PostgreSQL, or SQLite can
be used instead, but support for them is somewhat less mature.

The supported versions are:

* MariaDB 10.3 or higher
* MySQL 5.7.0 or higher
* PostgreSQL 10 or later
* SQLite 3.8.0 or later

== Online documentation ==
Documentation for both end-users and site administrators is available on
MediaWiki.org, and is covered under the GNU Free Documentation License (except
for pages that explicitly state that their contents are in the public domain):

       https://www.mediawiki.org/wiki/Special:MyLanguage/Documentation

== Mailing list ==
A mailing list is available for MediaWiki user support and discussion:

       https://lists.wikimedia.org/mailman/listinfo/mediawiki-l

A low-traffic announcements-only list is also available:

       https://lists.wikimedia.org/mailman/listinfo/mediawiki-announce

It's highly recommended that you sign up for one of these lists if you're
going to run a public MediaWiki, so you can be notified of security fixes.

== IRC help ==
There's usually someone online in #mediawiki on irc.libera.chat.

= MediaWiki 1.40 =

PHP 8.0 workboard: https://phabricator.wikimedia.org/tag/php_8.0_support/
PHP 8.1 workboard: https://phabricator.wikimedia.org/tag/php_8.1_support/
PHP 8.2 workboard: https://phabricator.wikimedia.org/tag/php_8.2_support/
PHP 8.3 workboard: https://phabricator.wikimedia.org/tag/php_8.3_support/

== MediaWiki 1.40.4 ==

This is a maintenance release of the MediaWiki 1.41 branch.

=== Changes since MediaWiki 1.40.3 ===
* Localisation updates.
* tests: Skip failing tests on php8.2 (and make pass).
* (T326480) ApiResult: Make array ordering consistent across PHP versions.
* (T352789, T287972) build: Raise TestingAccessWrapper from 2.0.0 to 3.0.0.
* (T326478) tests: Create new classes to hold dynamic properties in auth tests.
* (T326478) tests: Avoid dynamic properties in AuthenticationProvider Test.
* tests: Skip failing tests on php8.3 (and make pass).
* (T326466) Introduce and use DynamicPropertyTestHelper.
* (T352910) tests: Use TestingAccessWrapper::newFromClass in session tests.
* (T326478) tests: Avoid dynamic properties in SessionManagerTest.
* ArticleTest: Skip testGetOrSetOnNewProperty() if PHP >= 8.2.
* (T326478) tests: Avoid dynamic properties in auth tests.
* tests: Remove dead code from WikiPageDbTest::assertPreparedEditNotEquals.
* (T326479, T361985) StatusValue: Allow passing arbitrary data to augment
  result.
* (T357760) Use i18n strings for truncated subpage message in SpecialMovePage.
* debug: Update PsySH 0.11.1 -> 0.12.3.
* (T361991) Fix slash-delimited regex from CLI on maintenence/grep.php.
* (T352695) tests: Only set $dbSetup if setupTestDB() ends without throwing.
* (T362272) api: Replace null $httpCode by 0 in ApiBase::dieWithErrorOrDebug.
* (T150647, T216682) Make EncryptedPassword work with Argon2Password.
* (T364270) Fix long param names overlapping docs in API help pages.
* wrapOldPasswords: Improve progress output and decrease batch size.
* (T361367) ApiFeedWatchlist: Fix handling of array parameters.
* (T366130) EncryptedPassword: Store default parameters as strings.
* Name the PagerTools array entries to allow hooks to unset them.
* (T302186) Add title cache for Title::newMainPage().

== MediaWiki 1.40.3 ==

This is a security and maintenance release of the MediaWiki 1.40 branch.

=== Changes since MediaWiki 1.40.2 ===
* Localisation updates.
* (T296896) CategoryViewer::getSectionPagingLinks: Fix null array offset
  warning.
* CategoryViewer: Fix "count(): Argument #1 ($value) must be of type
  Countable|array, null given".
* (T334992) Headings in the license pickers should not be selected.
* (T353929) ActiveUsersPager: Count actions only once.
* composer: Use @php instead of php.
* (T326065) Indent JsonContent using tabs.
* (T309714, T354274) mime: Add support for 'font/woff' and 'font/woff2' mime
  type.
* (T353644) Update wikimedia/parsoid to 0.17.3.
* (T354541) authmanager: Improve AuthenticationRequest docs.
* (T330428) ForeignResourceManager: Add trailing newline in validateLicense.
* (T355017) Add missing space in Special:RecentChangesLinked.
* (T355003) composer.json Add ext-bcmath and ext-gmp to suggests.
* PHPVersionCheck: Update text to match currently supported upstream PHP
  versions (8.1+).
* (T354045) API: mark HTML output as non-cacheable.
* (T355530) filerepo: Fix img_major_mime for files with a non-standard
  extensions.
* (T355530) MimeAnalyzer: Add @since to isValidMajorMimeType.
* (T352554) ZhConverter: Fix language variant fallback chain.
* (T357668) Parser::getExternalLinkAttribs: Don't set rel attribute to null.
* LockManagerGroupIntegrationTest: Remove test depending on DBLockManager.
* (T357808) LinkRendererTest: Add missing import for LinkTarget.
* (T353305) ApiResetPassword: Allow both user and email parameters to be passed
  for reset.
* (T358949) updateCollation: Explicitly cast $scale to int.
* (T359055) api: Improve linking of language codes lists in top level i18n
  messages.
* (T359294) Make sure MovePage::isValidFileMove matches UploadBase::getTitle.
* (T230245) Respect $maxConcurrency when queuing async FileOps.
* (T352554) Follow-up "ZhConverter: Fix language variant fallback chain".
* (T359139) Restore ability to disable footer links with "-".
* (T292237, T317451) build: Restore Doxygen output for MediaWiki release tags.
* (T324903) HistoryPager: Add #[AllowDynamicProperties].
* (T360850) Update Apache config syntax in .htaccess files.
* (T309714) mime: Make test cases use data provider.
* (T317489, T319202) Mark some parserTests on talk pages Parsoid only on
  REL1_40.
* Update wikimedia/parsoid to 0.17.4.
* docs: Remove use of $IP from mwdocgen.php.
* (T317451) build: Restore Doxygen output for MediaWiki release tags (take 3).
* docs: Set stable permalink on markdown files.
* (T357019) allow maintenance/deleteBatch.php to accept page ID.
* (T355538, CVE-2024-34507) SECURITY: XSS in edit summary parser.
* (T357760, CVE-2024-34506) SECURITY: Denial of service vector via GET request
  to Special:MovePage on pages with thousands of subpages.

== MediaWiki 1.40.2 ==

This is a security and maintenance release of the MediaWiki 1.40 branch.

=== Changes since MediaWiki 1.40.1 ===
* Localisation updates.
* Updated symfony/polyfill-php80 from 1.27.0 to 1.28.0.
* Updated symfony/polyfill-php81 from 1.27.0 to 1.28.0.
* (T344912) mail: Encode period (ascii 46) if it appears in encoded email
  header.
* Added symfony/polyfill-php82.
* Added symfony/polyfill-php83.
* Updated symfony/yaml from 5.4.17 to 5.4.23.
* Updated wikimedia/timestamp from 4.1.0 to 4.1.1.
* tests: Provide coverage for StatusValue::__toString.
* StatusValue: Improve logging/debug output with multibyte characters.
* (T347726, CVE-2023-51704) SECURITY: logging: Fix non-escaped messages
  used in rights log.
* Updated wikimedia/parsoid from 0.17.0 to 0.17.1.
* (T229992) LocalisationCache: Preserve fallback source language info.
* (T340840) Title: Check local fallbacks for system message.
* (T346332) Installer: Make Minerva works correctly for $wgDefaultSkin.
* specials: Use options-messages on Special:RevisionDelete.
* Fix use of buildComparison() in uppercaseTitlesForUnicodeTransition.php.
* (T275085) Fix logging Status objects to 'authevents' channel.
* (T341310) DEVELOPERS.md: mention git clone and WSL.
* (T351758) DEVELOPERS.md: reword WSL instructions to include best practices.
* (T350615) PoolCounterConnectionManager: Add support for ipv6.
* ParsoidCachePrewarmJob::newSpec() now requires a PageRecord as the second
  parameter instead of a page ID.
* (T341123) ParsoidCachePrewarmJob: enable deduplication.
* (T349115) LocalisationCache: Fix a rare case in fallback source language.
* (T351848) language: Avoid multiple signs in Language::userAdjust.
* SwiftFileBackend: Fix "PHP Deprecated: strlen(): Passing null to parameter #1
  ($string) of type string is deprecated".
* maintenance: Add missing parenthesis to SQL in attachLatest.php.
* (T321234) Make MagicWordArray not fail on old revs with broken UTF-8.
* thumb: Fix "PHP Deprecated: strlen(): Passing null to parameter".
* (T327007) htmlform: Correct validation for file input field.

== MediaWiki 1.40.1 ==

This is a security and maintenance release of the MediaWiki 1.40 branch.

=== Changes since MediaWiki 1.40.0 ===
* Localisation updates.
* (T333050, CVE-2023-45363) SECURITY: Fix infinite loop for self-redirects
  with variants conversion.
* docs: Fix a few typos in MainConfigSchema.
* (T290464) Add DiscussionTools bundling to release notes.
* (T309714) mime: Add support for 'font/sfnt' mime type.
* (T341434) WikiImporter: Improve error message output.
* (T341737) ApiBase: Cast $id to string in filterIDs.
* (T286291, T296188) Merge zh and zh-tw namespace translations back to zh-hans,
  zh-hant, zh-hk respectively.
* (T337875) WRStats: Round up SequenceSpec::hardExpiry to the nearest integer.
* (T237898) installer: Check MariaDB version in updater/installer.
* (T342632) ApiComparePages: Add help url.
* (T326182, T324903) EditPage: Add #[AllowDynamicProperties].
* (T342351) rdbms: Fix postgres db function call.
* (T343675) user: Use {@} to escape annotation when writting about annotation.
* (T343797) LanguageWa: Fix double timezone adjustment.
* (T343669) skins: Avoid function call on array.
* (T326454) Update pear/mail to 1.5.1.
* (T343622) docs: Set the <comment> tag back to optional.
* (T330528) Upgrade wikimedia/html-formatter from 3.0.1 to 4.0.3.
* Updated jQuery from v3.6.1 to v3.7.1.
* (T337463) wdio-mediawiki: await saveScreenshot.
* (T208477) $wgPrivilegedGroups – Users belonging in some of the listed groups
  will be audited more aggressively.
* doc: Improve description of "type" in extension.schema.v2.json.
* Added PrivilegedGroups attribute for extension.json / skin.json, which lets
  you add any new user groups you define to wgPrivilegedGroups (see above).
* (T288624) MultiHttpClient: Unset $this->cmh after closing it.
* (T345039) Do not run SkinAfterBottomScripts hook twice unconditionally.
* (T265734) API Help: Note that parameters may be inherited from other context.
* (T285545) i18n: Split apihelp for standard dir parameter.
* (T285545) i18n: Split apihelp for redirects/linkshere/transcludedin/fileusage
  show.
* (T285545) i18n: Split apihelp for parameter list=deletedrevs&drprop=.
* (T285545) i18n: Split apihelp for parameter list=allpages&apprexpiry=.
* (T285545) i18n: Split apihelp for parameter action=opensearch&redirects=.
* (T285545) i18n: Split apihelp for parameter action=managetags&operation=.
* (T285545) api: Add message for list=watchlist&wlprop=expiry.
* (T334011) ApiComparePages: expose 'difftype' param if wikidiff2 is installed.
* (T342633) api: Add message for action=compare&prop=timestamp.
* API: revids=… does not necessarily return the queried revisions.
* (T235207) Get correct main page in API call examples.
* doc: Make extension.schema.v2.json a valid JSON schema.
* (T326696) Add since tag to UserOptionsManager::MAX_BYTES_OPTION_VALUE.
* (T310378) Ensure that installer i18n is loaded by update.php.
* updateSpecialPages.php: Avoid implicit float conversion on modulo.
* (T347227) ImportReporter: Make callback functions public.
* (T346898) importDump: Unconditionally call $importer->setUsernamePrefix().
* (T204470) Remove feedback messages from RawHtmlMessages.
* (T127268) MainConfigSchema: Update doc for "ResourceLoader: Default File
  modules to mobile and desktop targets".
* (T264765, CVE-2023-45364) SECURITY: Article: Check permissions before
  showing link to view deleted revision.
* doc: Improve description of type in extension.schema.v1.json.
* (T340217, CVE-2023-45359) SECURITY: Vector 2022: Numerous unescaped messages
  leading to potential XSS.
* (T340220, CVE-2023-45361) SECURITY: Vector 2022: vector-intro-page message
  is assumed to yield a valid title.
* (T340221, CVE-2023-45360) SECURITY: XSS via 'youhavenewmessagesmanyusers'
  and 'youhavenewmessages' messages.
* (T341529, CVE-2023-45362) SECURITY: diff-multi-sameuser ("X intermediate
  revisions by the same user not shown") ignores username suppression.
* (T341565, CVE-2023-3550) SECURITY: Stored XSS when uploading crafted
  XML file to Special:Upload (non standard configuration).

== MediaWiki 1.40.0 ==

=== Changes since MediaWiki 1.40.0-rc.0 ===
* Localisation updates.
* (T330464) Work around argument corruption bug in XMLReader::open.
* build: Updating mediawiki/mediawiki-phan-config to 0.12.1.
* Fix frame and frameless rdfa depending on file existing.
* (T329214) Pass whether current rev of file exists to
  Linker::makeBrokenImageLinkObj.
* (T334659) Handle thumb errors when !$enableLegacyMediaDOM.
* A manualthumb that doesn't exist should be considered a thumb error.
* (T313157) IndexPager: Also protect against $offset being 0.
* (T335612, CVE-2023-36674) SECURITY: Move badFile lookup to Linker.

== MediaWiki 1.40.0-rc.0 ==

== Upgrading notes for 1.40 ==
Don't forget to always back up your database before upgrading!

See the file UPGRADE for more detailed per-version upgrade instructions from the
oldest supported upgrading version, MediaWiki 1.35.

Some specific notes for MediaWiki 1.40 upgrades are below:
* Maintenance scripts should now be executed using maintenance/run.php, e.g.
  maintenance/run.php update not maintenance/update.php as before.
* Five extensions have now been bundled with MediaWiki:
  * The DiscussionTools extension, which provides a forum-like editing
    experience for wikitext-based discussion pages.
  * The Echo extension, which provides a system of user notifications.
  * The Linter extension, which warns about use of deprecated wikitext.
  * The LoginNotify extension, which warns users about failed attempted logins.
  * The Thanks extension, which lets users thank editors for edits.
* The Renameuser extension has been moved to MediaWiki core. It is now possible
  to rename users without installing an extension. The extension had already
  been bundled with MediaWiki since 1.18.

For notes on 1.39.x and older releases, see HISTORY.

=== Configuration changes for system administrators in 1.40 ===
* When computing PBKDF2 password hashes, MediaWiki now detects and uses OpenSSL
  support if available, unless $wgPasswordConfig['pbkdf2']['class'] is set in
  LocalSettings.php. OpenSSL is more efficient, so if that setting is present,
  you should remove it (or set it to 'Pbkdf2PasswordUsingOpenSSL' if possible).
  If users get an internal error when trying to log in, you can try setting it
  to 'Pbkdf2PasswordUsingHashExtension'. In particular, this would be necessary
  if existing PBKDF2 password hashes were computed using a hash algorithm other
  than "sha512" or "sha256" (the current and prior defaults).
* You should configure your webserver to return the http header
  'X-Content-Type-Options: nosniff' for the /images directory. This will
  instruct browsers to not apply content sniffing when accessing the files.
  MediaWiki before 1.40 shipped with a content sniffer which disallowed
  potentially dangerous files at upload time, but this protection has now been
  removed in favor of this 'X-Content-Type-Options: nosniff' header and the
  installer will return a warning when it is not in place.
* Support for MW_USE_LEGACY_DEFAULT_SETTINGS has been removed, setting this
  constant will not have any effect. Use of MW_USE_LEGACY_DEFAULT_SETTINGS
  had been deprecated since 1.39.

==== New configuration ====
* $wgThumbnailNamespaces - This setting lets you define the namespaces for which
  image thumbnails (or a placeholder in the absence of a thumbnail) will be
  displayed on Special:Search.
* $wgResourceLoaderClientPreferences – This experimental flag lets you enable
  client-side preferences for logged-out users.
* $wgExternalLinksSchemaMigrationStage – This temporary flag lets you control
  the migration stage for the new schema for the external links database table.
  Ignore it unless you have a large wiki farm with complex migration needs.
* $wgCommentTempTableSchemaMigrationStage – This temporary flag lets you control
  the migration stage for the temporary comment database table, from revision.
  Ignore it unless you have a large wiki farm with complex migration needs.
* $wgSpecialContributeSkinsEnabled – This setting lets you list skins on which
  Special:Contribute is available, for where others don't work for the feature.
* $wgPrivilegedGroups – Users belonging in some of the listed groups will be
  audited more aggressively.

==== Changed configuration ====
* $wgPasswordPolicies – This setting, which controls what makes for a valid
  password for wiki accounts, has been adjusted to raise the minimal password
  length from 1 to 8 characters. The initial limit of 1 has been in place since
  MediaWiki 1.26. If you wish to allow shorter passwords, you can over-ride it
  in your LocalSettings following the guidance on MediaWiki.org.
* (T254045) New accounts can no longer use an equals sign (=) in their
  usernames because of issues it causes in wikitext syntax. This can be
  adjusted by changing the value of $wgInvalidUsernameCharacters.
* (T314318) $wgParserEnableLegacyMediaDOM – This setting has been changed, so
  the alternative modern HTML structure for media is now the default. You can
  disable it for now by over-riding this back to `true` in LocalSettings, but
  this configuration will be removed in future versions of MediaWiki. For more
  details, see the documentation at:
  https://www.mediawiki.org/wiki/Parsoid/Parser_Unification/Media_structure/FAQ
* $wgWatchlistExpiryMaxDuration – This setting, which controls the maximum
  allowed duration for users to set their temporary watchlist entries for expiry
  if that feature is enabled, has been increased from 6 months to 1 year.

==== Removed configuration ====
* $wgShellboxUrl – This setting, deprecated in 1.37, has now been removed; use
  $wgShellboxUrls instead.
* $wgMainWANCache and $wgWANObjectCaches – These never-used settings have been
  removed. To inject WANObjectCache parameters, use $wgWANObjectCache instead.
  These variables were introduced for multi-DC wiki farms to add a separate
  memcached proxy for cross-DC relaying of purges but never used because
  WANObjectCache works based on route prefixes, which can be transparently
  handled by the main memcached proxy.
* $wgParserTestFiles – This setting, deprecated in 1.30, has now been removed;
  extensions can place their parser test files in `tests/parser` instead.
* (T231412) $wgAutoloadAttemptLowercase – This setting, deprecated in 1.35, no
  longer has any effect. If you run into difficulties, fix the names of miscased
  local files.
* (T309787) $wgVerifyMimeTypeIE – This setting, to provide extra security checks
  for very old versions of Internet Explorer clients, was removed. These user
  agents aren't used in practice, and haven't been served JavaScript content for
  years.

=== New user-facing features in 1.40 ===
* Special:Search can now show thumbnails for results for titles outside NS_FILE.
  This is controlled via the new onSearchResultProvideThumbnail hook.
* A new preference ('search-thumbnail-extra-namespaces') to allow users to
  control whether to show more thumbnails (per $wgThumbnailNamespaces)
* (T324910) On pages using multi-content revisions, the raw content of a
  specific slot can be retrieved using the action=raw&slot=<role-name> query
  parameters.
* (T313804) The preferences page now provides a search bar to find preferences,
  regardless of the tab on which they appear.

=== New developer features in 1.40 ===
* The MediaWiki-Docker development environment is now configured to
  run on PHP 8.1 by default, up from PHP 7.4 now that that's EOL.
* Vue development mode is enabled by default in DevelopmentSettings.php
* (T277618) The @noVarDump annotation from the DebugInfoTrait tool can now be
  added to references to stop them from being expanded when their object is
  passed to var_dump(), to make its use for debugging more feasible.
* The ApiSandbox will now by default request responses in the latest API format,
  rather than the original format. Users can set `formatversion` to a different
  value if needed.
* A new hook, GetBlockErrorMessageKeyHook, allows extensions' block error
  messages to be received and displayed by BlockErrorFormatter.
* A new hook, SpecialCreateAccountBenefits, lets extensions and local code set
  custom content on the signup page about the benefits of using an account.
* (T321412) A new 'PageUndeleteComplete' hook has been added for more thorough
  information about a page post restoration than the 'PageUndelete' hook passes.
  This provides similar functionality to the 'PageDeleteComplete' hook.
* The Linker::specialLink() method can now link to a Special page's with a sub-
  page or action parameter set, e.g. [[Special:Contributions/JohnDoe]].
* The PHPUnit entrypoints (tests/phpunit/phpunit.php and vendor/bin/phpunit)
  now check if composer dependencies are up-to-date, like update.php, using
  CheckComposerLockUpToDate. To disable this check, use
  MW_SKIP_EXTERNAL_DEPENDENCIES=1 environment flag when running PHPUnit.
* ManualLogEntry::setForceBotFlag() has been added to allow the forcing of the
  bot flag for log entries which are inserted to the recent changes.

=== External library changes in 1.40 ===

==== New external libraries ====
* Added codex-design-tokens at v0.6.2.
* Added symfony/polyfill-php81 at v1.28.0.
* Added symfony/polyfill-php82 at v1.28.0.
* Added symfony/polyfill-php83 at v1.28.0.
* Added wikimedia/bcp-47-code at v1.0.0.

===== New development-only external libraries =====
* Added wikimedia/langconv at v0.4.2.

==== Changed external libraries ====
* Updated OOUI from v0.44.3 to v0.46.3.
* Updated codex, codex-search, and codex-icons from v0.2.2 to v0.6.2.
* Updated cssjanus/cssjanus from 2.1.0 to 2.1.1.
* Updated guzzlehttp/guzzle 7.4.5 to 7.5.0.
* Updated justinrainbow/json-schema from 5.2.11 to 5.2.12.
* Updated pear/mail from 1.4.1 to 1.5.1.
* Updated pear/net_smtp from 0.10.0 to 0.10.1.
* Updated psr/container from 1.1.1 to 1.1.2.
* Updated symfony/polyfill-php80 from 1.26.0 to 1.28.0.
* Updated symfony/yaml from 5.4.10 to 5.4.23.
* Updated wikimedia/html-formatter from 3.0.1 to 4.0.3.
* Updated wikimedia/less.php from 3.1.0 to 4.0.0.
* Updated wikimedia/object-factory from 4.0.0 to 5.0.1.
* Updated wikimedia/parsoid from 0.16.0 to 0.17.0.
* Updated wikimedia/remex-html from 3.0.2 to 3.0.3.
* Updated wikimedia/shellbox from 3.0.0 to 4.0.0.
* Updated wikimedia/timestamp from 4.0.0 to 4.1.1.
* Updated wikimedia/xmp-reader from 0.8.4 to 0.9.1.

===== Changed development-only external libraries =====
* Updated QUnit from 2.18.2 to 2.19.4.
* Updated api-testing from 1.5.0 to 1.5.1.
* Updated composer/spdx-licenses from 1.5.6 to 1.5.7.
* Updated eslint-config-wikimedia from 0.22.1 to 0.24.0.
* Updated giorgiosironi/eris from ^0.10.0 to ^0.13.0.
* Updated grunt from 1.5.2 to 1.6.1.
* Updated grunt-banana-checker from 0.9.0 to 0.10.0.
* Updated grunt-eslint from 24.0.0 to 24.0.1.
* Updated karma from 6.3.15 to 6.4.1.
* Updated mediawiki/mediawiki-codesniffer from 38.0.0 to 41.0.0.
* Updated mediawiki/mediawiki-phan-config from 0.11.1 to 0.12.1.
* Updated php-parallel-lint/php-console-highlighter from 0.5 to 1.0.0.
* Updated php-parallel-lint/php-parallel-lint from 1.3.1 to 1.3.2.
* Updated phpunit/phpunit from 8.5.28 to 9.5.28.
* Updated stylelint-config-wikimedia from 0.13.0 to 0.13.1.
* Updated wikimedia/alea from 0.9.3 to 1.0.0.

==== Removed external libraries ====
* jquery.throttle-debounce, deprecated since MediaWiki 1.33.
* WVUI, deprecated since MediaWiki 1.39.

=== Action API changes in 1.40 ===
* New `cancreateaccount` parameter on action=query&meta=userinfo that allows
  you to check if the user can create an account. Some of the errors that have
  previously been returned by action=query&list=users&usprop=cancreate are now
  returned here.

=== Languages updated in 1.40 ===
MediaWiki supports over 400 languages. Many localisations are updated regularly.
Below only new and removed languages are listed, as well as changes to languages
because of Phabricator reports.

* (T300378) Added language support for Toki Pona (tok).
* (T320465) Added language support for Magahi (mag).
* (T320912) Added language support for Arakanese (rki).
* (T323971) Added language support for Khakas (kjh).
* (T326526) Added language support for Igala (igl).
* (T329476) Added language support for Kusaal (kus).
* (T330266) Added language support for Southern Dagaare (dga).
* (T331596) Added language support for Obolo (ann).
* (T331597) Added language support for Nogai (nog).
* (T331599) Added language support for Wolaytta (wal).
* (T295637) Add no to fallback chain of nb and nn.

=== Breaking changes in 1.40 ===
* OutputPage::enableClientCache no longer accepts a parameter, nor does it
  return the current value. It simply sets the OutputPage::mEnableClientCache
  to true. Use OutputPage::disableClientCache to disable client side caching
  instead.
* ResourceLoader::makeMessageSetScript, unused since 1.26, has been removed
  without deprecation.
* Changes to skins:
  - The internal protected method Skin::getFooterLinks() was removed.
    It had no known usages. Different from SkinTemplate::getFooterLinks.
  - The internal public method Skin::getSiteFooterLinks() was removed.
    It had no known usages.
* The 'oojs-router' module has been removed without deprecation in favour
  of the 'mediawiki.router' wrapper module.
* BagOStuff::makeKeyInternal(), deprecated for public use in 1.36, is now a
  protected method of MediumSpecificBagOStuff.
* WANObjectCache::reap() and WANObjectCache::reapCheckKey(), deprecated since
  1.39, have been removed.
* The EnqueueJob class, unused since 1.31, has been removed without
  deprecation.
* JobQueueGroup::singleton() and ::destroySingletons(), deprecated since 1.37,
  have been removed.
* JobRunner no longer supports manually calling the constructor,
  use MediaWikiServices::getInstance()->getJobRunner() instead.
* JobRunner::setLogger, deprecated since 1.35, has been removed.
* ContextSource::getStats, deprecated since 1.27, has been removed.
* The following public properties of Parser, deprecated in 1.35,
  have been made private: Parser::$mLinkId, Parser::$mIncludeSizes,
  Parser::$mDoubleUnderscore, Parser::$mShowToc, Parser::$mRevisionId,
  Parser::$mRevisionTimestamp, Parser::$mRevisionUser, Parser::$mRevisionSize,
  Parser::$mInputSize, Parser::$mInParse, Parser::$mFirstCall,
  Parser::$mGeneratedPPNodeCount
* The MWGrants class, deprecated since 1.38, has been removed.
* PageProps::getInstance(), deprecated since 1.38, has been removed.
* Global functions wfReadOnly and wfReadOnlyReason, deprecated since 1.38, have
  been removed.
* Global function wfQueriesMustScale, deprecated since 1.39, has been removed.
* Global function wfLogProfilingData, deprecated since 1.38, has been removed.
* The HTMLCacheUpdate class, deprecated since 1.34, has been removed.
* Linker::normaliseSpecialPage(), deprecated since 1.35, has been removed.
* MWTimestamp::getHumanTimestamp(), deprecated since 1.26, has been removed.
* Collation::singleton() and ::factory(), deprecated since 1.37, have been
  removed.
* SpecialVersion::listToText() and SpecialVersion::arrayToString()
  have become private or internal without deprecation.
* The 'ParserTestFiles' key in the schema for extension.json has been removed.
  This was deprecated in 1.30 and the corresponding $wgParserTestFiles
  configuration variable has also been removed in this release.  Extensions
  can put parser test files in their `tests/parser` directory to have them
  automatically run.
* DBLockManager, MySqlLockManager, and PostgreSqlLockManager have been
  removed without deprecation.
* MediaWikiTestCaseTrait::checkPHPExtension() has been removed without
  deprecation. Use PHPUnit @requires annotations instead.
* EditPage::getCopywarn(), deprecated since 1.38, has been removed.
* EditPage::getCopyrightWarning() now requires a MessageLocalizer parameter.
  Use of other parameter types or omitting it was deprecated since 1.38.
* Action constructor now requires Article and IContextSource parameters.
  Use of other parameter types or omitting them was deprecated since 1.35.
* Article::viewRedirect(), deprecated since 1.30, has been removed.
* Title::getNotificationTimestamp(), deprecated since 1.35, has been removed.
* WikiRevision::$fileIsTemp property, deprecated since 1.29, has been removed.
* Use of CommentStore::insertWithTempTable() with 'img_description' is no
  longer supported, it was deprecated since 1.32. Use CommentStore::insert()
  instead.
* Return values in the parameter $pageLang of the PageContentLanguage hook with
  other types than a Language object, deprecated since 1.33 & emitting warnings
  since 1.38, now throws an exception.
* FormatMetadata::flattenArrayContentLang(), deprecated since 1.36, has been
  removed.
* WikiRevision::downloadSource() and ::importUpload(), deprecated since 1.31,
  have been removed.
* DataUpdate::runUpdates(), deprecated since 1.28, has been removed.
* CdnCacheUpdate::newFromTitles(), deprecated since 1.35, has been removed.
* HtmlFileCacheUpdate::newFromTitles(), deprecated since 1.37, has been
  removed.
* BaseTemplate::renderAfterPortlet() and ::getAfterPortlet(), has been removed.
  Use the corresponding methods in Skin class.
* DifferenceEngine::textDiff(), deprecated since 1.32, has been removed.
* Skin::getSearchPageTitle() and Skin::setSearchPageTitle(), deprecated since
  1.38, have been removed.
* DifferenceEngine::getDiffBodyCacheKey(), deprecated since 1.31, has been
  removed.
* ForeignDBViaLBRepo::getMasterDB(), LocalRepo::getMasterDB(), and
  JobQueueDB::getMasterDB(), deprecated since 1.37, have been removed.
* Clarified that the InitializeArticleMaybeRedirect hook should not change
  its $article parameter; the behavior when doing so was previously
  undocumented.
* IDatabase::ping()'s $rtt parameter was removed without deprecation.
* IDatabase::setBigSelects(), unused, was removed without deprecation.
* IDatabase::attributesFromType(), unused, was removed without deprecation.
* IMaintainableDatabase::deadlockLoop() was removed without deprecation.
* DatabasePostgres::remappedTableName(), deprecated since 1.37, has been
  removed.
* ILBFactory::getChronologyProtectorClientId and ::commitAll, unused, were
   removed without deprecation.
* LoadBalancer::haveIndex() and ::isNonZeroLoad(), deprecated in 1.34,
  have been removed.
* LoadBalancer::getLazyConnectionRef(), deprecated in 1.38, has been removed.
* ILBFactory::forEachLB(), deprecated in 1.39, has been removed.
* LoadBalancer::getTransactionRoundStage and ::commitAll, unused, were
  removed without deprecation.
* ILoadBalancer::getLaggedReplicaMode, unused, was removed  without
  deprecation. Use ILBFactory::laggedReplicaUsed() instead.
* Optional parameters of ILoadBalancer::waitForPrimaryPos(), $pos and $timeout
  have been removed without deprecation as they are unused.
* LoadMonitorMysql was removed without deprecation. Use LoadMonitor instead.
* IDatabase::selectDB(), deprecated since 1.32, has been removed.
  Use IDatabase::selectDomain() instead.
* The following deprecated hooks have been removed:
  - BaseTemplateAfterPortlet, deprecated in 1.35
  - BeforeParserFetchTemplateAndtitle, deprecated in 1.36
  - BeforeParserrenderImageGallery, deprecated in 1.35
  - InternalParseBeforeSanitize, deprecated in 1.35
  - LinksUpdateConstructed, deprecated in 1.38
  - LinksUpdateAfterInsert, deprecated in 1.38
  - ParserSectionCreate, deprecated in 1.35
  - ResourceLoaderTestModules, deprecated in 1.33
  - SpecialMuteSubmit, deprecated in 1.35
  - UserLoadFromDatabase, deprecated in 1.37
  - UserSetCookies, deprecated in 1.27
* RemexDriver::__construct() now only accepts a ServiceOptions instance as
  the only argument. Passing an array was deprecated since 1.36.
* TidyDriverBase::supportsValidate(), deprecated since 1.36, has been removed.
* RevDelList::reloadFromMaster(), deprecated since 1.37, has been removed.
* ExternalStoreDB::getMaster(), deprecated since 1.37, has been removed.
* DeletePage::deletionWasScheduled(), deprecated since 1.38, has been removed.
* The SearchResultProvideThumbnailHook (which was unstable) and now no longer
  used, has been removed. Use SearchResultProvideThumbnailHook in the search
  namespace: MediaWiki\Search\Hook\SearchResultProvideThumbnailHook.
* Command::cgroup(), deprecated since 1.36, has been removed.
* When running tests, the serialize_precision INI setting is now set to -1
  (current PHP default) instead of 17. Extension tests may need to be adjusted
  accordingly; string representations of floating-point numbers in serialized
  or JSON-encoded data may change.
* WikiRevision::$sha1base36 is now private.
* IcuCollation::getUnicodeVersionForICU() was removed without deprecation.
* LinkFilter::supportsIDN() was removed without deprecation.
* The ability to pass null for the errorData parameter of HttpException and
  LocalizedHttpException was removed without deprecation.
* ApiQueryExtLinksUsage::getProtocolPrefix() and ::prepareProtocols() have
  been moved to LinkFilter with the same name.
* .box-sizing() Less mixin, deprecated since 1.37, has been removed.
  Use CSS box-sizing now.
* MimeAnalyzer::getIEMimeTypes() and IEContentAnalyzer were removed.
* Language::commafy and mw.language.commafy, deprecated since 1.36, has been
  removed.
* BagOStuff::decr(), deprecated since 1.28, has been removed.
* BagOStuff::incr(), deprecated since 1.28, has been removed.

=== Deprecations in 1.40 ===
* Changes to skins:
  - The public Skin::footerLink is deprecated.
    Use SkinComponentMenuLink::getTemplateData instead.
    It now emits deprecation warnings.
  - The protected Skin::lastModified is deprecated, and marked for @internal use
    and now emits deprecation warnings.
* Manipulating $wgHooks after initialization is deprecated.
  HookContainer::register() or HookContainer::scopedRegister() should be
  used instead. During initialization, SettingsBuilder::registerHookHandlers
  can be used. For backwards compatibility, $wgHooks is replaced by a fake
  array that calls methods on HookContainer. $wgHooks can still be used as a
  configuration variable, only dynamic manipulation is deprecated.
* ParserOptions::{get,set}ExternalLinkTarget() and
  ParserOptions::{get,set}MaxTemplateDepth() have been deprecated and marked
  for @internal use only.
* ParserOutput::getCategories() has been deprecated; use ::getCategoryNames()
  and ::getCategorySortKey() instead.
* ParserOutput::{get,set}TOCHTML() has been deprecated; use
  ::{get,set}TOCData() instead.
* TransactionProfiler::setSilenced() is deprecated.
  Use TransactionProfiler::silenceForScope() instead.
* The following methods in the Title class, deprecated since 1.37, emits
  deprecations warnings:
  - ::areCascadeProtectionSourcesLoaded()
  - ::areRestrictionsCascading()
  - ::areRestrictionsLoaded()
  - ::getAllRestrictions()
  - ::getCascadeProtectionSources()
  - ::getFilteredRestrictionTypes()
  - ::getRestrictionExpiry()
  - ::getRestrictionTypes()
  - ::getRestrictions()
  - ::isCascadeProtected()
  - ::isProtected()
  - ::isSemiProtected()
  - ::loadRestrictionsFromRows()
* The class Pbkdf2Password was renamed to Pbkdf2PasswordUsingHashExtension,
  and the old name is now deprecated.
* WikiPage::factory(), ::newFromID() and ::newFromRow, deprecated in 1.36, now
  emit deprecation warnings.
* Manually constructing a LinkBatch object, deprecated in 1.35, now emits
  deprecation warnings. Use LinkBatchFactory instead.
* Calling MediaWikiSite::getFileUrl() without a $path argument is deprecated.
  If you need the "generic" full file path, with $1 not replaced by anything,
  call $site->getPath( MediaWikiSite::PATH_FILE ) directly.
* In SessionConsistentConnectionManager, the methods
  getReadConnectionRef() and getWriteConnectionRef() are deprecated;
  the ConnectionManager methods they override had been deprecated already.
* Database::wasErrorReissuable() is deprecated.
* MimeAnalyzer::isPHPImageType was not used and will now emit deprecation
  warnings.
* GenericArrayObject, originally developed for Wikibase and SiteList, has been
  deprecated. Use built-in ArrayObject directly instead.
* Parser::getFunctionLang() has been deprecated; use
  Parser::getTargetLanguage() instead.
* MagicWordArray::getVariableRegex(), deprecated in 1.36, now emits deprecation
  warnings.
* AbstractBlock::getId() now emits deprecation warnings in case of cross-wiki
  access. This use was deprecated in 1.38.
* CommentStore::getStore, deprecated in 1.31, now emits deprecation warnings.
* BacklinkCache::get(), ::getLinks() and ::getCascadeProtectedLinks(),
  deprecated in 1.37, now emit deprecation warnings.
* LanguageConverterFactory::isTitleConversionDisabled(), deprecated in 1.36,
  now emits deprecation warnings.
* Language::getFileName(), ::getMessagesFileName() and
  ::getJsonMessagesFileName(), deprecated in 1.34,
  now emit deprecation warnings.
* Language::getLocalisationCache(), deprecated in 1.34, also
  Language::getMessagesFor(), ::getMessageFor() and ::getMessageKeysFor(),
  deprecated in 1.35, now emit deprecation warnings.
* User::incEditCount(), deprecated in 1.37, now emits deprecation warnings.
* User::idFromName(), deprecated in 1.37, now emits deprecation warnings.
* The ability to override and use User::$mRights, deprecated in 1.34, now emits
  deprecation warnings.
* IndexPager::getHookContainer is deprecated and emits deprecation warnings.
  Inject a HookContainer instead.
* User::getGroupPermissions(), ::getGroupsWithPermission() and
  ::groupHasPermission(), deprecated in 1.34, now emit deprecation warnings.
* PermissionManager::getGroupPermissions(), ::getGroupsWithPermission() and
  ::groupHasPermission(), deprecated in 1.36, now emit deprecation warnings.
* Global function wfShowingResults is deprecated and emits deprecation warnings.
* UserGroupMembership::getGroupMemberName is deprecated, the deprecation of
  UserGroupMembership::getGroupName in 1.38 missed a release note.
  Use Language::getGroupMemberName or ::getGroupName instead.
* AbstractBlock::getPermissionsError(), deprecated in 1.35, now emits
  deprecation warnings.
* SearchEngine::getNearMatcher() and ::getDefaultMatcher() have been deprecated
  in favor of MediaWikiServices::getInstance()->getTitleMatcher().
* SearchNearMatcher class has been deprecated in 1.40 in favor of TitleMatcher.
* The following functions are deprecated: User::isBlockedGlobally and
  User::getGlobalBlock. Use User::getBlock instead.
* The UserIsBlockedGlobally hook is deprecated.
  Use GetUserBlock hook instead.
* The SystemBlock type global-block is deprecated.
  GlobalBlocks are now added into CompositeBlocks via the GetUserBlock hook.
* Language::isWellFormedLanguageTag(), deprecated in 1.39, now emits deprecation
  notices. Please use LanguageCode::isWellFormedLanguageTag() instead.
* Language::fetchLanguageNames() and ::fetchLanguageName(), deprecated in 1.34,
  now emit deprecation warnings.
* Language::getFallbackFor(), ::getFallbacksIncludingSiteLanguage() and
  ::getFallbacksFor(), deprecated in 1.35, now emit deprecation warnings.
* Language::isSupportedLanguage(), ::isValidCode(), ::isValidBuiltInCode() and
  ::isKnownLanguageTag(), deprecated in 1.34, now emit deprecation warnings.
* Language::getConverter(), ::autoConvert(), ::autoConvertToAllVariants(),
  ::convert(), ::convertNamespace(), ::convertHtml(), ::convertCategoryKey(),
  ::getVariants(), ::hasVariants(), ::hasVariant(), ::getDefaultVariant(),
  ::getURLVariant(), ::getExtraHashOptions(), ::getConvRuleTitle(),
  deprecated in 1.35, now emit deprecation warnings.
* Language::factory() and ::getParentLanguage(), deprecated in 1.35, now emit
  deprecation warnings.
* Executing maintenance scripts directly is deprecated. The maintenance/run.php
  entry point should be used instead.
* MWHttpRequest::factory, deprecated in 1.34, now emits deprecation warnings.
* Job::factory is deprecated, use JobFactory::newJob instead.
* Http::request(), ::get(), ::post(), ::userAgent() and ::isValidURI(),
  deprecated in 1.34, now emit deprecation warnings.
* Title.js's confusingly-named getName() and getNameText() methods, for using
  media files' pages, have been renamed to getFileNameWithoutExtension() and
  getFileNameTextWithoutExtension() respectively. The old names are deprecated.
* Command::whitelistPaths() should now emit deprecation warnings. Make use of
  Command::allowPaths/disallowPaths() instead.
* When manually creating an HTMLFormField (i.e. not via HTMLForm::factory),
  it is deprecated to not include the "parent" field as one of the parameters.
* The MWException class is deprecated. Use native exceptions, either directly
  or as base classes.
* SelectQueryBuilder::lockForUpdate() is deprecated. Use ::forUpdate() with
  ::fetchRowCount() or ::acquireRowLocks() instead.
* ArticleUndelete hook is deprecated. Use PageUndeleteComplete hook instead.
* The global function wfReportTime() is now deprecated.
* PrevNextNavigationRenderer, deprecated in 1.39, now emits deprecation
  warnings.
* PagerNavigationBuilder::setMakeLinkCallback(), deprecated in 1.39, now emits
  deprecation warnings.
* IndexPager::getPagingLinks(), IndexPager::getLimitLinks() and
  IndexPager::buildPrevNextNavigation(), deprecated in 1.39, now emit
  deprecation warnings.
* Overriding the method IndexPager::makeLink(), deprecated in 1.39, now emits
  deprecation warnings.
* The following class names were namespaced (and, for the special pages,
  also renamed), and the old class names are now deprecated:
  - MostimagesPage -> MediaWiki\Specials\SpecialMostImages
  - MovePageForm -> MediaWiki\Specials\SpecialMovePage
  - UserrightsPage -> MediaWiki\Specials\SpecialUserRights
  - WantedFilesPage -> MediaWiki\Specials\SpecialWantedFiles
  - WantedPagesPage -> MediaWiki\Specials\SpecialWantedPages
  - DerivativeRequest -> MediaWiki\Request\DerivativeRequest
  - FauxRequest -> MediaWiki\Request\FauxRequest
  - FauxRequestUpload -> MediaWiki\Request\FauxRequestUpload
  - PathRouter -> MediaWiki\Request\PathRouter
  - WebRequestUpload -> MediaWiki\Request\WebRequestUpload
  - HeaderCallback -> MediaWiki\Request\HeaderCallback
  - FauxResponse -> MediaWiki\Request\FauxResponse
  - WebResponse -> MediaWiki\Request\WebResponse
  - ForeignResourceManager ->
    MediaWiki\ResourceLoader\ForeignResourceManager
  - DummyLinker -> MediaWiki\Linker\DummyLinker
  - Linker -> MediaWiki\Linker\Linker
  - PageProps -> MediaWiki\Page\PageProps
  - MagicWord -> MediaWiki\Parser\MagicWord
  - MagicWordArray -> MediaWiki\Parser\MagicWordArray
  - MagicWordFactory -> MediaWiki\Parser\MagicWordFactory
  - RawMessage -> MediaWiki\Language\RawMessage
  - ActorMigration -> MediaWiki\User\ActorMigration
  - ActorMigrationBase -> MediaWiki\User\ActorMigrationBase
  - CategoriesRdf -> MediaWiki\Category\CategoriesRdf
  - Category -> MediaWiki\Category\Category
  - CategoryViewer -> MediaWiki\Category\CategoryViewer
  - TrackingCategories -> MediaWiki\Category\TrackingCategories
  - EditPage -> MediaWiki\EditPage\EditPage
  - TemplatesOnThisPageFormatter ->
    MediaWiki\EditPage\TemplatesOnThisPageFormatter
  - ContentSecurityPolicy -> MediaWiki\Request\ContentSecurityPolicy
  - FormOptions -> MediaWiki\Html\FormOptions
  - Html -> MediaWiki\Html\Html
  - HtmlHelper -> MediaWiki\Html\HtmlHelper
  - TemplateParser -> MediaWiki\Html\TemplateParser
  - FormOptions -> MediaWiki\Html\FormOptions
  - WikiMap -> MediaWiki\WikiMap\WikiMap
  - WikiReference -> MediaWiki\WikiMap\WikiReference
  - MediaWiki\BadFileLookup -> MediaWiki\Page\File\BadFileLookup
  - FileDeleteForm -> MediaWiki\Page\File\FileDeleteForm
  - MergeHistory -> MediaWiki\Page\MergeHistory
  - MovePage -> MediaWiki\Page\MovePage
  - ProtectionForm -> MediaWiki\Page\ProtectionForm
  - LinkFilter -> MediaWiki\ExternalLinks\LinkFilter
  - TitleArray -> MediaWiki\Title\TitleArray
  - TitleArrayFromResult -> MediaWiki\Title\TitleArrayFromResult
  - TitleFactory -> MediaWiki\Title\TitleFactory
  - Title -> MediaWiki\Title\Title
  - ForkController -> MediaWiki\Maintenance\ForkController
  - OrderedStreamingForkController ->
    MediaWiki\Maintenance\OrderedStreamingForkController
  - AtomFeed -> MediaWiki\Feed\AtomFeed
  - ChannelFeed -> MediaWiki\Feed\ChannelFeed
  - FeedItem -> MediaWiki\Feed\FeedItem
  - FeedUtils -> MediaWiki\Feed\FeedUtils
  - RSSFeed -> MediaWiki\Feed\RSSFeed
  - DeprecatedGlobal -> MediaWiki\StubObject\DeprecatedGlobal
  - StubGlobalUser -> MediaWiki\StubObject\StubGlobalUser
  - StubObject -> MediaWiki\StubObject\StubObject
  - StubUserLang -> MediaWiki\StubObject\StubUserLang
* ContentHandler::getParserOutputForIndexing() and ::getDataForSearchIndex()
  now take an optional RevisionRecord parameter.
* The SearchDataForIndex hook is deprecated in favor of SearchDataForIndex2
* IDatabase::lastQuery and IReadableDatabase::lastQuery are deprecated without
  without replacement.

=== Other changes in 1.40 ===
* Calling RecentChange::doMarkPatrolled() with $auto = true has no effect and
  logs a warning. Since 1.31, it would mark the change as manually patrolled,
  but would not log it as such in patrol log and would still require
  'autopatrol' right (not 'patrol'). Generally, whether a change should become
  autopatrolled, is usually determined before it's inserted in the database.
* In versions of MediaWiki before 1.39, the table of contents location
  was marked internally with <mw:toc>...</mw:toc>; in version 1.39
  this was changed to an empty tag <mw:tocplace />.  In 1.40 this has
  been changed a final time to use an empty <meta> tag for future
  Parsoid compatibility (see Parser::TOC_PLACEHOLDER).  This may
  affect you if stale content is left in the ParserCache or if your
  skin did manual ToC replacement without using the recommended
  Parser::replaceTableOfContentsMarker() function.
* Skins can now choose which Codex theme should be loaded by setting the
  SkinCodexThemes attribute in their skin.json file.
* The parser test framework has been updated, and the 'pst', 'ill', 'cat'
  and 'showflags' options have slight differences in their output.  These
  options are not much used outside core, but third parties may need to
  update parser tests.
* (T332889, CVE-2023-36675) SECURITY: Fix escaping in BlockLogFormatter.

== Compatibility ==

MediaWiki 1.40 requires PHP 7.4.3 or later and the following PHP extensions:

* ctype
* dom
* fileinfo
* iconv
* intl
* json
* mbstring
* xml

MariaDB is the recommended database software. MySQL, PostgreSQL, or SQLite can
be used instead, but support for them is somewhat less mature.

The supported versions are:

* MariaDB 10.3 or higher
* MySQL 5.7.0 or higher
* PostgreSQL 10 or later
* SQLite 3.8.0 or later

== Online documentation ==
Documentation for both end-users and site administrators is available on
MediaWiki.org, and is covered under the GNU Free Documentation License (except
for pages that explicitly state that their contents are in the public domain):

       https://www.mediawiki.org/wiki/Special:MyLanguage/Documentation

== Mailing list ==
A mailing list is available for MediaWiki user support and discussion:

       https://lists.wikimedia.org/mailman/listinfo/mediawiki-l

A low-traffic announcements-only list is also available:

       https://lists.wikimedia.org/mailman/listinfo/mediawiki-announce

It's highly recommended that you sign up for one of these lists if you're
going to run a public MediaWiki, so you can be notified of security fixes.

== IRC help ==
There's usually someone online in #mediawiki on irc.libera.chat.

= MediaWiki 1.39 =

PHP 8.0 workboard: https://phabricator.wikimedia.org/tag/php_8.0_support/
PHP 8.1 workboard: https://phabricator.wikimedia.org/tag/php_8.1_support/
PHP 8.2 workboard: https://phabricator.wikimedia.org/tag/php_8.2_support/
PHP 8.3 workboard: https://phabricator.wikimedia.org/tag/php_8.3_support/

== MediaWiki 1.39.10 ==

This is a maintenance release of the MediaWiki 1.39 branch.

=== Changes since 1.39.9 ===
* Fix issue related to backport of AbuseFilter patch for T372998.

== Mediawiki 1.39.9 ==

This is a security and maintenance release of the MediaWiki 1.39 branch.

=== Changes since 1.39.8 ===
* Localisation updates.
* (T303007) skins: Fix Skin::buildSidebar to not share cache between skins.
* (T367918) When using the 'runMaintenance' method in a
  LoadExtensionSchemaUpdates hook handler, only the script's class name is
  required, not its path.
* Clarify that $wgAllowCrossOrigin only applies to REST.
* (T370380) installer: Support MW_SKIP_EXTERNAL_DEPENDENCIES in update.php.
* composer.json: Add 5 more ext- to suggests.
* resources: Fix 404 Not Found for foreign Financial-Times/polyfill-library.
* ResourceLoader: Fix regression of color mapping in Less.php.
* ResourceLoader: Upgrade wikimedia/less.php to 4.4.1.
* SpecialExport: Prevent passing null to strtolower.

== MediaWiki 1.39.8 ==

This is a maintenance release of the MediaWiki 1.39 branch.

=== Changes since 1.39.7 ===
* Localisation updates.
* tests: Skip failing tests on php8.2 (and make pass).
* (T326480) ApiResult: Make array ordering consistent across PHP versions.
* (T352789, T287972) build: Raise TestingAccessWrapper from 2.0.0 to 3.0.0.
* (T326478) tests: Create new classes to hold dynamic properties in auth tests.
* (T326478) tests: Avoid dynamic properties in AuthenticationProvider Test.
* (T326466) Introduce and use DynamicPropertyTestHelper.
* tests: Skip failing tests on php8.3 (and make pass).
* (T352910) tests: Use TestingAccessWrapper::newFromClass in session tests.
* (T326478) tests: Avoid dynamic properties in auth tests.
* (T326479, T361985) StatusValue: Allow passing arbitrary data to augment
  result.
* tests: Remove dead code from WikiPageDbTest::assertPreparedEditNotEquals.
* (T326478) tests: Avoid dynamic properties in SessionManagerTest.
* (T361990) Upgrading wikimedia/parsoid (v0.16.3 => v0.16.4).
* (T357760) Use i18n strings for truncated subpage message in SpecialMovePage.
* ArticleTest: Skip testGetOrSetOnNewProperty() if PHP >= 8.2.
* (T361982) Update wikimedia/less.php from 3.1.0 to 3.2.1.
* debug: Update PsySH 0.11.1 -> 0.12.3.
* (T361991) Fix slash-delimited regex from CLI on maintenence/grep.php.
* (T362078) Improve RestAPIAdditionalRouteFiles path expansion.
* (T352695) tests: Only set $dbSetup if setupTestDB() ends without throwing.
* (T302186) Add title cache for Title::newMainPage().
* objectcache: Fix flaky WANObjectCacheTest::testLockTSESlow case.
* (T362272) api: Replace null $httpCode by 0 in ApiBase::dieWithErrorOrDebug.
* (T150647, T216682) Make EncryptedPassword work with Argon2Password.
* (T327220) Special:ApiHelp: Move widths and floats in CSS to media query.
* (T364270) Fix long param names overlapping docs in API help pages.
* MaintenanceRunner.php: Add trailing newline to error message.
* wrapOldPasswords: Improve progress output and decrease batch size.
* (T361367) ApiFeedWatchlist: Fix handling of array parameters.
* (T132418) ResourceLoader: Add 1min grace via stale-while-revalidate
  Cache-Control.
* (T366130) EncryptedPassword: Store default parameters as strings.
* Name the PagerTools array entries to allow hooks to unset them.

== MediaWiki 1.39.7 ==

This is a security and maintenance release of the MediaWiki 1.39 branch.

=== Changes since 1.39.6 ===
* Localisation updates.
* (T334992) Headings in the license pickers should not be selected.
* (T353929) ActiveUsersPager: Count actions only once.
* composer: Use @php instead of php.
* (T326065) Indent JsonContent using tabs.
* (T354541) authmanager: Improve AuthenticationRequest docs.
* (T355017) Add missing space in Special:RecentChangesLinked.
* (T355003) composer.json Add ext-bcmath and ext-gmp to suggests.
* PHPVersionCheck: Update text to match currently supported upstream PHP
  versions (8.1+).
* (T354045) API: mark HTML output as non-cacheable.
* (T355530) filerepo: Fix img_major_mime for files with a non-standard
  extensions.
* (T355530) MimeAnalyzer: Add @since to isValidMajorMimeType.
* (T317489, T319202) Mark some parserTests on talk pages Parsoid only on
  REL1_39.
* (T350594) Update wikimedia/parsoid to 0.16.3.
* (T352554) ZhConverter: Fix language variant fallback chain.
* (T357668) Parser::getExternalLinkAttribs: Don't set rel attribute to null.
* LockManagerGroupIntegrationTest: Remove test depending on DBLockManager.
* (T357808) LinkRendererTest: Add missing import for LinkTarget.
* (T353305) ApiResetPassword: Allow both user and email parameters to be passed
  for reset.
* (T358949) updateCollation: Explicitly cast $scale to int.
* (T359055) api: Improve linking of language codes lists in top level i18n
  messages.
* (T359294) Make sure MovePage::isValidFileMove matches UploadBase::getTitle.
* (T230245) Respect $maxConcurrency when queuing async FileOps.
* (T352554) Follow-up "ZhConverter: Fix language variant fallback chain".
* (T292237, T317451) build: Restore Doxygen output for MediaWiki release tags.
* (T324903) HistoryPager: Add #[AllowDynamicProperties].
* (T360850) Update Apache config syntax in .htaccess files.
* (T309714, T354274) mime: Add support for 'font/woff' and 'font/woff2' mime
  type.
* (T309714) mime: Make test cases use data provider.
* (T331608) installer: Bear with schema drift caused by running old updater.
* docs: Remove use of $IP from mwdocgen.php.
* (T317451) build: Restore Doxygen output for MediaWiki release tags (take 3).
* docs: Set stable permalink on markdown files.
* (T357019) allow maintenance/deleteBatch.php to accept page ID.
* (T355538, CVE-2024-34507) SECURITY: XSS in edit summary parser.
* (T357760, CVE-2024-34506) SECURITY: Denial of service vector via GET request
  to Special:MovePage on pages with thousands of subpages.

== MediaWiki 1.39.6 ==

This is a security and maintenance release of the MediaWiki 1.39 branch.

=== Changes since MediaWiki 1.39.5 ===
* Localisation updates.
* Updated symfony/polyfill-php80 from 1.26.0 to 1.28.0.
* Updated symfony/polyfill-php81 from 1.26.0 to 1.28.0.
* (T344912) mail: Encode period (ascii 46) if it appears in encoded email
  header.
* Added symfony/polyfill-php82.
* Added symfony/polyfill-php83.
* Updated symfony/yaml from 5.4.10 to 5.4.23.
* (T329609) ApiQueryLanguageinfoTest: Do not pass a float to setFakeTime.
* Updated wikimedia/timestamp from 4.0.0 to 4.1.1.
* tests: Provide coverage for StatusValue::__toString.
* StatusValue: Improve logging/debug output with multibyte characters.
* (T347726, CVE-2023-51704) SECURITY: logging: Fix non-escaped messages
  used in rights log.
* Updated wikimedia/parsoid from 0.16.1 to 0.16.2.
* (T229992) LocalisationCache: Preserve fallback source language info.
* (T275085) Fix logging Status objects to 'authevents' channel.
* (T341310) DEVELOPERS.md: mention git clone and WSL.
* (T351758) DEVELOPERS.md: reword WSL instructions to include best practices.
* (T349115) LocalisationCache: Fix a rare case in fallback source language.
* SwiftFileBackend: Fix "PHP Deprecated: strlen(): Passing null to parameter #1
  ($string) of type string is deprecated".
* maintenance: Add missing parenthesis to SQL in attachLatest.php.
* (T353472) maintenance: Fix join condition in DeduplicateArchiveRevId.

== MediaWiki 1.39.5 ==

This is a security and maintenance release of the MediaWiki 1.39 branch.

=== Changes since MediaWiki 1.39.4 ===
* Localisation updates.
* (T333050, CVE-2023-45363) SECURITY: Fix infinite loop for self-redirects
  with variants conversion.
* docs: Fix a few typos in MainConfigSchema.
* (T309714) mime: Add support for 'font/sfnt' mime type.
* (T341434) WikiImporter: Improve error message output.
* (T317255) VueComponentParser: Use Zest's getElementsByTagName() rather than
  PHP's.
* (T341737) ApiBase: Cast $id to string in filterIDs.
* (T286291, T296188) Merge zh and zh-tw namespace translations back to zh-hans,
  zh-hant, zh-hk respectively.
* (T337875) WRStats: Round up SequenceSpec::hardExpiry to the nearest integer.
* (T237898) installer: Check MariaDB version in updater/installer.
* (T342632) ApiComparePages: Add help url.
* (T326182, T324903) EditPage: Add #[AllowDynamicProperties].
* (T342351) rdbms: Fix postgres db function call.
* (T343675) user: Use {@} to escape annotation when writting about annotation.
* (T343797) LanguageWa: Fix double timezone adjustment.
* (T326454) Update pear/mail to 1.5.1.
* (T204470) Remove feedback messages from RawHtmlMessages.
* (T264765, CVE-2023-45364) SECURITY: Article: Check permissions before
  showing link to view deleted revision.
* (T310378) Ensure that installer i18n is loaded by update.php.
* (T343622) docs: Set the <comment> tag back to optional.
* (T330528) Upgrade wikimedia/html-formatter from 3.0.1 to 4.0.3.
* (T337463) wdio-mediawiki: await saveScreenshot.
* (T274041) Include core PSR-4 classes in the generated classmap.
* (T208477) $wgPrivilegedGroups – Users belonging in some of the listed groups
  will be audited more aggressively.
* doc: Improve description of "type" in extension.schema.v2.json.
* Added PrivilegedGroups attribute for extension.json / skin.json, which lets
  you add any new user groups you define to wgPrivilegedGroups (see above).
* HTMLForm: Fix E_NOTICE when hide-if is used with setFormIdentifier.
* (T288624) MultiHttpClient: Unset $this->cmh after closing it.
* (T345039) Do not run SkinAfterBottomScripts hook twice unconditionally.
* (T265734) API Help: Note that parameters may be inherited from other context.
* API: Make continue parameter help description more specific.
* (T285545) i18n: Split apihelp for standard dir parameter.
* (T285545) i18n: Split apihelp for redirects/linkshere/transcludedin/fileusage
  show.
* (T285545) i18n: Split apihelp for parameter list=deletedrevs&drprop=.
* (T285545) i18n: Split apihelp for parameter list=allpages&apprexpiry=.
* (T285545) i18n: Split apihelp for parameter action=opensearch&redirects=.
* (T285545) i18n: Split apihelp for parameter action=managetags&operation=.
* (T285545) api: Add message for list=watchlist&wlprop=expiry.
* (T334011) ApiComparePages: expose 'difftype' param if wikidiff2 is installed.
* (T342633) api: Add message for action=compare&prop=timestamp.
* API: revids=… does not necessarily return the queried revisions.
* (T326696) user: Truncate option value in UserOptionsManager.
* (T326696) ApiOptions: Give warning if the value is too long.
* API i18n: Add {{PLURAL:}} for byte count messages.
* (T235207) Get correct main page in API call examples.
* doc: Make extension.schema.v2.json a valid JSON schema.
* updateSpecialPages.php: Avoid implicit float conversion on modulo.
* (T347227) ImportReporter: Make callback functions public.
* (T346898) importDump: Unconditionally call $importer->setUsernamePrefix().
* doc: Improve description of type in extension.schema.v1.json.
* (T340217, CVE-2023-45359) SECURITY: Vector 2022: Numerous unescaped
  messages leading to potential XSS.
* (T340220, CVE-2023-45361) SECURITY: Vector 2022: vector-intro-page
  message is assumed to yield a valid title.
* (T340221, CVE-2023-45360) SECURITY: XSS via
  'youhavenewmessagesmanyusers' and 'youhavenewmessages' messages.
* (T341529, CVE-2023-45362) SECURITY: diff-multi-sameuser
  ("X intermediate revisions by the same user not shown") ignores
  username suppression.
* (T341565, CVE-2023-3550) SECURITY: Stored XSS when uploading crafted
  XML file to Special:Upload (non-standard configuration).

== MediaWiki 1.39.4 ==

This is a security and maintenance release of the MediaWiki 1.39 branch.

=== Changes since MediaWiki 1.39.3 ===
* Localisation updates.
* (T333990) composer.json: Explicitly pin psr/http-message to 1.0.1.
* (T335203, CVE-2023-29197) SECURITY: Upgrading guzzlehttp/psr7
  (2.4.0 => 2.4.5).
* (T333776) {{ACTIVEUSERS}} wasn't being updated without updateSpecialPages.php.
* (T258860) Prevent LogicCache exception from message cache during IO errors
  from memcache.
* (T336868) Improve idempotency of postgres index upgrades.
* (T322944) Add Authorization to default $wgAllowedCorsHeaders.
* (T332889, CVE-2023-36675) SECURITY: Fix escaping in BlockLogFormatter.
* A fake MessageLocalizer for use in unit tests.
* (T338114) Title: Add forward alias.
* composer: Add symfony/polyfill-php81 like symfony/polyfill-php80.
* (T330464) Work around argument corruption bug in XMLReader::open.
* Fix frame and frameless rdfa depending on file existing.
* Fixes for the phan upgrade, part 1.
* Fixes for the phan upgrade, part 2.
* (T298571) build: Update mediawiki/mediawiki-phan-config to 0.12.0.
* build: Updating mediawiki/mediawiki-phan-config to 0.12.1.
* (T329214) Pass whether current rev of file exists to
  Linker::makeBrokenImageLinkObj.
* (T334659) Handle thumb errors when !$enableLegacyMediaDOM.
* A manualthumb that doesn't exist should be considered a thumb error.
* (T313157) IndexPager: Also protect against $offset being 0.
* (T335612, CVE-2023-36674) SECURITY: Move badFile lookup to Linker.

== MediaWiki 1.39.3 ==

This is a security and maintenance release of the MediaWiki 1.39 branch.

=== Changes since MediaWiki 1.39.2 ===
* Localisation updates.
* (T328477) LinksUpdate: Use DB key for category links table.
* GlobalFunctions: Remove check for MEDIAWIKI constant.
* (T329484) API: Fix query+allimages user parameter description.
* (T330529) SpecialEditTags: Set default of '' for wpReason.
* (T330382) postgres: Make the upgrade ignore dropping indexes that
  might not exist.
* (T330526) htmlform: Handle null from HTMLFormField::getDefault in
  multiselects.
* (T291753) rdbms: escape backslashes in makeConnectionString for PostgreSQL.
* (T325529) Fix total breakage of wgCanonicalServer fallback.
* (T318103) mediawiki.storage: Disable async GC during integration test.
* (T332461, T332397) TempFSFile: Keep the WeakMap alive.
* (T332902) page: fix InvalidArgumentException in SQLPlatform::makeList.
* (T285159, CVE-2023-29141) SECURITY: Do not apply autoblocks to untrusted
  XFF headers.

== MediaWiki 1.39.2 ==

This is a maintenance release of the MediaWiki 1.39 branch.

=== Changes since MediaWiki 1.39.1 ===
* Localisation updates.
* (T325872) ChangeTags: Remove table name from condition.
* (T324895) MWCallbackStream: Add explicit $stream property.
* (T297031, T326039) PostgresUpdater: Move setDefault ahead of
  changeNullableField.
* (T321319) Produce HTML for invalid JSON.
* (T215466, T326071) MigrateActors: Write to revision table (Follow-up 24115a8).
* (T223027) ReservedUsernames config: Add reserved names from maintenance
  scripts.
* (T325000, T324896, T307631) Updated OOUI from v0.44.3 to v0.44.5.
* Remove /images .htaccess rules that are no longer relevant.
* Disable php in .htaccess of images directory as a hardening measure.
* (T322583) Include missing message parameter in message.
* LocalFileTest: use encodeBlob/decodeBlob for img_metadata.
* DatabaseSqlite: fix null blobs.
* rdbms: avoid pg_escape_bytea() call-style deprecation notices.
* (T322278) Improve LocalisationCache post-merge validation check.
* (T324408, T326367) Updated wikimedia/remex-html from 3.0.2 to 3.0.3.
* (T322278) Fix the remaining Phan failures on PHP 8.1.
* (T322278, T326367) Respond to some messages from Phan on PHP 8.1.
* Fix phan error when Excimer is enabled.
* (T326021) Add matrix: to $wgUrlProtocols.
* (T314099) stream wrapper: Declare $context class property.
* (T314099) libs\jsminplus: Declare JSNode::$expression.
* (T314096) composer.json: Updated composer/spdx-licenses from 1.5.6 to 1.5.7.
* (T326472) Upgrading cssjanus/cssjanus (v2.1.0 => v2.1.1).
* (T308536) rdbms: Remove deprecation mark for $wgSharedDB.
* (T215466, T326071) installer: Split drop action out of the SQL patch for actor
  migration.
* (T322603) SqliteMaintenance.php: Fix fatally broken instanceof check.
* (T326377) rdbms: Use DBConnRef in SelectQueryBuilder.
* api/en.json: api-help-datatype-expiry add missing 'may'.
* (T317329) OutputPage: Fix undefined ['host'] in ImagePreconnect code.
* (T328222) Pass empty string to strlen() if schema is null for
  PostgresDatabase.
* (T289926) SpecialRevisionDelete: Set default of '' for wpReason.
* (T155582, T328503) Fix XML dumps for content types with non-string
  getNativeData().
* (T326886) PoolCounterRedis: Fix wrong cast, locks weren't being released.
* (T314099) revisiondelete: Replace dynamic property Status::$itemStatuses
* (T327821) skin: Restore default 'value' attribute in makeSearchButton().
* (T329198) ParamValidator: Improve paramvalidator-help-multi-max message.
* (T329415) Clear the statsd data buffer regardless of StatsdServer config.
* (T292348) WikiImporter: do not fail if upload entry in dump lacks 'text' tag.
* (T330049) UnregisteredLocalFile: Don't call MimeAnalyzer if no path.
* (T324894 TempFSFile: Use a WeakMap for reference tracking if available.
* (T295637) Add no to fallback chain of nb and nn.

== MediaWiki 1.39.1 ==

This is a security and maintenance release of the MediaWiki 1.39 branch.

=== Changes since MediaWiki 1.39.0 ===
* Localisation updates.
* PostgresUpdater: Remove trailing space from 'user_id ' column.
* (T304515) LCStoreStaticArray: atomically replace the cache file.
* (T324516) postgres: Fix upgrade for templatelinks primary key.
* (T324890, T324891, T324901) Parser: Allow dynamic properties on PHP 8.2.
* (T324513) uuid\GlobalIdGenerator: Check if getmyuid() exists.
* (T314099) OutputPage: Remove unused dynamic property ParserOptions->isBogus.
* (T314099) api: Remove use of undeclared property in action=comparepages.
* Upgrading wikimedia/xmp-reader (0.8.5 => 0.8.6).
* (T324489) Upgrading wikimedia/parsoid (v0.16.0 => v0.16.1).
* Updated pear/mail (v1.4.1 => v1.5.0).
* Removed wikimedia/dodo (v0.4.0).
* (T324910) On pages using multi-content revisions, the raw content of a
  specific slot can be retrieved using the action=raw&slot=<role-name> query
  parameters.
* (T322637) SECURITY: sqlite should not create DB file world-readable.

== MediaWiki 1.39.0 ==

=== Changes since MediaWiki 1.39.0-rc.1 ===
* Localisation updates.
* exception: Tolerate no service container when trying DB rollback.
* (T320282) Upgrading wikimedia/xmp-reader (0.8.3 => 0.8.4).
* objectcache: Deprecate WANObjectCache::reap() and ::reapCheckKey().
* (T320864) When calling mail(), use an array for headers.
* Upgrading wikimedia/xmp-reader (0.8.4 => 0.8.5).
* (T321154) Call setFormIdentifier() on LogEventsList form.
* When importing revision with same timestamp as latest revision, treat
  it as the new latest.
* (T320726) RandomImageGenerator::getImageSpec: Don't pass a float to mt_rand(),
  for PHP 8.1.
* (T298485, T322360) WikiExporter: Avoid calling reload in processing every row.
* (T321551) pager: Fix null used for foreach in Pager::getNavigationBar.
* (T321551) pager: Remove unused AlphabeticPager::getOrderTypeMessages()
  support.
* pager: Remove unused PagerNavigationBuilder::setExtra().
* PagerNavigationBuilder: Document that nulls in setLinkQuery() etc. are
  allowed.
* (T322335) ApiQueryRevisionsBase: Fix 'rvdiffto' parameter handling on PHP 8.0.
* (T314096) TestFileEditor: Fix string interpolation.
* (T289926) api: Fix minor PHP 8.1 incompatibility in ApiOptions.
* (T322803) SpecialBotPasswords: Don't pass null to trim().
* (T289926) Fix incomplete ITextFormatter mocks.
* Language: Handle ronna and quetta.
* (T72510) rdbms: make SqlitePlatform::tableName() apply double quotes.
* (T323373) Parser: Fix extractSections() behavior for PHP >= 8.0.
* .gitattributes: Ship docker-compose.yml to the tarball.

== MediaWiki 1.39.0-rc.1 ==

=== Changes since MediaWiki 1.39.0-rc.0 ===
* Localisation updates.
* (T318481) composer: Drop symfony/php73-polyfill.
* (T318460) SpecialChangeEmail: Set default for returntoquery.
* (T318307) HTMLFormField::validate(): Update docs to permit all data types
* (T306802) docker: update to latest published images.
* (T318754) WebInstallerOptions::addPersonalizationOptions(): Close fieldset.
* (T227047) Soft-deprecate the remainder of ActorMigration.
* (T316304, CVE-2022-41767) SECURITY: reassignEdits doesn't update results
  in an IP range check on Special:Contributions.
* (T309894, CVE-2022-41765) SECURITY: HTMLUserTextField exposes existence
  of hidden users.
* (T307278, CVE-2022-41766) SECURITY: On action=rollback the message
  "alreadyrolled" can leak revision deleted user name.
* (T319186) .phan/config.php: Update minimum_target_php_version.
* Tests: Explicit cast to int in RandomImageGenerator test (php8 warnings).
* (T319186) .phan/config.php: Update minimum_target_php_version.
* (T310243) Deprecate use of 'wvui-search' package.
* utils: Fix return doc about false/null for UrlUtils::expand.
* (T319000) WebInstaller: Don't try and run trim() on null.
* In the event of preg failure in MagicWordArray throw exception.
* (T318753) Installer: Disable logo dropper for now.

== MediaWiki 1.39.0-rc.0 ==

== Upgrading notes for 1.39 ==
Don't forget to always back up your database before upgrading!

See the file UPGRADE for more detailed per-version upgrade instructions from the
oldest supported upgrading version, MediaWiki 1.31.

Some specific notes for MediaWiki 1.39 upgrades are below:
* (T278139) Drop PHP 7.3 support in MediaWiki 1.39; require 7.4.3 or higher.

For notes on 1.38.x and older releases, see HISTORY.

=== Configuration changes for system administrators in 1.39 ===

==== New configuration ====
* $wgAutoCreateTempUser – This configures automatic user creation on page save.
* $wgCopyUploadAllowOnWikiDomainConfig – This configures if administrators can
  use the MediaWiki:Copyupload-allowed-domains system message to define which
  domains can be used with the upload-by-url tool.
* $wgCdnMatchParameterOrder – This can be set to false if MediaWiki is behind a
  CDN that re-orders query parameters. This will make the code that matches
  request URLs to canonical CDN URLs insensitive to parameter order.
* $wgMultiShardSiteStats – This allows you to split site_stats across multiple
  rows. Only useful for very large, heavily edited wikis. (T306589)
* $wgPrivilegedGroups – Users belonging in some of the listed groups will be
  audited more aggressively.

==== Changed configuration ====
* $wgInvalidUsernameCharacters – This setting now contains the char '>', which
  is now the reserved delimiter for external user names.
* $wgLocalFileRepo – The default serialization method for file meta-data has
  been changed to JSON. You can revert it to PHP by setting the property
  'useJsonMetadata' to false.
* $wgLBFactoryConf – The 'configCallback' flag can now be set to a callback
  function that returns an array with keys to update in $wgLBFactoryConf. This
  can be used to update the database configuration on the fly, e.g. to take
  replica hosts out of rotation.
* $wgDBservers and $wgLBFactoryConf – The DBO_SSL flag in has been deprecated in
  favour of a boolean "ssl" parameter.
* $wgObjectCaches – The 'globalKeyLB' and 'localKeyLB' flags are no longer
  supported.

==== Removed configuration ====
* $wgMultiContentRevisionSchemaMigrationStage - This transition flag, deprecated
  since MediaWiki 1.35, has been removed; the data migration is over.
* $wgActorTableSchemaMigrationStage - This transition flag has been removed; the
  data migration is over.
* $wgWikiFarmSiteDetector – This experimental setting has been removed without
  replacement. Use the MW_WIKI_NAME environment variable to specifiy the name of
  the site for which to load configuration. Using the WIKI_NAME environment
  variable for this purpose is deprecated.
* $wgParserCacheUseJson - The ParserCache now always uses JSON serialization.
  Reading old non-JSON cache entries is still supported. The setting had been
  deprecated since 1.36.
* $wgAllowJavaUploads - To allow uploads of JAR files, remove application/java
  from $wgMimeTypeExclusions.
* $wgMaxRedirects – This broken feature was removed, as it never worked as
  intended (T296430).
* $wgElementTiming – This experimental, default-disabled feature has been
  removed without replacement.
* $wgPriorityHints and $wgPriorityHintsRatio – The related experimental feature
  has been removed without replacement.
* $wgIncludeLegacyJavaScript – This flag has been removed, without loss of any
  functionality in this release. Most former "wikibits" functions were removed
  after deprecation in previous releases. The remaining functions, such as
  importScript, are now available unconditionally.
* $wgLegacySchemaConversion - This unused setting has been removed.
* $wgInterwikiPrefixDisplayTypes - This unused setting has been removed.
* $wgMangleFlashPolicy – This is no longer functional, and is now deprecated.
  Users who are somehow still using Flash as a browser extension will be exposed
  to CSRF vulnerabilities.

=== New user-facing features in 1.39 ===
* Optional automatic user creation on page save ($wgAutoCreateTempUser)
* Administrators now have the option to delete/undelete the associated "Talk"
  page when they are (un)deleting a given page. `deletetalk` and `undeletetalk`
  options were added to the 'delete' and 'undelete' action APIs in MW 1.38.
* `{{=}}` is now a wikitext built-in magic word, expanding to `=`.  This is
  conventionally used as an escape mechanism to allow the use of `=` in
  unnamed template arguments.  Defining [[Template:=]] to expand to something
  other than `=` has been deprecated since 1.36, with affected pages put into
  a special tracking category for migration.
* (T284020) Bot passwords are now supported when using the REST API.

=== New developer features in 1.39 ===
* Added optional $size param to SearchResultProvideThumbnail hook.
* SearchResultProvideThumbnail hook interface moved from MediaWiki\Rest\Hook
  namespace to MediaWiki\Search\Hook.
* JsonValidateSaveHook has been added to allow extensions to set additional
  pre-save validations for specific JSON pages (T313254)
* Added 'PermissionErrorAudit' hook, enabling extensions to audit permission
  errors on specfic actions. For instance account registration failed attempts
  due to a block (T306018).

=== External library changes in 1.39 ===

==== New external libraries ====
* Added Codex v0.1.1. This replaces the now deprecated wvui library.
* Added symfony/polyfill-php81.
* Added symfony/polyfill-php82.
* Added symfony/polyfill-php83.

===== New development-only external libraries =====
* Updated QUnit from 2.18.0 to 2.18.2.

==== Changed external libraries ====
* Updated jQuery from v3.6.0 to v3.6.1.
* Updated OOUI from v0.43.2 to v0.44.5.
* Updated composer/semver from 3.2.6 to 3.3.2.
* Updated cssjanus/cssjanus fromv2.1.0 to v2.1.1.
* Updated pear/mail from v1.4.1 to v1.5.1.
* Updated symfony/polyfill-php80 from 1.25.0 to 1.28.0.
* Updated symfony/yaml from 5.4.3 to 5.4.23.
* Updated vue/compat from 3.2.23 to 3.2.37.
* Updated wikimedia/base-convert from 2.0.1 to 2.0.2.
* Updated wikimedia/html-formatter from 3.0.1 to 4.0.3.
* Updated wikimedia/ip-set from 3.0.0 to 3.1.0.
* Updated wikimedia/minify from 2.2.6 to 2.3.0.
* Updated wikimedia/php-session-serializer from 2.0.0 to 2.0.1.
* Updated wikimedia/remex-html from 3.0.2 to 3.0.3.
* Updated wikimedia/running-stat from 1.2.1 to 2.1.0.
* Updated wikimedia/scoped-callback from 3.0.0 to 4.0.0.
* Updated wikimedia/services from 2.0.1 to 3.0.0.
* Updated wikimedia/timestamp from 3.0.0 to 4.1.1.
* Updated wikimedia/xmp-reader from 0.8.1 to 0.8.6.

===== Changed development-only external libraries =====
* Updated composer/spdx-licenses from 1.5.5 to 1.5.7.
* Updated doctrine/dbal for PHP < 7.3 from 2.13.6 to 2.13.9.
* Updated doctrine/dbal for PHP >= 7.3 from 3.1.5 to 3.4.2.
* Updated mediawiki/mediawiki-phan-config from 0.11.1 to 0.12.1.

==== Removed external libraries ====
* Removed wikimedia/dodo (v0.4.0).

=== Bug fixes in 1.39 ===
* (T314013) $wgExtraNamespaces no longer overrides canonical namespace names
  specified in extension.json files. While this setting can still be used to
  rename extension-defined namespaces, system administrators may need to run
  namespaceDupes.php after upgrading.

=== Action API changes in 1.39 ===
* New `undeletetalk` parameter on action=undelete that allows you to restore
  all revisions of the associated talk page.

=== Languages updated in 1.39 ===
MediaWiki supports over 350 languages. Many localisations are updated regularly.
Below only new and removed languages are listed, as well as changes to languages
because of Phabricator reports.

* Actual localization was added for several languages, which were already
  in Names.php and even used for a Wikipedia:
** (T313200) Added language support for Rundi (Kirundi, rn).
** (T310976) Added language support for Tumbuka (ChiTumbuka, tum).
** (T314270) Added language support for Kanuri (kr).
* (T313199) Added language support for Sylheti (syl).
* (T311975) Added language support for Ghanaian Pidgin (gpe).
* (T307080) Added language support for Okinawan (ryu).
* (T307887) Added language support for Mooré (mos).
* (T308813) Added language support for Nigerian Pidgin (pcm).
* (T309763) Added language support for Tai Nüa (tdd).
* (T310040) Added language support for Fante (fat).
* (T311034) Added language support for Campidanese Sardinian (sro).
* (T315406) Fix the autonym of the Iñupiaq language to "Iñupiatun".
* (T315677) Removed French fallback from the Fula language (ff).
* (T304920) In Swahili, The "Media" namespace is now "Media", as in English,
  and the "File" namespace is now "Faili". The old name of the "File" namespace
  was "Picha", and it's kept for backwards compatibility. If you manage a wiki
  in Swahili, and you use "Faili:" as a namespace anywhere in wikitext, and
  you mean to use it as "Media:", these need to be replaced to "Media:".
* (T309866) Some namespace translations were updated for Kyrgyz (ky). The old
  ones are retained as aliases for backwards compatibility.
* (T117845) Started the renaming of the language codes for Serbian from sr-ec
  and sr-el to sr-cyrl and sr-latn.
* (T295637) Add no to fallback chain of nb and nn.

=== Breaking changes in 1.39 ===
* Basic non-JavaScript (Grade C) support has been dropped for Internet Explorer
  9-10, Firefox 27-38, and Android 4.3-4.4.
* The following methods, deprecated since 1.37, have been removed from IDatabase
  - ::fetchObject()
  - ::fetchRow()
  - ::numRows()
  - ::freeResult()
* Title::getDefaultNamespace(), deprecated since 1.37, has been removed.
* The DBPrimaryPos class alias 'DBMasterPos' has been removed.
* The global function wfGetLB(), deprecated since 1.27, has been removed.
* Passing a db to BlockRestrictionStore::loadByBlockId() is no longer supported.
  BlockRestrictionStoreFactory should be used to fetch a correct
  BlockRestrictionStore instead. This was deprecated since 1.38.
* The global function wfGetCache(), deprecated since 1.32, has been removed. You
  can use ObjectCache::getInstance() instead.
* The global function wfGetMainCache(), deprecated since 1.32, has been removed.
  You can use ObjectCache::getLocalClusterInstance() instead.
* MovePage::__construct() now requires that all parameters be passed. The
  fallback to MediaWikiServices emitted deprecation notices since 1.37.
* WikiPage::doEditContent(), deprecated since 1.32, was removed.
* WikiPage::prepareContentForEdit() now requires a UserIdentity parameter to be
  provided. Not providing one has been deprecated since 1.37.
* EventRelayerKafka, deprecated in 1.38, was removed.
* MediaWiki\Logger\Monolog\KafkaHandler, deprecated in 1.38, was removed.
* The "trace" option of SectionProfiler, deprecated in 1.38, was removed.
* The global function wfWikiID(), deprecated since 1.35, has been removed.
* Database::wasKnownStatementRollbackError() was removed. Subclasses should
  override isKnownStatementRollbackError() instead.
* Database::wasQueryTimeoutError() was removed. Subclasses should
  override isQueryTimeoutError() instead.
* Database::buildSuperlative() has been removed without deprecation.
* The following methods, deprecated in 1.37, have been removed:
  - Linker::setStubThreshold(), ::getStubThreshold().
  - LinkRendererFactory::createForUser().
  - ParserOptions::getStubThreshold(), ::setStubThreshold().
* Changes to ResourceLoader modules:
  - The mediawiki.viewport module, deprecated in 1.37 has been
     removed. Use IntersectionObserver instead.
* If you manage a wiki in Swahili, and you use "Faili:" as a namespace anywhere,
  and you mean to use it as "Media:", replace it with "Media:". See T304920.
* Changes to skins:
  - Skin::getCopyrightIcon(), ::getPoweredBy(), deprecated in 1.37 have been
    removed.
  - Skin::bottomScripts, deprecated in 1.37, now emits deprecation notices.
    Skins using SkinTemplate must set bodyOnly as a skin option and
    remove lines of code generating html, body and head elements.
  - Skin::makeSearchButton and Skin::makeSearchInput were deprecated in 1.38.
    Use SkinTemplate methods with the same name or Skin::getTemplateData
    instead.
  - Styles for the HTML classes `warningbox`, `errorbox` and `successbox` have
    been removed in favor of Html class methods.
  - The feature `legacy` used inside ResourceLoaderSkinModule,
    deprecated in 1.37, will no longer ship any styles.
  - Skin::getSkinStylePath, deprecated since 1.36, has been removed.
  - Skin::getPortletData has been made private.
  - SkinTemplate::getPersonalToolsList(), deprecated in 1.35 has been
    removed.
  - The following SkinTemplate template data, deprecated in 1.37,
    have been removed:
     - poweredbyico
     - copyrightico
  - The following hooks, deprecated in 1.37, have been removed:
     - SkinGetPoweredBy: SkinGetPoweredByHook
  - The following hooks are deprecated and replaced with
    SkinTemplateNavigation::Universal:
     - SkinTemplateNavigation::SpecialPage
     - SkinTemplateNavigation
     - PersonalUrls
  - The mediawiki.skinning.content.externallinks module, which was
    deprecated in 1.36 has been removed. Skins that still rely on it
    will lose the icon styling of external links by type.
* Experimental wiki farm support: Automatic detection of the requested site
  within a wiki farm based on the requested domain has been removed.
  Use the MW_WIKI_NAME environment variable to specify the name of the site
  to load configuration for. Using the WIKI_NAME environment variable for this
  purpose is deprecated. This is only relevant if you have been using
  $wgWikiFarmSettingsDirectory to load wiki farm config.
* MWExceptionHandler::installHandler was marked @internal and had required
  arguments added. This method is intended for use in bootstrap code and is
  unused in known extensions.
* MWException::useOutputPage was made private without deprecation.
  This method was apparently only public for testing and is unused in known
  extensions.
* Calling getId() on a User or UserIdentityValue from the wrong wiki, deprecated
  since 1.36, now throws an exception.
* The following methods have been removed from ExtensionRegistry without
  deprecation and without replacement. They had been introduced in 1.35 for use
  in the testing framework, and were not in use by any known extension:
  - exportAutoloadClassesAndNamespaces
  - exportTestAutoloadClassesAndNamespaces
* The MWNamespace class, deprecated since 1.34, has been removed. Use the
  NamespaceInfo service instead.
* The UnknownContent and UnknownContentHandler class aliases have been removed,
  use FallbackContent and FallbackContentHandler instead.
* IResultWrapper::next() now returns void, to match the Iterator interface that
  it implements. fetchObject() has the same behavior as next() used to.
* In HTMLForm HTMLAutoCompleteSelectFields, the parameters 'autocomplete' and
  'autocomplete-messages', which were deprecated in MediaWiki 1.29, were
  removed. Instead, use 'autocomplete-data' and 'autocomplete-data-messages'.
* The global $wgParser, deprecated in 1.32, was removed. Use
  MediaWikiServices::getInstance()->getParser() instead.
* ParserOutput::setText will now set the ParserOutput's text to null if
  given null. Previously it did nothing if given null.
* The default value for the first argument to the ParserOutput constructor
  is now null instead of ''.
* IDatabase::lockTables() and IDatabase::unlockTables(), deprecated since 1.38,
  have been removed.
* The $context parameter to `new HTMLForm( … )` and `HTMLForm::factory( … )`
  is now required.
* The class alias for revision related classes in namespace MediaWiki\Storage
  has been removed. Classes are IncompleteRevisionException,
  MutableRevisionRecord, MutableRevisionSlots, RevisionAccessException,
  RevisionArchiveRecord, RevisionFactory, RevisionLookup, RevisionRecord,
  RevisionSlots, RevisionStore, RevisionStoreRecord, SlotRecord, and
  SuppressedDataException.
* Calling getBy() on an AbstractBlock from the wrong wiki, deprecated since
  1.38, now throws an exception.
* Passing a MediaWiki\Linker\LinkTarget to EditPage::makeTemplatesOnThisPageList
  or TemplatesOnThisPageFormatter::format is no longer supported,
  a MediaWiki\Page\PageIdentity is required.
* The deprecated class alias FakeConverter has been removed, use
  TrivialLanguageConverter instead.
* The deprecated ApiQueryContributions class alias has been removed, use
  ApiQueryUserContribs instead.
* The deprecated MediaWiki\Special\SpecialPageFactory class alias has been
  removed, use MediaWiki\SpecialPage\SpecialPageFactory instead.
* The following skin modules, deprecated in 1.37, have been removed:
	- mediawiki.skinning.elements
	- mediawiki.skinning.content
	- mediawiki.toc.styles
	- mediawiki.legacy.config
	- mediawiki.legacy.shared
	- mediawiki.legacy.commonPrint
* FileModule::compileLessFile(), deprecated since 1.35, has been removed. Use
  ::compileLessString() instead.
* LogFormatter::styleRestricedElement(), deprecated since 1.37, has been
  removed. Use ::styleRestrictedElement() instead.
* Title::isNamespaceProtected(), deprecated in 1.34, has been removed.
* ApiStashEdit::parseAndStash(), deprecated in 1.34, has been removed.
* LinkCache::forUpdate(), deprecated in 1.34, has been removed.
* Passing null instead of a NamespaceInfo instance to LinkCache::__construct()
  is not supported anymore. It is recommended to request an instance from the
  service container.
* ApiQueryBase::showHiddenUsersAddBlockInfo(), deprecated in 1.34, has been
  removed. Use ApiQueryBlockInfoTrait instead.
* ApiQueryBase::prefixedTitlePartToKey(), deprecated in 1.35, has been removed.
  Use ::parsePrefixedTitlePart() instead.
* ExternalStoreDB::getSlave(), deprecated in 1.34, has been removed. Use
  ExternalStoreDB::getReplica() instead.
* ChangesListSpecialPage::checkStructuredFilterUiEnabled() and
  SpecialWatchlist::checkStructuredFilterUiEnabled() now support UserIdentity
  as the only argument. Passing Config argument was deprecated in 1.34.
* DatabaseUpdater::ifNoActorTable(), deprecated in 1.35, has been removed. Use
  ::ifTableNotExists() instead.
* MediaWiki\Revision\RevisionStoreFactory::getRevisionStore was documented
  to allow passing bool true as a dbDomain, this is no longer possible,
  because that is an invalid value for a dbDomain.
* LinkHolderArray::__construct() had its signature changed. The class was marked
  internal in 1.35.
* SpecialMute::isTargetBlacklisted(), deprecated in 1.35, has been removed. Use
  ::isTargetMuted() instead.
* WebRequest::checkUrlExtension(), deprecated in 1.35, has been removed.
* ContentHandler::cleanupHandlersCache(), deprecated in 1.35, has been removed.
* SpecialVersion::getExtAuthorsFileName, deprecated in 1.35, has been removed.
  Use MediaWiki\ExtensionInfo::getAuthorsFileName.
* SpecialVersion::getExtLicenseFileName, deprecated in 1.35, has been removed.
  Use MediaWiki\ExtensionInfo::getLicenseFileNames.
* CategoryPage::getCategoryViewerClass and ::setCategoryViewerClass, deprecated
  in 1.35, have been removed.
* SqlBlobStore::getLegacyEncodingConversionLang(), deprecated in 1.34, has been
  removed.
* wfCanIPUseHTTPS(), deprecated in 1.37, has been removed.
* wfGetScriptUrl(), deprecated in 1.35, has been removed.
* The following methods of Database class, are no longer stable to override:
  - ::implicitOrderby()
  - ::selectSQLText()
  - ::bitNot()
  - ::bitAnd()
  - ::bitOr()
  - ::buildConcat()
  - ::buildGreatest()
  - ::buildLeast()
  - ::buildSubstring()
  - ::buildStringCast()
  - ::buildIntegerCast()
  - ::tableName()
  - ::addIdentifierQuotes()
  - ::buildLike()
  - ::limitResult()
  - ::unionSupportsOrderAndLimit()
  - ::unionQueries()
  - ::conditional()
  - ::strreplace()
  - ::timestamp()
  - ::getInfinity()
  - ::setTableAliases()
  - ::setIndexAliases()
  - ::buildGroupConcatField()
* SpecialUnblock::processUnblock(), deprecated in 1.36, has been removed. Use
  UnblockUser instead.
* wfLocalFile() and wfFindFile(), deprecated in 1.34, have been removed.
* Maintenance script resetUserTokens.php, deprecated in 1.27, has been removed.
* These methods in Database have been removed without deprecation as they are
  not used outside core. Users should override corresponding methods in
  SQLPlatform instead:
  - Database::doInsert -> SQLPlatform::insertSqlText
  - Database::doDropTable -> SQLPlatform::dropTableSqlText
  - Database::doRollback -> SQLPlatform::rollbackSqlText
  - Database::doSavepoint -> SQLPlatform::savepointSqlText
  - Database::doReleaseSavepoint -> SQLPlatform::releaseSavepointSqlText
  - Database::doRollbackToSavepoint -> SQLPlatform::rollbackToSavepointSqlText
* The following protected methods of Database class have been removed without
  deprecation as they are not used outside core. Users should call
  corresponding methods in SQLPlatform:
  - Database::makeInsertLists -> SQLPlatform::makeInsertLists
  - Database::isFlagInOptions -> SQLPlatform::isFlagInOptions
  - Database::normalizeOptions -> SQLPlatform::normalizeOptions
  - Database::fieldNameWithAlias -> SQLPlatform::fieldNameWithAlias
  - Database::isTransactableQuery -> SQLPlatform::isTransactableQuery
* $wgCanonicalNamespaceNames no longer includes custom namespaces defined using
  $wgExtraNamespaces. Extensions should use the NamespaceInfo service instead
  of accessing this configuration setting directly.
* The following hook, deprecated in 1.35, has been removed:
     - ParserGetVariableValueVarCache: ParserGetVariableValueVarCacheHook
* The $variableCache parameter to the ParserGetVariableValueSwitch hook is
  no longer used; non-standard use of this parameter has been deprecated since
  1.35.
* These methods have been moved from IDatabase to IMaintainableDatabase:
  - IDatabase::fieldExists -> IMaintainableDatabase::fieldExists
  - IDatabase::indexExists -> IMaintainableDatabase::indexExists
  - IDatabase::tableExists -> IMaintainableDatabase::tableExists
* DBConnRef doesn't accept live connection in constructor anymore.
  Only parameters for getting connection should be provided.
* IDatabase::getTopologyRootPrimary() was removed.
* User::blockedBy(), deprecated since 1.38, has been removed.
* User::getBlockId(), deprecated since 1.38, has been removed.
* AlphabeticPager::getOrderTypeMessages(), unused since 1.13, has been removed
  without deprecation.

=== Deprecations in 1.39 ===
* PageProps::getInstance(), deprecated since 1.38, emits deprecations warnings.
* The global function wfGetDB() has been deprecated. Use
  LoadBalancer::getConnection() instead.
* SpecialRedirectWithAction::__construct without SearchEngineFactory argument
  will now emit a deprecation notice.
* Use of the SiteStatsUpdate constructor has been deprecated in favor of
  the ::factory() method.
* AuthManager::checkAccountCreatePermissions has been deprecated. Use
  AuthManager::authorizeCreateAccount or AuthManager::probablyCanCreateAccount
  instead.
* Title::getSelectFields() has been deprecated in favor of
  PageStore::newSelectQueryBuilder()
* Title::newFromTitleValue(), deprecated since in 1.34, now emits deprecation
  warnings. Use ::newFromLinkTarget() instead.
* ExtensionRegistry::readFromQueue() has been marked @internal. Extensions
  should use ExtensionProcessor instead.
* Processor::getExtraAutoloaderPaths() and
  ExtensionProcessor::getExtraAutoloaderPaths() have been deprecated, use get
  getExtractedAutoloadInfo() instead.
* The following global functions are deprecated in favor of the listed UrlUtils
  methods.
  - wfExpandUrl -> UrlUtils::expand
  - wfGetServerUrl -> UrlUtils::getServer
  - wfAssembleUrl -> UrlUtils::assemble
  - wfRemoveDotSegments -> UrlUtils::removeDotSegments
  - wfUrlProtocols -> UrlUtils::validProtocols
  - wfUrlProtocolsWithoutProtRel -> UrlUtils::validAbsoluteProtocols
  - wfParseUrl -> UrlUtils::parse
  - wfExpandIRI -> UrlUtils::expandIRI
  - wfMatchesDomainList -> UrlUtils::matchesDomainList
  These methods are exact replacements except that
  1) they return null instead of false or empty string on error (where
     applicable);
  2) UrlUtils::validProtocols does not take a parameter (documentation said not
     to pass one to wfUrlProtocols anyway);
  3) they use type hints (don't try passing null instead of string, etc.).
* MaintainableDBConnRef is deprecated, use DBConnRef instead.
* Loading DefaultSettings.php is deprecated. To get default values of main
  config settings, use MainConfigSchema::listDefaultValues() or
  MainConfigSchema::getDefaultValue().
* AbstractContent::getRedirectChain() and
  AbstractContent::getUltimateRedirectTarget() are now emitting deprecation
  warnings (T296430).
* (T244138) QueryPage::getSQL() is deprecated. Instead QueryPage::getQueryInfo()
  should be overridden.
* Calling new JobRunner() directly without $serviceOptions now emits
  deprecation warnings. Use MediaWikiServices::getInstance()->getJobRunner()
  instead.
* Passing an array of targets to Article::getRedirectHeaderHtml() is
  deprecated. Supply a single redirect target instead (T296430).
* The following Less mediawiki.mixins have been deprecated:
  - .animation()
  - .animation-delay()
  - .transform-rotate()
* Skin::getAction is deprecated. Use IContextSource::getActionName instead.
* User::getOption, deprecated since 1.35, now emits deprecation warnings.
  Use UserOptionsLookup::getOption instead.
* ILBFactory::forEachLB() is deprecated. Use ::getAllLBs().
* LoadBalancer::forEachOpenConnection() and ::forEachOpenPrimaryConnection()
  are deprecated without replacement.
* The following classes were moved from the root namespace to the
  MediaWiki\ResourceLoader namespace, the old names becoming deprecated aliases:
  ResourceLoader, MessageBlobStore, VueComponentParser.
* The following classes had the "ResourceLoader" prefix stripped while being
  moved to the MediaWiki\ResourceLoader namespace, the old names becoming
  deprecated aliases: DerivativeResourceLoaderContext,
  ResourceLoaderCircularDependencyError, ResourceLoaderClientHtml,
  ResourceLoaderCodexModule, ResourceLoaderContext, ResourceLoaderFileModule,
  ResourceLoaderFilePath, ResourceLoaderForeignApiModule, ResourceLoaderImage,
  ResourceLoaderImageModule, ResourceLoaderLanguageDataModule,
  ResourceLoaderLessVarFileModule, ResourceLoaderModule,
  ResourceLoaderMwUrlModule, ResourceLoaderOOUIFileModule,
  ResourceLoaderOOUIIconPackModule, ResourceLoaderOOUIImageModule,
  ResourceLoaderOOUIModule, ResourceLoaderSiteModule,
  ResourceLoaderSiteStylesModule, ResourceLoaderSkinModule,
  ResourceLoaderStartUpModule, ResourceLoaderUserModule,
  ResourceLoaderUserOptionsModule, ResourceLoaderUserStylesModule,
  ResourceLoaderWikiModule.
* WANObjectCache::reap() and WANObjectCache::reapCheckKey() have been
  deprecated without replacement.
* The following methods in WikiRevision and their interfaces
  ImportableUploadRevision and ImportableOldRevision are deprecated:
  - ::getUserObj() → ::getUser()
  - ::setUserObj() → ::setUsername()
  - ::setUserIP() → ::setUsername()
* ObjectCache::addBusyCallback() is deprecated and non-functional.
* MWTimestamp::getHumanTimestamp(), deprecated in 1.26, now emits deprecation
  warnings.
* Article::viewRedirect(), deprecated in 1.30, now emits deprecation warnings.
* Parser::getFreshParser() is deprecated, use ParserFactory::getInstance().
* CoreParserFunctions::mwnamespace() is deprecated and emits deprecation
  warnings, use CoreParserFunctions::namespace() instead.
* Registering magic variables whose names include a colon is deprecated.
* User::blockedFor(), deprecated in 1.35, now emits deprecation warnings.
* Access to previously public properties AbstractBlock::$mExpiry,
  AbstractBlock::$mHideName, AbstractBlock::$mTimestamp, DatabaseBlock::$mAuto,
  and DatabaseBlock::$mParentBlockId, deprecated in 1.34, now emits deprecation
  warnings.
* Access to previously public properties User::$mBlock, User::$mBlockedby, and
  User::$mHideName, deprecated in 1.35, now emits deprecation warnings.
* JobQueueGroup::singleton() and ::destroySingletons(), deprecated in 1.37, now
  emit deprecation warnings.
* Title::getNotificationTimestamp(), deprecated in 1.35, now emits deprecation
  warnings.
* Global functions wfReadOnly and wfReadOnlyReason, deprecated in 1.38, now
  emit deprecation warnings.
* Overriding or calling DifferenceEngine::getDiffBodyCacheKey(), deprecated in
  1.31, now emits deprecation warnings.
* Access to previously public property WikiRevision::$fileIsTemp, deprecated in
  1.29, now emits deprecation warnings.
* wfQueriesMustScale() has been deprecated and emits deprecation warnings.
* ContextSource::getStats(), RequestContext::getStats(), and
  DerivativeContext::getStats(), deprecated in 1.27, now emit deprecation
  warnings.
* ManualLogEntry::setTags(), deprecated in 1.33, now emits deprecation warnings.
* WikiRevision::downloadSource(), deprecated in 1.31, now emits deprecation
  warnings.
* DifferenceEngine::textDiff(), deprecated in 1.32, now emits deprecation
  warnings.
* FormatMetadata::flattenArrayContentLang(), deprecated in 1.36, now emits
  deprecation warnings.
* SkinTemplate::getNameSpaceKey(), deprecated in 1.35, now emits deprecation
  warnings.
* EnqueueJob::newFromJobsByWiki(), deprecated in 1.33, now emits deprecation
  warnings.
* The following methods of the MWGrants class, all deprecated since 1.38,
  are now emitting deprecation warnings:
  - getValidGrants
  - getRightsByGrant
  - grantName
  - grantNames
  - getGrantRights
  - grantsAreValid
  - getGrantGroups
  - getHiddenGrants
  - getGrantsLink
  - getGrantsWikiText
* DataUpdate::runUpdates(), deprecated in 1.28, now emits deprecation warnings.
* CdnCacheUpdate::newFromTitles(), deprecated in 1.35, now emits deprecation
  warnings.
* Instantiating HTMLCacheUpdate class, deprecated in 1.34, now emits deprecation
  warnings.
* ISQLPlatform::tableNames() (implemented by IDatabase) is now deprecated.
  None of the tableName*() functions should be used by most users;
  if you absolutely must use raw SQL, write several tableName() calls instead.
* Language::isWellFormedLanguageTag() has been deprecated in favor of
  LanguageCode::isWellFormedLanguageTag().
* The PrevNextNavigationRenderer helper class has been deprecated in favor of
  the new PagerNavigationBuilder one.
* The methods IndexPager::getPagingLinks(), IndexPager::getLimitLinks() and
  IndexPager::buildPrevNextNavigation() have been deprecated in favor of
  IndexPager::getNavigationBuilder().
* Overriding the method IndexPager::makeLink() has been deprecated.
* ActorMigration is deprecated. The temporary table is no longer needed, the
  actor table can be directly joined to the revision table, which is simple
  enough to not need a helper class. See the methods of ActorMigration for more
  specific information on replacements. ActorMigrationBase remains usable for
  migrations in extension tables.

=== Other changes in 1.39 ===
* Dynamic default values are now applied before extension registration callbacks
  are run. This way, extensions have a complete view of config variables, with
  all defaults applied. For example, when the default value of X used to be
  static but becomes dynamic, and an extension reads the value of X in the
  registration callback, it will now continue to function as expected. In some
  cases however, this may cause an undesired change in behavior: if the dynamic
  default of setting X depends on the value of setting Y, and an extension
  changes Y, the changed value of Y will no longer affect the value of X.

== Compatibility ==

MediaWiki 1.39 requires PHP 7.4.3 or later and the following PHP extensions:

* ctype
* dom
* fileinfo
* iconv
* intl
* json
* mbstring
* xml

MariaDB is the recommended database software. MySQL, PostgreSQL, or SQLite can
be used instead, but support for them is somewhat less mature.

The supported versions are:

* MariaDB 10.3 or higher
* MySQL 5.7.0 or higher
* PostgreSQL 10 or later
* SQLite 3.8.0 or later

== Online documentation ==
Documentation for both end-users and site administrators is available on
MediaWiki.org, and is covered under the GNU Free Documentation License (except
for pages that explicitly state that their contents are in the public domain):

       https://www.mediawiki.org/wiki/Special:MyLanguage/Documentation

== Mailing list ==
A mailing list is available for MediaWiki user support and discussion:

       https://lists.wikimedia.org/mailman/listinfo/mediawiki-l

A low-traffic announcements-only list is also available:

       https://lists.wikimedia.org/mailman/listinfo/mediawiki-announce

It's highly recommended that you sign up for one of these lists if you're
going to run a public MediaWiki, so you can be notified of security fixes.

== IRC help ==
There's usually someone online in #mediawiki on irc.libera.chat.

= MediaWiki 1.38 =

== MediaWiki 1.38.7 ==

This is a security and maintenance release of the MediaWiki 1.38 branch.

=== Changes since MediaWiki 1.38.6 ===
* Localisation updates.
* (T333990) composer.json: Explicitly pin psr/http-message to 1.0.1.
* (T335203, CVE-2023-29197) SECURITY: Upgrading guzzlehttp/psr7
  (2.4.0 => 2.4.5).
* (T322944) Add Authorization to default $wgAllowedCorsHeaders.
* (T332889, CVE-2023-36675) SECURITY: Fix escaping in BlockLogFormatter.
* (T330464) Work around argument corruption bug in XMLReader::open.
* (T313157) IndexPager: Also protect against $offset being 0.
* (T335612, CVE-2023-36674) SECURITY: Move badFile lookup to Linker.

== MediaWiki 1.38.6 ==

This is a security and maintenance release of the MediaWiki 1.38 branch.

=== Changes since MediaWiki 1.38.5 ===
* Localisation updates.
* (T325872) ChangeTags: Remove table name from condition.
* (T324895) MWCallbackStream: Add explicit $stream property.
* (T297031, T326039) PostgresUpdater: Move setDefault ahead of
  changeNullableField.
* Remove /images .htaccess rules that are no longer relevent.
* Disable php in .htaccess of images directory as a hardening measure.
* (T322583) Include missing message parameter in message.
* Fix phan error when Excimer is enabled.
* (T323373) Parser: Fix extractSections() behavior for PHP >= 8.0
* (T326021) Add matrix: to $wgUrlProtocols.
* (T326377) rdbms: Use DBConnRef in SelectQueryBuilder.
* api/en.json: api-help-datatype-expiry add missing 'may'.
* (T328222) Pass empty string to strlen() if schema is null for
  PostgresDatabase.
* (T317329) OutputPage: Fix undefined ['host'] in ImagePreconnect code.
* (T289926) SpecialRevisionDelete: Set default of '' for wpReason.
* (T155582, T328503) Fix XML dumps for content types with non-string
  getNativeData().
* (T314099) revisiondelete: Replace dynamic property Status::$itemStatuses.
* (T329198) ParamValidator: Improve paramvalidator-help-multi-max message.
* (T292348) WikiImporter: do not fail if upload entry in dump lacks 'text'
  tag.
* (T295637) Add no to fallback chain of nb and nn.
* (T329484) API: Fix query+allimages user parameter description.
* (T330529) SpecialEditTags: Set default of '' for wpReason.
* (T330526) htmlform: Handle null from HTMLFormField::getDefault in
  multiselects.
* (T285159, CVE-2023-29141) SECURITY: Do not apply autoblocks to untrusted
  XFF headers.

== MediaWiki 1.38.5 ==

This is a security and maintenance release of the MediaWiki 1.38 branch.

=== Changes since MediaWiki 1.38.4 ===
* Localisation updates.
* Tests: Explicit cast to int in RandomImageGenerator test (php8 warnings).
* (T319000) WebInstaller: Don't try and run trim() on null.
* (T318753) Installer: Disable logo dropper for now.
* (T320864) When calling mail(), use an array for headers.
* (T311567) In ManualLogEntry, cast the comment to string.
* (T289926) api: Fix minor PHP 8.1 incompatibility in ApiOptions.
* (T322803) SpecialBotPasswords: Don't pass null to trim().
* (T323082) Upgrading wikimedia/xmp-reader (0.8.1 => 0.8.5).
* Language: Handle ronna and quetta.
* PostgresUpdater: Remove trailing space from 'user_id ' column.
* (T304515) LCStoreStaticArray: atomically replace the cache file.
* (T324890, T324891, T324901) Parser: Allow dynamic properties on PHP 8.2.
* (T324910) On pages using multi-content revisions, the raw content of a
  specific slot can be retrieved using the action=raw&slot=<role-name> query
  parameters.
* (T322637) SECURITY: sqlite should not create DB file world-readable.

== MediaWiki 1.38.4 ==

This is a maintenance release of the MediaWiki 1.38 branch.

=== Changes since MediaWiki 1.38.3 ===
* Fix missing use statement from backport of fix for T307278.

== MediaWiki 1.38.3 ==

This is a security and maintenance release of the MediaWiki 1.38 branch.

=== Changes since MediaWiki 1.38.2 ===
* Localisation updates.
* (T311568) UploadBase::setTempFile() handle $tempPath being passed as null.
* (T311559) SpecialListFiles: user parameter isn't always present.
* (T311561) ImageListPager: Don't call htmlspecialchars() on null.
* (T311920) SpecialBlockList: Prevent passing null to trim().
* (T311921) SpecialUserrights: Don't pass null to str_replace.
* (T311570) SpecialWithoutInterwiki: Don't pass null through to
  Title::capitalize().
* (T311574, T311576) SpecialLinkSearch: Don't pass null through to the parser.
* (T311360) RecentChange: Straight join to actor table when needed.
* (T311360) RecentChange: Make join to comment table also straight.
* Remove messages in en-gb.json.
* (T312519, T312520) Parser::extensionSubstitution() Don't run substr() on null.
* (T287564) populateInterwiki: Include not null columns iw_api/iw_wikiid.
* (T312302) SpecialRedirect: Don't pass null to explode.
* RemoveInvalidEmails: Fix quoting for postgres.
* (T312678) import: UploadSourceAdapter::stream_read() don't pass null to
  strlen().
* (T312300) SpecialDiff: Don't pass null to explode().
* (T312680) parser: Fix CoreParserFunctions::urlencode() null coalescence $arg.
* (T289926) Handle null passed to wfShorthandToInteger() and Html::element().
* (T289926) Ensure that strlen() does not get passed a (valid) null.
* (T312301) SpecialDiff: Don't pass null to trim().
* Hooks: Use more meaningful name for SkinAfterPortlet hook parameter.
* (T289926) Ensure we don't pass null to mb_strlen.
* (T312305, T311572, T311571, T311578) HTMLForm: Null coalescence in trim()
  calls.
* (T289926) site: Consistently return null from Site::getDomain().
* (T307304, T289879) filebackend,jobqueue: Add signature for
  FilterIterator::accept().
* (T304559) Use page ID from parent revision, improve logging.
* (T312183) rdbms: Adapt hasOrMadeRecentPrimaryChanges test mock for PHP 8.1.
* Add application/vnd.ms-opentype to MIME list.
* Allow composer/installers plugin in composer.json.
* (T313663) Make ReadOnlyModeTest work in php8.
* (T313663) Make HandlerTestTrait compatible with php8.1.
* (T313663) [php8] Make DeletePageTest stop giving warnings on php8.1.
* Change type hints for BatchRowIterator and NotRecursiveIterator for
  compatibility with PHP 8.1.
* (T313663) [php8.1] Change override of $wgResourceBasePath for CSP tests.
* (T313663) parser: Mock WikiPage::getContentModel in ParserCacheTest to fix
  php8.1.
* (T313663) [php8.1] Make WikiImporterFactoryTest use better mock for
  ImportSource.
* Fix tests so getName() doesn't return null.
* (T313663) [php8] Don't use strlen on potentially null string.
* (T313663) [php8.1] Suppress test warning about providing null.
* (T313663) [php8.1] mock User::getTitleKey() in DeaultPreferencesFactoryTest.
* (T313663) Parser will use current timestamp instead of null if passed a
  RevisionRecord that does not have a timestamp.
* (T313663) Add explicit null check for $sha in FileBackend [php8.1].
* (T313663) LogFormatter: Cast argument of ctype_digit to string [php8.1].
* (T313663) Mock UserOptionsManager::getOption for php8.1.
* (T289879, T289926) Get rid of warnings on PHP 8.1.
* (T313663) Check for null return of preg_replace in MediaWikiTitleCodec.
* (T313663) cast db name to string when checking if it is read only [php8.1].
* (T313663) Avoid testing strlen on null in ApiQuerySiteinfo [php 8.1 compat].
* (T313663) Use default timezone UTC for SpecialWatchlistTest [php 8.1].
* (T313663) Mock User::getTitleKey in SpecialPreferencesTest [php 8.1].
* (T314096) Migrate use of ${var}-style string interpolation.
* (T314099) preprocessor: Add missing field declarations.
* (T313663, T313662) Make default value for optional args {{PAGESINCAT:..}} be
  '' not null.
* (T313663) [php8.1] Mock out getLocalDomainID for WatchedItemStore tests.
* (T313663) Suppress warnings for the null test of addIdentifierQuotes.
* (T314225) SpecialCategories: Null coalescene $par.
* (T314099) User: Allow dynamic properties on PHP 8.2.
* (T314404) SpecialGoToInterwiki: Null coalescene $par.
* (T314397) SpecialBlock: Better handle null in getTargetUserTitle.
* (T314099) phpunit: Fix trivial dynamic property usages in tests.
* (T314405) UploadStash: Check if us_prop is set in the fileMetadata.
* (T313663) Make ChangesListSpecialPageTest cast to string for php 8.1.
* (T313663) Do not test giving a null fragment to Title::makeTitle.
* (T314550) SpecialMergeHistory: Set timestamp to '' if no mergepoint.
* (T314551) SpecialMergeHistory: Set defaults for target and dest parameters.
* (T313663) Cast results of Sqlite test to string [php 8.1].
* (T314208) Set $wgServer for HttpRequestFactoryTest to prevent warnings on
  php8.1.
* (T314208, T297082) phpunit: Fallback to global default user options.
* (T307282) Avoid passing null to strcasecmp(), for PHP 8.1.
* Fix a couple deprecation warnings in the installer under PHP 8.1.
* api: Add rel=nofollow to help examples.
* (T307613) Validate length of user email on Special:ChangeEmail/
  Special:CreateAccount.
* (T314226) LoginSignupSpecialPage: Check if $value is a string before length.
* (T314824) tests: Update parser test after i18n change.
* (T313663, T296083) context: Replace deprecated User::getOption.
* (T295958, T278847) MediaWiki-Docker: Switch PHP images to PHP7.4.
* (T314906, T314907) SpecialBlock: Set defaults for wpPageRestrictions and
  wpNamespaceRestrictions.
* (T315309) ImportStreamSource::newFromURL() Prevent passing null to fwrite.
* (T315892) composer.json: Pin phpunit to 8.5.28.
* (T313663) Do not compare byte-for-byte of serialized items in tests [php8.1].
* objectcache: avoid php 8.1 argument type warnings in
  genericKeyFromComponents().
* (T317750) session: Fix broken SessionTest case due to PHPUnit dependency
  change.
* ManualLogEntry: Don't pass null to trim() as PHP 8.1 whines.
* (T313663) Add a null check VueComponentParser to prevent php8.1 issues.
* (T313049) Bump wikimedia/parsoid to v0.15.1.
* (T318754) WebInstallerOptions::addPersonalizationOptions(): Close fieldset.
* (T318460) SpecialChangeEmail: Set default for returntoquery.
* (T318307) Update docs for HTMLFormField::validate() to permit all data types.
* (T316304, CVE-2022-41767) SECURITY: reassignEdits doesn't update results
  in an IP range check on Special:Contributions.
* (T309894, CVE-2022-41765) SECURITY: HTMLUserTextField exposes existence
  of hidden users.
* (T307278, CVE-2022-41766) SECURITY: On action=rollback the message
  "alreadyrolled" can leak revision deleted user name.

== MediaWiki 1.38.2 ==

This is a security and maintenance release of the MediaWiki 1.38 branch.

=== Changes since MediaWiki 1.38.1 ===
* Localisation updates.
* (T309426) Repair language selector for SVGs.
* (T310013) Fix default value for $wgShowEXIF and $wgUsePathInfo.
* (T308471) SECURITY: Escape welcomeuser message passed to showSuccessPage().
* (T308473) SECURITY: Escape contributions-title msg for use within page title.
* (T311272) Call parent constructor of AddSite maintenance script first.
* MediaWiki: Don't eagerly initialize action name.
* (T311384, CVE-2022-27776) Updated guzzlehttp/guzzle from 7.4.1 to 7.4.5.
* (T289926) Avoid passing null to trim() in SkinTemplate.
* (T289879) Address deprecations for PHP 8.1.
* (T311473) rollbackEdits: Pass user identity to RollbackPage.
* Upgrade wikimedia/remex-html from 3.0.1 to 3.0.2.
* (T311551) ShellboxClientFactory::getUrl(): Check if $this->key is null.
* (T311552) ChangesListSpecialPage: Don't pass null to FormatJson::decode().
* (T311569) FileBackend::isStoragePath() Handle being passed null.
* (T311544) Pass int to ApiUsageException::newWithMessage()'s $httpCode param.
* (T311678) SpecialEditWatchlist: Prevent passing null to strtolower().
* (T311554) ChangeTags: Return early in formatSummaryRow() if $tags === null.
* Upgrade wikimedia/common-passwords from 0.3.0 to 0.4.0.

== MediaWiki 1.38.1 ==

This is a maintenance release of the MediaWiki 1.38 branch.

=== Changes since MediaWiki 1.38.0 ===
* (T309860) Add justinrainbow/json-schema to vendor.
* (T309933) Drop PHP 7.2 support in MediaWiki 1.38; require 7.3.19.

== MediaWiki 1.38.0 ==

=== Changes since MediaWiki 1.38.0-rc.1 ===
* Localisation updates.
* (T309114) LocalFile::prerenderThumbnails: Limit the number of thumbnail
  jobs triggered.
* (T305779) phpunit: Support setting skin context in BundleSizeTest subclasses.
* (T309028) SECURITY: ApiEditPage: update title after redirects.
* (T308967) notifications: prevent log spam when invalid user object listed.
* composer: Lock Parsoid version to specific 0.15.0 release.
* (T306362, T308680) change-your-logo.svg: Resize to 135px square, re-crush,
  and manually minify.

== MediaWiki 1.38.0-rc.1 ==

=== Changes since MediaWiki 1.38.0-rc.0 ===
* Localisation updates.
* (T305028) Undeprecate EditPage::$textbox2.
* (T305635) LogActions is a map, not a list.
* (T306721) Add wikimedia/equivset to vendor; needed by bundled AbuseFilter.
* (T307284) Simplify TransactionManager::pendingWriteQueryDuration.
* (T307307) Add symfony/yaml to vendor.
* Fix old_name in UserLogoutComplete hook.
* REST: don't send stack trace in error responses.
* (T307998) SessionManager: stop storing an ObjectFactory instance.
* (T193565) UserGroupManager: Fix dbDomain in addUserToGroup() deferred update.

== Upgrading notes for 1.38 ==
Don't forget to always back up your database before upgrading!

See the file UPGRADE for more detailed per-version upgrade instructions from the
oldest supported upgrading version, MediaWiki 1.29.

Some specific notes for MediaWiki 1.38 upgrades are below:
* (T191740) The AbuseFilter extension is now bundled with MediaWiki. This is an
  anti-abuse feature that lets privileged users to set specific actions to be
  taken when actions by users, such as edits or file uploads, match certain
  criteria.
* (T232948) The Math extension is now bundled with MediaWiki. This is a content
  feature that lets users create mathematical formulæ, written in a sub-set of
  LaTeX and rendered in MathML with a fallback SVG image. By default, it will
  use Wikimedia's mathoid service to render each formula, but local rendering
  can be set up for network isolation or performance.
* (T191743) The Minerva skin is now bundled with MediaWiki. This is a simple,
  light-weight, and scalable skin that is particularly optimised for mobile use,
  and integrates well with the MobileFrontend extension (available separately),
  but can also be used as a regular desktop skin.

For notes on 1.37.x and older releases, see HISTORY.

=== Configuration changes for system administrators in 1.38 ===

==== New configuration ====
* (T297708) $wgMaxExecutionTimeForExpensiveQueries - This setting can be used to
  control the maximum execution time for several expensive query pages (e.g.
  RecentChanges and UserContribs).
* $wgBrowserFormatDetection – This setting allows overriding browsers' automatic
  detection and handling of formats. It's initially used to prevent auto-linking
  of possible telephone numbers in wiki pages' output in Safari on iOS; this can
  be re-enabled if you wish, or locally extended for other browsers' quirks.
* (T240685) $wgMetricsTarget, $wgMetricsFormat, $wgMetricsPrefix - These provide
  configuration for a new MetricsFactory service with support for the dogstatsd
  format, intended for integration with Prometheus integration.
* $wgGroupInheritsPermissions – This setting allows inheriting permissions, both
  granted and revoked, from another group.
* $wgForeignApiRepos – ForeignAPIRepo now has a apiMetadataExpiry option to
  control for how long file metadata is cached. Additionally the default changed
  from 1 hour to 4 hours.
* $wgSkinsPreferred – This lets you set a list of preferred skins to be listed
  higher in Special:Preferences.
* $wgWikiFarmSettingsDirectory – A directory that contains site-specific
  configuration files. Setting this will enable multi-tenant ("wiki farm")
  mode, causing site-specific settings to be loaded based on information from
  the web request. EXPERIMENTAL.
* $wgWikiFarmSettingsExtension – The file extension to be used when looking up
  site-specific settings files in $wgWikiFarmSettingsDirectory, such as 'json'
  or 'yaml'. EXPERIMENTAL.
* $wgWikiFarmSiteDetector – A callback function that returns the name of the
  wiki for the current request. This is used in multi-tenant ("wiki farm")
  mode to determine which settings file to load from
  $wgWikiFarmSettingsDirectory. EXPERIMENTAL.
* $wgEnableRemoteBagOStuffTests – This replaces the environment variable
  PHPUNIT_USE_BAGOSTUFF.
* (T230211) $wgForceDeferredUpdatesPreSend – Force deferred updates to be run
  before sending a response to the client, instead of attempting to run them
  after sending the response. Setting this to true is useful for end-to-end
  testing, to ensure that the effects of a request are visible to any subsequent
  requests, even if they are made immediately after the first one. Note however
  that this does not ensure that database replication is complete, nor does it
  execute any jobs enqueued for later.
* $wgTemplateLinksSchemaMigrationStage – Templatelinks table schema migration
  stage, for normalizing tl_namespace and tl_title fields.

==== Changed configuration ====
* $wgStyleDirectory and $wgExtensionDirectory – These are now set later, so can
  no longer be used within LocalSettings.php unless explicitly set in that file.
* $wgFileBackends – This setting no longer takes 'fileJournal' as an option.
* $wgMaxImageArea - This setting may now be set to false to disable size.
  checking before scaling. Extensions can still override its value by using the
  BitmapHandlerCheckImageArea hook.
* $wgAjaxUploadDestCheck – This is now deprecated, and act as always-true.
* $wgInterwikiCache – This no longer supports the string value for CDB files.
* $wgParserOutputHooks – This is now deprecated; adjustments using this should
  be done with OutputPageParserOutputHook instead. (T292321)
* $wgExternalStores – This is newly documentated in
  includes/externalstore/README.md.

==== Removed configuration ====
* $wgShellLocale - This setting has been removed as it was a flawed solution to
  the problem of locale dependence, MediaWiki will now always set a locale of
  C.UTF-8 or C and works around the remaining problems of the C locale by not
  using escapeshellarg. This follows the direction of PHP 8.0, which sets a
  locale of C by default instead of respecting LC_CTYPE.
* $wgLoggedOutMaxAge - Experiment removed, originally added in 1.35. (T293848)
* $wgIncludejQueryMigrate - Deprecated in 1.36. We only support jQuery v3.
* $wgUseCategoryBrowser - This experimental feature has been removed. If you
  still need to use this feature, please see [[mw:Extension:CategoryExplorer]].
* $wgStyleSheetPath - alias for $wgStylePath, deprecated since 1.3 (2004).

=== User-facing changes in 1.38 ===
* (T284921) The "auto-number headings" feature was removed following a
  consultation, due to performance reasons.

=== New operator/developer features in 1.38 ===
* EXPERIMENTAL: The environment variable MW_CONFIG_FILE can be used to specify
  the location of the settings file. This allows alternative settings files to
  be loaded depending on the environment. Settings files may be given as PHP
  files like the traditional LocalSettings.php file, or they may use JSON or
  YAML format.
  See https://www.mediawiki.org/wiki/Manual:YAML_settings_file_format
* Added a deleteUserEmail maintenance script - This file enables the deletion of
  a given user's associated email address. It can be helpful for
  privacy-preserving operations.
* The description array for constructing an HTMLForm now can use 'disable-if' to
  disable fields on condition easily, supported expressions are the same as
  'hide-if'.
* There is a new interface, IForeignRepoWithMWApi, to allows you to mark file
  repos provided by an extension as supporting making API queries against the
  foreign file repo so that extensions like TimedMediaHandler that depend on
  this can stop hard-coding looking for specific class names.
* Added EXPERIMENTAL support for an easy to configure multi-tenant ("wiki
  farm") mode:
  Settings for each site can be placed in a directory specified by
  $wgWikiFarmSettingsDirectory. Site detection is controlled by
  $wgWikiFarmSiteDetector and defaults to the requested host name.
  For example, setting $wgWikiFarmSettingsDirectory = "sites" would cause
  the settings for wiki.example.com to be loaded from
  "sites/wiki_example_com.yaml".
  WARNING: YAML files under the web root may be accessible to browsers, please
  take appropriate measures to protect them from access via HTTP.
* Running QUnit tests for an individual test suite module is possible with
  `grunt qunit --qunit-component={componentName}`, where {componentName} is
  "MediaWiki" to run core's QUnit tests or the skin or extension name.
* The 'mediawiki.mixins' module now has a `.user-select()` Less mixin.

=== External library changes in 1.38 ===

==== New external libraries ====
* symfony/yaml was promoted from development-only.
* justinrainbow/json-schema was promoted from development-only.

==== Changed external libraries ====
* Updated OOUI from v0.42.0 to v0.43.2.
* Updated Vue from 2.6.11 to 3.2.23.
* Updated WVUI from v0.3.0 to v0.4.0.
* Updated composer/semver from 3.2.5 to 3.2.6.
* Updated guzzlehttp/guzzle from 7.2.0 to 7.4.5.
* Updated pear/mail_mime from 1.10.9 to 1.10.11.
* Updated pear/net_smtp from 1.9.2 to 1.10.0.
* Updated psr/log from 1.1.3 to 1.1.4.
* Updated psy/psysh from 0.10.5 to 0.11.1.
* Updated symfony/polyfill-php80 from 1.23.1 to 1.25.0.
* Updated wikimedia/assert from 0.5.0 to 0.5.1.
* Updated wikimedia/cdb from 1.4.1 to 2.0.0.
* Updated wikimedia/ip-utils from 3.0.2 to 4.0.0.
* Updated wikimedia/minify from 2.2.4 to 2.2.6.
* Updated wikimedia/object-factory from 3.0.2 to 4.0.0.
* Updated wikimedia/parsoid from v0.14.0-a14 to v0.15.0.
* Updated wikimedia/purtle from 1.0.7 to 1.0.8.
* Updated wikimedia/request-timeout from 1.1.0 to 1.2.0.
* Updated wikimedia/shellbox from 2.0.0 to 3.0.0.
* Updated wikimedia/wrappedstring from 3.2.0 to 4.0.1.
* Updated wikimedia/remex-html from 3.0.1 to 3.0.2.
* Updated wikimedia/common-passwords from 0.3.0 to 0.4.0.

===== Changed development-only external libraries =====
* Updated QUnit from 2.16.0 to 2.18.0.
* Updated composer/semver from 3.5.4 to 3.5.5.
* Updated composer/spdx-licenses from 1.5.4 to 1.5.5.
* Updated doctrine/dbal for PHP < 7.3 from 2.10.4 to 2.13.6.
* Updated doctrine/dbal for PHP >= 7.3 from 3.0.0 to 3.1.5.

==== Removed external libraries ====
* jquery.jStorage, deprecated since MW 1.28; use "mediawiki.storage" instead.

=== Action API changes in 1.38 ===
* New `deletetalk` parameter on action=delete that allows you to delete the
  associated talk page of a subject page.
* New `variant` parameter for all API actions, for specifying language variant
  (akin to the existing `variant` parameter for index.php). Task T117549.

=== Languages updated in 1.38 ===
MediaWiki supports over 400 languages. Many localisations are updated regularly.
Below only new and removed languages are listed, as well as changes to languages
because of Phabricator reports.

* (T292166) Updated namespace names for the Lombard language.
* (T299201) Changed the autonym of the Angika language to अंगिका
* (T298309) Changed the autonym of the Abkhaz language to аԥсшәа
* (T302972) Changed the autonym of the Kirundi language to ikirundi
* (T220303) Show numbered lists with Burmese numerals in relevant languages
* (T291899) Added language support for Xiang Chinese (hsn).
* (T292612) Added language support for S'gaw Karen (ksw).
* (T293656) Added language support for Farefare (gur).
* (T294729) Added language support for Pa'O (blk).
* (T296286) Added language support for Skolt Sámi (sms).
* (T296612) Added language support for Makhuwa (vmw).
* (T296707) Added language support for Ga (gaa).
* (T297073) Added language support for Nanai (gld).
* (T297074) Added language support for Nawdm (nmz).
* (T298075) Added language support for Northern Thai (nod).
* (T298182) Added language support for Cape Verdean Creole (kea).
* (T298385) Added language support for Nheengatu (yrl).
* (T299329) Added language support for Fon (fon).
* (T300474) Added language support for Nkore (nyn).
* (T302556) Added language support for Pannonian Rusyn (rsk).

=== Breaking changes in 1.38 ===
* (T291008) The IP class, deprecated since 1.35 in favor of the IPUtils library,
  has been removed. The IP related regexes which were also deprecated in favor
  of the IPUtils library were also removed, IPUtils::RE_* should be used
  instead.
* (T293043) The MediaWikiIntegrationTestCase class alias 'MediaWikiTestCase' has
  been removed.
* LinkCache::singleton(), deprecated since 1.28, has been removed.
* RepoGroup::singleton(), ::destroySingletons() and setSingleton(), all
  deprecated since 1.34, have been removed.
* The following methods from FileDeleteForm were removed:
  - ::__construct (the class is no longer newable)
  - ::execute()
  - ::haveDeletableFile()
  Use FileDeleteAction instead.
* MessageCache::singleton(), deprecated since 1.34, has been removed.
* LockManagerGroup::singleton() and ::destroySingletons(), both deprecated since
  1.34, have been removed.
* FileBackendGroup::singleton() and ::destroySingletons(), both deprecated since
  1.35, have been removed.
* TemplateParser used to support disabling the cache with a boolean parameter in
  its constructor. This was deprecated in 1.35 and has now been removed.
* The ArticleUndeleteLogEntry hook, deprecated in 1.37, was removed.
* The BeforeResetNotificationTimestamp hook, deprecated in 1.37, was removed.
* The global function mimeTypeMatch() has been removed without a deprecation
  process.
* The following JavaScript mw.config keys have been removed:
  - $wgCookiePrefix
  - $wgCookieDomain
  - $wgCookiePath
  - $wgCookieExpiration
  Use mw.cookie from the mediawiki.cookie module instead.
* The signature of PageUpdater::markAsRevert method was changed. It has never
  been used outside of MediaWiki core.
* If you want to use interwiki titles with HTMLTitleTextField, you now need to
  pass 'interwiki' => true. In 1.37, the default behavior was to let interwiki
  title through by default, logging a deprecation warning.
* The `UndeleteForm::undelete` hook, deprecated in 1.37, was removed.
* BagOStuff::setDebug(), deprecated since 1.36, has been removed.
* The `jquery.mw-jump` ResourceLoader module was removed.
* The `wgForeignUploadTargets` and `wgEnableUploads` configuration values were
  removed from mw.config. They had previously been documented as being included
  for internal use by the mediawiki.ForeignUpload module.
*The `&$hasHistory` parameter to WikiPage::getAutoDeleteReason() and
  ContentHandler::getAutoDeleteReason() was hard-deprecated with no replacement.
* Several Skin methods, which have emitted deprecation warnings since 1.36, have
  been removed. These include:
  - Skin::privacyLink()
  - Skin::aboutLink()
  - Skin::disclaimerLink()
    For these, instead use Skin::footerLink() to alter footer links.
  - Skin::getLogo()
    For this, use ResourceLoaderSkinModule::getAvailableLogos() instead.
  - Skin::getIndicatorsHTML()
    For this, use Skin::getIndicatorsData() instead.
  - Skin::subPageSubtitle()
    For this, use Skin::prepareSubtitle() instead.
  - Skin::makeVariablesScript()
    For this, use ResourceLoader::makeInlineScript() instead.
  - Skin::getAllowedSkins()
  - Skin::getSkinNames()
    For these, use SkinFactory::getAllowedSkins() or ::getInstalledSkins().
  - Skin::makeUrl()
  - Skin::getSearchLink()
  - Skin::mainPageLink()
* Parser::getUser and ::mUser, as well as ParserOptions::getUser, deprecated
  since 1.37, has been removed.
* Parser::$mStripState, deprecated in 1.35, has been made private. Use
  Parser::getStripState() instead.
* The following deprecated features in blocks were removed:
  - DatabaseBlock constructor 'byText' property with blocker's name, use 'by'
    property with UserIdentity value instead.
  - DatabaseBlock constructor 'by' property with blocker's ID, use 'by' property
    with UserIdentity value instead.
  - DatabaseBlock::isWhitelistedFromAutoblocks, use ::isExemptedFromAutoblocks.
  - DatabaseBlock::setBlocker now only accepts UserIdentity.
  - AbstractBlock::getTargetAndType and ::getTarget, use ::getTargetName,
    ::getTargetUserIdentity and ::getType instead
* The following functions, emitting deprecations since 1.37, have been removed:
  - Title::isWatchable()
  - WatchAction::doWatchOrUnwatch(), WatchAction::doWatch(),
    WatchAction::doUnwatch(), WatchAction::getWatchToken()
  - User::isWatched(), User::isTempWatched(), User::addWatch(),
    User::removeWatch()
* ParserOptions::setTidy() that had no effect and was deprecated since 1.35 has
  been removed.
* The "YAML" encoding option of EtcdConfig, has been removed without
  deprecation.
* The constant ApiBase::PARAM_VALUE_LINKS, deprecated since 1.35 has been
  removed.
* UserLoadOptions, UserSaveOptions and UserResetAllOptions hooks, deprecated
  since 1.37, were removed.
* The experimental FileJournal system has been removed without deprecation. This
  includes the FileJournal abstract class, its implementation classes
  DBFileJournal and NullFileJournal, various minor getters and setters, and the
  option for the wiki configuration $wgFileBackends.
* The return values for each `bind` function in checkboxHack.js has been changed
  from an object to a function. In addition, the `unbind` function has been
  removed. A deprecation process was assumed unnecessary as there were no known
  usages.
* File::getUser, ::getImageSize, ArchivedFile::getRawDescription, ::getUser,
  ::getRawUser and ::getRawDescription, deprecated since 1.37, has been removed.
* ShellboxHttpClient class has been removed without deprecation. It was an
  internal class used by ShellboxClientFactory.
* The following hard deprecated User methods have been removed:
  - ::resetIdByNameCache,
  - ::getStubThreshold,
  - ::matchEditTokenNoSuffix,
  - ::changeableByGroup,
  - ::changeableGroups,
  - ::isAllowUsertalk,
  - ::getRights
  - ::isAllowUsertalk
  - ::isIP,
  - ::isIPRange,
  - ::isValidUserName,
  - ::isUsableName,
  - ::isCreatableName,
  - ::getCanonicalName,
  - ::addAutopromoteOnceGroups,
  - ::getDefaultOptions,
  - ::getDefaultOption,
  - ::getOptions,
  - ::getBoolOption,
  - ::getIntOption,
  - ::setOption
  - ::listOptionKinds
  - ::getOptionKinds,
  - ::resetOptions,
  - ::getEffectiveGroups,
  - ::getAutomaticGroups,
  - ::getFormerGroups
  - ::isLoggedIn
  - ::getFirstEditTimestamp
  - ::getLatestEditTimestamp
* Http::$httpEngine, deprecated since 1.34, has been removed. The only available
  HTTP engine is now Guzzle. CurlHttpRequest and PhpHttpRequest classes were
  removed.
* The UserRightsProxy class was deprecated. Pass the correct domain to
  UserGroupManagerFactory instead.
* Parser option enableLimitReport was deprecated. The report is now generated
  post-parse and can be included by providing 'includeDebugInfo' option to
  ParserOutput::getText. Thus, ParserOptions::enableLimitReport and
  ::getEnableLimitReport methods were deprecated.
* Ajax action that was deprecated in 1.27 now has been removed.
* The following methods have been removed from IDatabase without deprecation as
  they were completely unused:
  - ::preCommitCallbacksPending()
  - ::pendingWriteRowsAffected()
  - ::getServerUptime()
  - ::maxListLen()
* The following deprecated methods have been removed from IDatabase:
  - ::aggregateValue() soft-deprecated since 1.33
  - ::getTopologyRootMaster() since 1.37
  - ::masterPosWait() since 1.37
  - ::dataSeek() soft-deprecated since 1.37
  - ::numFields() soft-deprecated since 1.37
  - ::fieldName() soft-deprecated since 1.37
  - ::onTransactionIdle() soft-deprecated since 1.32
  - ::getMasterPos() since 1.37
* DatabaseMysqlBase::fieldType() and DatabasePostgres::fieldType(), deprecated
  since 1.37, have been removed.
* Database::assertIsWritableMaster(), deprecated since 1.37, has been removed.
* ResultWrapper::getInternalResult(), soft-deprecated since 1.37 and
  ResultWrapper::unwrap(), deprecated since 1.37, have been removed.
* Language::AS_AUTONYMS, deprecated since 1.34, has been removed. You can use
  the LanguageNameUtils::AUTONYMS constant instead.
* Several Language class variables deprecated in 1.35 have been removed; they
  are each replaced by a constant, as listed after the arrow:
  - ::$mWeekdayMsgs → WEEKDAY_MESSAGES
  - ::$mWeekdayAbbrevMsg → WEEKDAY_ABBREVIATED_MESSAGES
  - ::$mMonthGenMsgs → MONTH_GENITIVE_MESSAGES
  - ::$mIranianCalendarMonthMsgs → IRANIAN_CALENDAR_MONTHS_MESSAGES
  - ::$mHebrewCalendarMonthMsgs → HEBREW_CALENDAR_MONTHS_MESSAGES
  - ::$mHebrewCalendarMonthGenMsgs → HEBREW_CALENDAR_MONTH_GENITIVE_MESSAGES
  - ::$mHijriCalendarMonthMsgs → HIJRI_CALENDAR_MONTH_MESSAGES
* wfIncrStats, deprecated since 1.36, has been removed.
* Profiler::profileIn and ::profileOut, deprecated in 1.33, has been removed.
* IEditObject::AS_CANNOT_USE_CUSTOM_MODEL, deprecated in 1.35, was removed.
* Several protected methods in EditPage were made private. None of these was
  used outside of EditPage itself. Since the class is not stable to extend,
  this change happened without a deprecation phase.
* The following public methods in EditPage, unused externally, were
  made private:
   - ::getCancelLink()
   - ::isSupportedContentModel()
   - ::getParentRevId()
* EditPage::setApiEditOverride() was marked as @internal for use by
  ApiEditPage only.
* SelectQueryBuilder::straightJoin() was renamed to straightJoinOption().
* The following deprecated methods have been removed from ILBFactory:
  - ::beginMasterChanges() since 1.37
  - ::commitMasterChanges() since 1.37
  - ::rollbackMasterChanges() since 1.37
  - ::hasMasterChanges() since 1.37
  - ::hasOrMadeRecentMasterChanges() since 1.37
* The "groupLoadsByDB" option to LBFactoryMulti has been removed. Consider using
  "groupLoadsBySection" instead.
* The following methods have been removed from ILoadBalancer without deprecation
  as they were completely unused:
  - ::waitForOne()
  - ::allowLagged()
  - ::forEachOpenReplicaConnection()
* The following deprecated methods have been removed from ILoadBalancer:
  - ::getMasterPos() since 1.37
  - ::finalizeMasterChanges() since 1.37
  - ::approveMasterChanges() since 1.37
  - ::beginMasterChanges() since 1.37
  - ::commitMasterChanges() since 1.37
  - ::runMasterTransactionIdleCallbacks() since 1.37
  - ::runMasterTransactionListenerCallbacks() since 1.37
  - ::rollbackMasterChanges() since 1.37
  - ::flushMasterSnapshots() since 1.37
  - ::hasMasterConnection() since 1.37
  - ::hasMasterChanges() since 1.37
  - ::lastMasterChangeTimestamp() since 1.37
  - ::hasOrMadeRecentMasterChanges() since 1.37
  - ::pendingMasterChangeCallers() since 1.37
  - ::forEachOpenMasterConnection() since 1.37
  - ::waitForMasterPos() since 1.37
* LoadBalancer::safeGetLag() which has been soft-deprecated since 1.34 has been
  removed.
* The following properties of the EditPage class, deprecated since 1.35, were
  made private:
  - ::$deletedSinceEdit
  - ::$lastDelete
  - ::$mTokenOk
  - ::$mTriedSave
  - ::$incompleteForm
  - ::$tooBig
  - ::$missingComment
  - ::$missingSummary
  - ::$allowBlankSummary
  - ::$autoSumm
  - ::$mParserOutput
  - ::$hasPresetSummary
  - ::$minoredit
  - ::$watchthis
  - ::$recreate
  - ::$nosummaryparentRevId
  - ::$editintro
  - ::$scrolltop
  - ::$markAsBot
* Special:ListFiles and Special:NewFiles no longer allows to search for parts of
  file names (option was not available for $wgMiserMode = true)
* DBAccessBase, deprecated since 1.37, has been removed.
* The UserNamePrefixSearch service no longer supports a UserIdentity parameter
  to search(), to check for a specific audience an Authority object is required.
* The methods CoreParserFunctions::register() and CoreTagHooks::register() have
  been marked @internal, and had a seconds parameter added. These methods are
  intended for use in Parser's constructor, and are not used by any known
  extension.
* LoadBalancer::openConnection(), deprecated since 1.34, has been removed.
* Skin::preloadExistence has been made private. There is no known usages outside
  of MediaWiki core.

=== Deprecations in 1.38 ===
* The MWGrants class is deprecated in favor of the new GrantsInfo and
  GrantsLocalization services.
* The global functions wfReadOnly() and wfReadOnlyReason() have been deprecated
  in favor of the ReadOnlyMode service.
* PageProps::getInstance() has been deprecated. Use
  MediaWikiServices::getPageProps() instead.
* User::setOption(), deprecated since 1.35, now emits deprecation warnings.
* Linker::formatComment(), ::formatLinksInComment(), ::commentBlock() and
  revComment() were deprecated. Use the new CommentFormatter service.
* Several Skin methods have been deprecated.
  - Skin::setSearchPageTitle(), Skin::getSearchPageTitle(). For these,
    use SpecialPage::newSearchPage() or associated user preference instead.
  - Skin::getSkinStylePath now triggers deprecation warnings. Direct string path
  should be used instead.
  - SkinTemplate::getPersonalToolsList(), deprecated since 1.35, now emits
  deprecation warnings.
  - In preparation for SkinTemplate::getPortletData becoming a private
    function, extending the method is no longer permitted. Use
    SkinTemplate::getTemplateData instead.
  - SkinTemplate::buildContentNavigationUrls is now deprecated. Skins can
    use the runOnSkinTemplateNavigationHooks method or the
    SkinTemplateNavigation__Universal hook if they need access to this data.
* Usage of several template data keys in QuickTemplate are now deprecated:
  - searchaction, poweredbyico, copyrightico
* DatabaseBlock::purgeExpired(), deprecated since 1.36, now emits deprecation
  warnings.
* The following methods from the User class now trigger deprecation warnings:
   - ::blockedBy
   - ::getBlockId
* Content::getParserOutput and AbstractContent::fillParserOutput was
  hard-deprecated, use ContentRenderer::getParserOutput instead. Extensions
  defining a content model should override ContentHandler::fillParserOutput.
* Title::newFromIDs and TitleFactory::newFromIDs have been hard deprecated. Use
  a PageSelectQueryBuilder from a PageStore instead.
* Content::getRedirectChain() and Content::getUltimateRedirectTarget() have been
  deprecated with no replacement because support for $wgMaxRedirect will be
  removed completely. See T296430 for more information.
* WikiPage::getRedirectTarget() has been deprecated. Use the equivalent
  RedirectLookup::getRedirectTarget() instead.
* Article::doDelete() was deprecated. Use WikiPage::doDeleteArticleReal if you
  only need to delete the article. If you also need things to happen with
  OutputPage, you may want to check the hooks in DeleteAction instead.
* Instantiating the MessageContent class now emits deprecation notices.
* Message::content() now triggers deprecation warnings.
* Parser::setDefaultSort(), Parser::getDefaultSort(), and
  Parser::getCustomDefaultSort() now trigger deprecation warnings. Use
  ParserOutput::{get,set}PageProperty('defaultsort') instead.
* The following methods from the ParserOutput class now emit deprecation
  warnings:
   - ::hideNewSection()      - use ::setHideNewSection()
   - ::preventClickjacking() - use ::{get,set}PreventClickjacking()
   - ::getProperty()         - use ::getPageProperty() (return value changed)
   - ::setProperty()         - use ::setPageProperty()
   - ::unsetProperty()       - use ::unsetPageProperties()
   - ::getProperties()       - use ::getPageProperties()
   - ::getCategoryLinks()    - use ::getCategoryNames()
   - ::setCategoryLinks()    - use ::setCategories()
   - ::addTrackingCategory() - use Parser::addTrackingCategory()
                               or TrackingCategories::addTrackingCategory()
   - ::addWarning()          - use ::addWarningMsg()
   - ::hasDynamicContent()   - use ::hasReducedExpiry()
* The following methods from the ParserOutput class were deprecated:
   - ::getFlag() - use ::getOutputFlag()
   - ::setFlag() - use ::setOutputFlag()
   - ::getAllFlags() - this method is now marked @internal
   - ::addJsConfigVars() - use ::setJsConfigVar() or ::appendJsConfigVar()
   - ::addOutputHook() / ::getOutputHooks() - these hooks should be migrated
     to use the OutputPageParserOutput hook instead
* The use of ParserOutput::setExtensionData() to overwrite previous values
  stored under a given key has been deprecated; use the new
  ::appendExtensionData() to collect multiple values in the ParserOutput rather
  than destructively updating stored values. (T300981)
* The signatures of the following methods from the ParserOutput class were
  narrowed, restricting the permitted argument types:
  - ::addModules() - if you formerly passed a string, pass an array with
     the string as the only element.
   - ::addModuleStyles() - if you formerly passed a string, pass an array
     with the string as the only element.
* Access to the following public or protected properties of OutputPage was
  deprecated; they will be made private or removed in a future release.
  Use accessor functions instead.
  - ::$mCategoryLinks
  - ::$mCategories
  - ::$mIndicators
  - ::$mHeadItems
  - ::$mModules
  - ::$mModuleStyles
  - ::$mJsConfigVars
  - ::$mTemplateIds
  - ::$mEnableClientCache
  - ::$mNewSectionLink
  - ::$mHideNewSectionLink
  - ::$mNoGallery
* The following methods were deprecated; use ::setPreventClickjacking(..)
  instead:
   - OutputPage::preventClickjacking()
   - OutputPage::allowClickjacking()
   - ImageHistoryList::preventClickjacking()
   - ImageHistoryPseudoPager::preventClickjacking()
   - ContribsPager::preventClickjacking()
* OutputPage::enableClientCache() was deprecated, because it is universally used
  to do the opposite -- use OutputPage::disableClientCache() instead.
* Sanitizer::removeHTMLtags() has been deprecated. Its output can include
  unbalanced or ill-formed HTML and thus external callers may be misled about
  how to safely incorporate its output into a page. It is recommended to use the
  new Sanitizer::removeSomeTags() method instead, which will always return
  balanced HTML.
* EventRelayerKafka was deprecated. To use $wgEventRelayerConfig with Kafka,
  add a similar class to your code.
* MediaWiki\Logger\Monolog\KafkaHandler was deprecated. Consider using
  $wgMWLoggerDefaultSpi with SyslogHandler, or to use Kafka, add a similar
  Monolog handler class to your code.
* Collation::singleton() and ::factory() now trigger deprecation warnings.
* The following methods in MWNamespace, all deprecated since 1.34, now emit
  deprecation warnings:
  - isTalk()
  - exists()
  - subjectEquals()
  - getCanonicalNamespaces()
  - getCanonicalName()
  - getCanonicalIndex()
  - getValidNamespaces()
  - isContent()
  - hasSubpages()
  - getContentNamespaces()
* Return values in the parameter $pageLang of the hook PageContentLanguage with
  other types than a Language object, deprecated since 1.33, now emmits
  deprecation warnings.
* Passing a db to BlockRestrictionStore::loadByBlockId() is deprecated.
  BlockRestrictionStoreFactory should be used to fetch a correct
  BlockRestrictionStore instead.
* All external access to ParserOutput and CacheTime classes properties will now
  emit deprecation warnings. Use getters and setters instead.
* The custom jQuery event `watchpage.mw` emitted on #ca-watch and #ca-unwatch is
  now deprecated in favour of the new `wikipage.watchlistChange` hook.
* The global function wfLogProfilingData() has been deprecated without a
  replacement. The logic has been moved to the MediaWiki class.
* The "trace" option of SectionProfiler has been deprecated.
* The PageArchive class has had several methods deprecated. The replacements are
  as follows:
   - Use UndeletePage instead of ::undeleteAsUser(), ::getFileStatus() and
     ::getRevisionStatus().
   - Use the respective methods of the new ArchivedRevisionLookup service
     instead of ::listRevisions, ::getRevisionRecordByTimestamp,
     ::getArchivedRevisionRecord, ::getPreviousRevisionRecord and
     ::getLastRevisionId.
   - Use ArchivedRevisionLookup::hasArchivedRevisions instead of ::isDeleted.
* PageUpdater::isUnchanged() has been deprecated, use wasRevisionCreated()
  instead.
* The `mediawiki.pager.tablePager` module was deprecated in favor of the more
  generic `mediawiki.pager.styles`.
* wfGetCache() and wfGetMainCache(), both deprecated since 1.32, now emit
  deprecation warnings.
* LinkCache::addGoodLinkObj() has been hard deprecated.
* ApiStashEdit::parseAndStash has been hard deprecated.
* Content::prepareSave was hard-deprecated, now emits deprecation warnings.
  Use ContentHandler::validateSave instead.
* The hooks LinksUpdateAfterInsert and LinksUpdateConstructed were deprecated.
* Access to all public properties in LinksUpdate was deprecated.
* The global variable $IP has been deprecated for use in application logic.
  It will remain available for use in LocalSettings.php for now, though
  $wgBaseDirectory is preferred.
  Application logic should use the BaseDirectory setting from the main config.
  Tests and framework code that need to function without MediaWiki being
  fully initialized should use the MW_INSTALL_PATH constant.
* The global function wfWikiID(), deprecated since 1.35, now emits deprecation
  warnings.
* AbstractBlock::getBy() now takes a wikiId as a parameter and emits deprecation
  warnings in case of cross-wiki accesses.
* The `button` parameter for `bindUpdateAriaExpandedOnInput` and
  `updateAriaExpanded` in checkboxHack.js have been deprecated.
  `bindToggleOnSpaceEnter` has also been deprecated in favor of
  `bindToggleOnEnter`.
* IDatabase::lockTables() and IDatabase::unlockTables() have been deprecated
  with no replacement. Instead, callers should batch updates into atomic
  transactions, using FOR UPDATE for SELECT queries.
* EditPage::addNewLineAtEnd() was deprecated; use
  TextboxBuilder::addNewLineAtEnd instead.
* EditPage::getCopywarn() was deprecated; use EditPage::getCopyrightWarning
  instead.
* EditPage::getCopyrightWarning() without passing a MessageLocalizer parameter
  has been deprecated.
* Passing the $formCallback parameter to EditPage::showEditForm, deprecated in
  1.25 and previously emitting a warn notice, now emits a deprecation notice.
* EditPage::$action has been deprecated.
* The following properties in EditPage now emit deprecation notices when used
  from another class:
  - mArticle (use ::getArticle() instead)
  - mTitle (use ::getTitle() instead)
  - isNew (no replacement)
  - allowBlankArticle (no replacement)
  - selfRedirect (no replacement)
  - allowSelfRedirect (no replacement)
  - diff (no replacement)
  - textbox2 (no replacement)
  - undoAfter (no replacement)
  - edit (no replacement)
  - contentLength (no replacement)
* The HTMLForm methods getPreText, setPreText, addPreText, getPostText,
  setPostText, addPostText, getHeaderText, setHeaderText, addHeaderText,
  getFooterText, setFooterText and addFooterText have been renamed to
  getPreHtml, setPreHtml, addPreHtml, getPostHtml, setPostHtml, addPostHtml,
  getHeaderHtml, setHeaderHtml, addHeaderHtml, getFooterHtml, setFooterHtml and
  addFooterHtml respectively.
* The FormSpecialPage methods preText and postText have been renamed to preHtml
  and postHtml respectively.
* Article::doDelete, deprecated in 1.37, now emits deprecation notices.
* The following Less mediawiki.mixins have been deprecated:
  - .background-image()
  - .list-style-image()
* Category::getPageCount now takes a parameter. Category::COUNT_ALL_MEMBERS
  return count of all members while Category::COUNT_CONTENT_PAGES return that
  of content pages. For the former behavior use Category::getMemberCount()
* Using `new HTMLForm( … )` or `HTMLForm::factory( … )` without the $context
  parameter is now deprecated.
* BagOStuff::incr() and BagOStuff::decr() are now deprecated.
* Action::exists() and ActionFactory::actionExists() are deprecated, use
  (bool)ActionFactory::getAction().

=== Other changes in 1.38 ===
* The following things were changed in the file deletion form:
   - The name and ID of the submit button are now `wpConfirmB`, not
      `mw-filedelete-submit`
   - The ID of the form is now `deleteconfirm`, not `mw-img-deleteconfirm`
   - The `mw-filedelete-editreasons` class was replaced with
     `mw-delete-editreasons`
  The goal of these changes is to make the HTML more similar to that of
  normal page deletion.
* ParserOptions created with ::newFrom* or ::newCanonical are now identical.
* MediaWiki initialization order have been changed to load vendor autoload
  earlier. This means that extensions that are installed via composer and
  execute code upon autoloading can not depend on any MediaWiki classes,
  constants or globals in that code.
* The source of truth for configuration defaults is now the MainConfigSchema
  class. DefaultSettings.php still exists for backwards compatibility. A PHP
  file generated for optimized loading will be used in Setup.php to initialize
  configuration variables. Setup.php can be made to load DefaultSettings.php
  as before by setting MW_USE_LEGACY_DEFAULT_SETTINGS as  an environment
  variable (e.g. via SetEnv in htaccess) or a PHP constant (e.g. via
  auto_prepend_file in php.ini).

== Compatibility ==
MediaWiki 1.38 requires PHP 7.3.19 or later and the following PHP extensions:

* ctype
* dom
* fileinfo
* iconv
* intl
* json
* mbstring
* xml

MySQL/MariaDB is the recommended DBMS. PostgreSQL or SQLite can also be used,
but support for them is somewhat less mature.

The supported versions are:

* MySQL 5.5.8 or later
* PostgreSQL 9.4 or later
* SQLite 3.8.0 or later

== Online documentation ==
Documentation for both end-users and site administrators is available on
MediaWiki.org, and is covered under the GNU Free Documentation License (except
for pages that explicitly state that their contents are in the public domain):

       https://www.mediawiki.org/wiki/Special:MyLanguage/Documentation

== Mailing list ==
A mailing list is available for MediaWiki user support and discussion:

       https://lists.wikimedia.org/mailman/listinfo/mediawiki-l

A low-traffic announcements-only list is also available:

       https://lists.wikimedia.org/mailman/listinfo/mediawiki-announce

It's highly recommended that you sign up for one of these lists if you're
going to run a public MediaWiki, so you can be notified of security fixes.

== IRC help ==
There's usually someone online in #mediawiki on irc.libera.chat.

= MediaWiki 1.37 =

== MediaWiki 1.37.6 ==

This is a maintenance release of the MediaWiki 1.37 branch.

=== Changes since MediaWiki 1.37.5 ===
* Fix missing use statement from backport of fix for T307278.

== MediaWiki 1.37.5 ==

This is a security and maintenance release of the MediaWiki 1.37 branch.

=== Changes since MediaWiki 1.37.4 ===
* Localisation updates.
* (T312519, T312520) Parser::extensionSubstitution() Don't run substr() on null.
* (T287564) populateInterwiki: Include not null columns iw_api/iw_wikiid.
* (T312302) SpecialRedirect: Don't pass null to explode.
* RemoveInvalidEmails: Fix quoting for postgres.
* (T312678) import: UploadSourceAdapter::stream_read() don't pass null to
  strlen().
* (T312300) SpecialDiff: Don't pass null to explode().
* (T312680) parser: Fix CoreParserFunctions::urlencode() null coalescence $arg.
* (T289926) Handle null passed to wfShorthandToInteger() and Html::element().
* (T289926) Ensure that strlen() does not get passed a (valid) null.
* (T312301) SpecialDiff: Don't pass null to trim().
* Hooks: Use more meaningful name for SkinAfterPortlet hook parameter.
* (T289926) Ensure we don't pass null to mb_strlen.
* (T312305, T311572, T311571, T311578) HTMLForm: Null coalescence in trim()
  calls.
* (T289926) site: Consistently return null from Site::getDomain().
* (T307304, T289879) filebackend,jobqueue: Add signature for
  FilterIterator::accept().
* (T312183) rdbms: Adapt hasOrMadeRecentPrimaryChanges test mock for PHP 8.1.
* Add application/vnd.ms-opentype to MIME list.
* Allow composer/installers plugin in composer.json.
* Change type hints for BatchRowIterator and NotRecursiveIterator for
  compatibility with PHP 8.1.
* (T313663) [php8.1] Change override of $wgResourceBasePath for CSP tests.
* (T313663) parser: Mock WikiPage::getContentModel in ParserCacheTest to fix
  php8.1.
* (T313663) [php8.1] Make WikiImporterFactoryTest use better mock for
  ImportSource.
* Fix tests so getName() doesn't return null.
* (T313663) [php8] Don't use strlen on potentially null string.
* (T313663) [php8.1] Suppress test warning about providing null.
* (T313663) Parser will use current timestamp instead of null if passed a
  RevisionRecord that does not have a timestamp.
* (T313663) Add explicit null check for $sha in FileBackend [php8.1].
* (T313663) LogFormatter: Cast argument of ctype_digit to string [php8.1].
* (T313663) Mock UserOptionsManager::getOption for php8.1.
* (T289879, T289926) Get rid of warnings on PHP 8.1.
* (T313663) Check for null return of preg_replace in MediaWikiTitleCodec.
* (T313663) cast db name to string when checking if it is read only [php8.1].
* (T313663) Avoid testing strlen on null in ApiQuerySiteinfo [php 8.1 compat].
* Fix a couple deprecation warnings in the installer under PHP 8.1.
* (T313663) Use default timezone UTC for SpecialWatchlistTest [php 8.1].
* (T313663) Mock User::getTitleKey in SpecialPreferencesTest [php 8.1].
* (T314096) Migrate use of ${var}-style string interpolation.
* (T314099) preprocessor: Add missing field declarations.
* (T313663, T313662) Make default value for optional args {{PAGESINCAT:..}} be
  '' not null.
* (T314225) SpecialCategories: Null coalescene $par.
* (T314099) User: Allow dynamic properties on PHP 8.2.
* (T314397) SpecialBlock: Better handle null in getTargetUserTitle.
* (T314099) phpunit: Fix trivial dynamic property usages in tests.
* (T314405) UploadStash: Check if us_prop is set in the fileMetadata.
* (T313663) Make ChangesListSpecialPageTest cast to string for php 8.1.
* (T313663) Do not test giving a null fragment to Title::makeTitle.
* (T314550) SpecialMergeHistory: Set timestamp to '' if no mergepoint.
* (T314551) SpecialMergeHistory: Set defaults for target and dest parameters.
* api: Add rel=nofollow to help examples.
* (T307613) Validate length of user email on Special:ChangeEmail/
  Special:CreateAccount.
* (T314226) LoginSignupSpecialPage: Check if $value is a string before length.
* (T314824) tests: Update parser test after i18n change.
* (T295958, T278847) MediaWiki-Docker: Switch PHP images to PHP7.4.
* (T314906, T314907) SpecialBlock: Set defaults for wpPageRestrictions and
  wpNamespaceRestrictions.
* (T315309) ImportStreamSource::newFromURL() Prevent passing null to fwrite.
* (T315892) composer.json: Pin phpunit to 8.5.28.
* (T313049) Bump wikimedia/parsoid to v0.14.2.
* (T317750) session: Fix broken SessionTest case due to PHPUnit dependency
  change.
* (T318079) SpecialEditTags: Set default value of wpTagsToRemove to empty array.
* (T318460) SpecialChangeEmail: Set default for returntoquery.
* (T318307) Update docs for HTMLFormField::validate() to permit all data types.
* (T316304, CVE-2022-41767) SECURITY: reassignEdits doesn't update results
  in an IP range check on Special:Contributions.
* (T309894, CVE-2022-41765) SECURITY: HTMLUserTextField exposes existence
  of hidden users.
* (T307278, CVE-2022-41766) SECURITY: On action=rollback the message
  "alreadyrolled" can leak revision deleted user name.

== MediaWiki 1.37.4 ==

This is a maintenance release of the MediaWiki 1.37 branch.

=== Changes since MediaWiki 1.37.3 ===
* Localisation updates.
* (T311568) UploadBase::setTempFile() handle $tempPath being passed as null.
* (T311559) SpecialListFiles: user parameter isn't always present.
* (T311561) ImageListPager: Don't call htmlspecialchars() on null.
* (T311920) SpecialBlockList: Prevent passing null to trim().
* (T311921) SpecialUserrights: Don't pass null to str_replace.
* (T311570) SpecialWithoutInterwiki: Don't pass null through to
  Title::capitalize().
* (T311574, T311576) SpecialLinkSearch: Don't pass null through to the parser.
* (T312059) Update guzzlehttp/guzzle to 7.4.5 in vendor.
* (T296435, T297669) cache: Add four fields to LinkCache::getSelectFields.

== MediaWiki 1.37.3 ==

This is a security and maintenance release of the MediaWiki 1.37 branch.

=== Changes since MediaWiki 1.37.2 ===
* Localisation updates.
* (T289879) Type hints for ArrayAccess and JsonSerializable.
* (T304783) TemplateParser: avoid warnings when called by NoLocalSettings.
* Rebuilt vendor with composer 2.3.3.
* Fix old_name in UserLogoutComplete hook.
* (T289879) Address some deprecations for PHP 8.1.
* (T193565) UserGroupManager: Fix dbDomain in addUserToGroup() deferred update.
* (T309114) LocalFile::prerenderThumbnails: Limit the number of thumbnail jobs
  triggered.
* (T307982) Updated wikimedia/parsoid from v0.14.0 to v0.14.1.
* (T308471) SECURITY: Escape welcomeuser message passed to showSuccessPage().
* (T308473) SECURITY: Escape contributions-title msg for use within page title.
* (T311272) Call parent constructor of AddSite maintenance script first.
* MediaWiki: Don't eagerly initialize action name.
* Updated wikimedia/shellbox from v2.0.0 to v2.1.1.
* (T311384, CVE-2022-27776) Updated guzzlehttp/guzzle from 7.2.0 to 7.4.5.
* (T289926) Avoid passing null to trim() in SkinTemplate.
* (T311473) rollbackEdits: Pass user identity to RollbackPage.
* (T307282) Avoid passing null to strcasecmp(), for PHP 8.1.
* (T311551) ShellboxClientFactory::getUrl(): Check if $this->key is null.
* (T311552) ChangesListSpecialPage: Don't pass null to FormatJson::decode().
* (T311569) FileBackend::isStoragePath() Handle being passed null.
* (T311544) Pass int to ApiUsageException::newWithMessage()'s $httpCode param.
* (T311678) SpecialEditWatchlist: Prevent passing null to strtolower().
* (T281741) ChangeTags: Fix adding CSS classes for hidden tags.
* (T296642) changetags: Fix management of a '0' tag.
* (T311554) ChangeTags: Return early in formatSummaryRow() if $tags === null.
* (T303033) Handle null in ChangeTags::modifyDisplayQuery.
* Updated wikimedia/common-passwords from 0.3.0 to 0.4.0.

== MediaWiki 1.37.2 ==

This is a security and maintenance release of the MediaWiki 1.37 branch.

=== Changes since MediaWiki 1.37.1 ===
* (T298261) Fix support for Composer 2.2.
* (T298283) composer.json: Add wikimedia/composer-merge-plugin to allow-plugins.
* Update doctrine/dbal (3.0.0 => 3.1.5).
* (T296898) Add entry point name to disabled Session exception if possible.
* (T298564) MemcachedClient: Add support for IPv6.
* (T297543, CVE-2022-28202) SECURITY: properly escape output used within
  galleries and Special:RevisionDelete.
* (T289956) WatchAction: Fix bug that prevents showing proper success
  message in the noscript fallback mode.
* (T268847) Suppress deprecation warnings from libxml_disable_entity_loader().
* (T283275) Fix PHP 8.0 failure of RefreshSecondaryDataUpdateTest.
* (T283275) Fix PHP 8.0 failure of WikiExporterFactoryTest.
* (T275673) objectcache: Avoid getCurrentTime() call in MapCacheLRU::has().
* (T275673) objectcache: split up MapCacheLRU::getAge() to avoid conditional
  overhead.
* Fix the json schema and the extension processor for Parsoid extension modules.
* (T299696) update.php: Avoid passing null to substr.
* (T195807, T256401) Fix signature of DatabasePostgres::buildGroupConcatField.
* In PHP 8.1 don't throw exceptions from mysqli.
* (T289926) SiteConfiguration: Don't pass null to str_replace().
* (T264735) Fix deprecation warning from CURLPIPE_HTTP1.
* (T260735) Stop using is_resource() where possible.
* (T289879) Apply ReturnTypeWillChange to various implementations of built in
  interfaces.
* (T299312) Implement __serialize/__unserialize for PHP 8.1 support.
* ExtensionRegistry: Add process cache for lazy attributes.
* (T301041) ApiPageSet: Add "missing": true to missing revisions.
* Allow ParsoidModules extension schema to register services.
* (T300462) SpecialUndelete: Do not show empty comments as deleted.
* (T297708) Allow setting max execution time to several special pages.
* (T205349) LinkCache: Try invalidating cache before throwing.
* (T302540) composer.json: Add ext-calendar to require.
* (T302540) composer.json: Add ext-simplexml to require-dev.
* (T302540) composer.json: Add various PHP extensions to suggests.
* Upgrading symfony/polyfill-php80 (v1.23.1 => v1.25.0).
* (T304008) Don't re-check "Move subpages" on Special:MovePage after a warning.
* (T293576) listFiles: Display file name instead of version.
* (T303871) Fix @since of Title::getId().
* (T303560) Installer: Check correct PCRE_CONFIG_NEWLINE value.
* wrapOldPasswords: add \n to two output calls.
* (T297571, CVE-2022-28201) Title::newMainPage() goes into an infinite recursion
  loop if it points to a local interwiki.
* (T297731, CVE-2022-28203) Requesting Special:NewFiles on a wiki with many file
  uploads with actor as a condition can result in a DoS.
* (T297754, CVE-2022-28204) Special:WhatLinksHere can result in a DoS when a
  page is used on a extremely large number of other pages.

== MediaWiki 1.37.1 ==

This is a security and maintenance release of the MediaWiki 1.37 branch.

=== Changes since MediaWiki 1.37.0 ===
* (T296112) Allow inserting new sections named '0'.
* Fix path for ZhConversion.php.
* nukeNS: don't run purgeRedundantText() after every change.
* (T286779, T297031) installer: Fix Postgres mistakes in using changeField
  method.
* (T225888) RollbackAction: fix missing pagetitle.
* (T297322, CVE-2021-44858, CVE-2021-44857) SECURITY: Fix permissions checks in
  undo actions.
* (T297574, CVE-2021-45038) SECURITY: Fix permissions check in action=rollback.
* (T34716, T297416) SECURITY: Require 'read' right for most actions.
* (T271037, CVE-2021-44856) SECURITY: Fix use of EditFilterMergedContent hook
  when changing content model.

== MediaWiki 1.37.0 ==

=== Changes since MediaWiki 1.37.0-rc.2 ===
* Remove justinrainbow/json-schema from vendor.
* Updated pear/mail_mime from 1.10.9 to 1.10.11.
* Update deprecated Guzzle Psr7 function calls.
* (T281972) UserIdentityValue: Correct @since tags.
* Updated wikimedia/parsoid from v0.14.0-a19 to v0.14.0.
* Localisation updates.
* Tweak error message for missing composer dependencies.

== MediaWiki 1.37.0-rc.2 ==

=== Changes since MediaWiki 1.37.0-rc.1 ===
* (T295173) Re-add wikimedia/normalized-exception to vendor.
* Remove wikimedia/testing-access-wrapper, psr/simple-cache, psr/http-factory
  from vendor.
* (T295191) ApiQuerySiteinfo: Fix "rightsinfo"/"url" when $wgRightsPage is set.
* (T212428) Allow populateContentTables to continue when there are bad blobs.

== MediaWiki 1.37.0-rc.1 ==

=== Changes since MediaWiki 1.37.0-rc.0 ===
* (T294043) checkStorage: pass no parameters to WikiRevision::getContent().
* (T292763, CVE-2021-44854) SECURITY: Do not cache private wiki completion
  results.
* (T293783) ApiQueryImageInfo: don't show empty comments as deleted.
* (T294316) Revert "Mark ApiClientLogin/ApiLogin as requiring write mode".
* (T294796) JobQueueRedis: Replace deprecated zSize with zCard.
* Remove duplicate settings from DefaultSettings.
* (T278037) NoLocalSettings: Pass an EmptyBagOStuff to TemplateParser.

== MediaWiki 1.37.0-rc.0 ==

== Upgrading notes for 1.37 ==
Don't forget to always back up your database before upgrading!

See the file UPGRADE for more detailed per-version upgrade instructions from the
oldest supported upgrading version, MediaWiki 1.27.

Some specific notes for MediaWiki 1.37 upgrades are below:
* (T280806) Deprecated methods of fetching API tokens have been removed. This
  may cause older bots and scripts to fail. Most queries are trivially
  updateable to using new methods. See the Action API changes section below
  for more information.

For notes on 1.36.x and older releases, see HISTORY.

=== Configuration changes for system administrators in 1.37 ===
* (T242768) The PasswordCannotMatchUsername password policy has been removed,
  please use PasswordCannotBeSubstringInUsername instead. If you have not
  customised your password policies, there will be nothing to do here.

==== New configuration ====
* $wgBrowserFormatDetection - This setting allows the enabling or disabling
  of automatic detection of possible phone numbers in a webpage in iOS Safari.
* $wgParserEnableLegacyMediaDOM - This setting defaults to true, and enables
  the legacy media HTML structure in the output from the Parser.  The
  alternative modern HTML structure for media is described at
  https://www.mediawiki.org/wiki/Parsing/Media_structure
  In a future release of MediaWiki this option will default to false,
  so it's a good idea to test this setting on your wiki early and report
  any issues.

==== Changed configuration ====
* $wgContentHandlerTextFallback - This migration setting, which defines how to
  react if a plain text version of a non-text Content object is requested using
  ContentHandler::getContentText(), is deprecated.
* $wgActions – This setting lets sysadmins over-ride which actions can be used.
  It has been re-worked to support injecting dependencies into Action sub-
  classes as part of wider work on dependency injection. Previously, $wgActions
  was an array where the keys were the names of actions, and the values had the
  following impacts (for a given key 'Foo'):
  - `true`: use the class 'FooAction' unless for a specific page
    WikiPage::getActionOverrides() wants to override that action
  - a string: use the class with that name, and do not allow over-riding on a
    per-page basis
  - `false`: the action is disabled
  - a callable: use the Action instance returned by invoking that callback, and
    do not allow overriding on a per-page basis
  - an object: use that specific Action instance, and do not allow overr-iding
    on a per-page basis.
  As part of T253078, values can now be arrays that are not callables, which are
  treated as ObjectFactory specs, allowing for services to be injected.
  Additionally, the distinction between values that allow per-page overrides and
  those that do not was removed - all actions can now be overridden on a per-
  page basis using WikiPage::getActionOverrides().
* $wgShellboxUrl – This setting, new in 1.36 to configure the novel Shellbox
  encapsulation system, is now deprecated; use $wgShellboxUrls as a mapping of
  service => URL instead.
* $wgIncludejQueryMigrate – This setting, introduced in 1.29 to on whether to
  provide a migration layer for jQuery, has now switched its default value from
  true to false. This may break gadgets that depended on methods that were
  removed in jQuery 3 in 2017. See T280944 for more information.
* A number of settings have been renamed. The former configuration variable
  names are deprecated, but will be used as the fall back if they are still set,
  and remain temporarily available for extensions which might try to read them:
  - $wgFileBlacklist is now $wgProhibitedFileExtensions
  - $wgMimeTypeBlacklist is now $wgMimeTypeExclusions
  - $wgEnableUserEmailBlacklist is now $wgEnableUserEmailMuteList
  - $wgShortPagesNamespaceBlacklist is now $wgShortPagesNamespaceExclusions
* $wgMimeTypeExclusions - As well as being renamed, this configuration array now
  also prohibits the RFC 4329 form of JavaScript, 'application/javascript', as
  well as previous MIME types.
* $wgFragmentMode - This setting, which determines the encoding of section IDs,
  has now switched its default value from legacy-first to html5-first: both the
  HTML5 anchor and the legacy percent-encoding-style anchor will still be
  generated for section titles, but references to them will use the HTML5
  version, resulting in human-readable fragments.

==== Removed configuration ====
* $wgLegacyJavaScriptGlobals, deprecated in 1.36.
* (T274695) $wgAjaxEditStash, deprecated in 1.36.
* $wgShowDBErrorBacktrace, deprecated and non-functional since 1.32.
* $wgShowSQLErrors, deprecated and non-functional since 1.32.
* $wgLangObjCacheSize, without deprecation; the LanguageFactory service now
  always retains at most 10 objects in its LRU-cache.
* $wgDjvuToXML, without deprecation; the tool it enables is obsolete and
  abandoned upstream. Use $wgDjvuDump to use that tool instead.

=== New user-facing features in 1.37 ===
* (T161934) MediaWiki now supports JPEG2000 files, to a limited extent.

=== External library changes in 1.37 ===

==== New external libraries ====
* Added symfony/polyfill-php80 1.23.1.
* Added whatwg-fetch 3.6.2.
* Added wikimedia/normalized-exception 1.0.1.

==== Changed external libraries ====
* Updated OOjs from v5.0.0 to v6.0.0
* Updated OOjs-Router from v0.2.0 to v0.3.0
* Updated OOUI from v0.41.3 to v0.42.0
* Updated WVUI from v0.1.0 to v0.3.0
* Updated cssjanus/cssjanus from v1.3.0 to v2.1.0.
* Updated pear/mail_mime from 1.10.9 to 1.10.11.
* Updated psr/container from v1.0.0 to v1.1.1.
* Updated wikimedia/minify from v2.2.2 to v2.2.4.
* Updated wikimedia/object-factory from v3.0.0 to v3.0.2.
* Updated wikimedia/parsoid from v0.13.1 to v0.14.1.
* Updated wikimedia/relpath from v2.1.1 to v3.0.0.
* Updated wikimedia/remex-html from v2.3.1 to v2.3.2.
* Updated wikimedia/shellbox from v1.0.4 to v2.1.1.
* Updated wikimedia/wait-condition-loop from v2.0.1 to v2.0.2.
* Updated zordius/lightncandy from v1.2.5 to v1.2.6.
* Updated guzzlehttp/guzzle from 7.2.0 to 7.4.5.
* Updated wikimedia/common-passwords from 0.3.0 to 0.4.0.

===== Changed development-only external libraries =====
* Updated qunit from 2.10.0 to 2.16.0.

==== Removed external libraries ====
* The pimple/pimple development-only library has been removed.

=== Action API changes in 1.37 ===
* (T280806) The API methods for fetching tokens which were deprecated in
  MediaWiki 1.24 have been removed. action=query&meta=tokens&type= should be
  used instead. Please note some token types no longer exist, and you should
  just use type=csrf for those instead.
  - action=query&prop=info&intoken ->
      action=query&meta=tokens&type=csrf
  - action=tokens&type= ->
      action=query&meta=tokens&type=
  - action=query&list=recentchanges&rctoken ->
      action=query&meta=tokens&type=csrf
  - action=query&prop=revisions&rvtoken=rollback ->
      action=query&meta=tokens&type=rollback
  - action=query&meta=userinfo&uiprop=preferencestoken ->
      action=query&meta=tokens&type=csrf
  - action=query&list=users&ustoken=userrights ->
      action=query&meta=tokens&type=userrights

=== Languages updated in 1.37 ===
MediaWiki supports over 350 languages. Many localisations are updated regularly.
Below only new and removed languages are listed, as well as changes to languages
because of Phabricator reports.

* (T280435) LRM and RLM characters were removed from names of languages with
  parentheses in Names.php
* (T283422) Add namespace name translations and change the autonym of
  the Kinyarwanda language to "Ikinyarwanda".
* (T283423) Change the autonym of the Lombard language from "lumbaart"
  to "lombard".
* (T279619) Added language support for Dagbani (dag).
* (T282085) Added language support for Malay in Arabic (Jawi) script (ms-arab).
* (T283053) Added language support for Ojibwe (ojb).
* (T283480) Added language support for Wallisian (wls, Fakaʻuvea).
* (T284002) Added language support for Paiwan (pwn).
* (T284044) Added language support for Carpathian Romani (rmc).
* (T286460) Added language support for Gun (guw, Gungbe).
* (T287345) Added language support for Baoulé (bci).
* (T290126) Added language support for Kildin Sami (sjd).
* (T290408) Added language support for Pite Sami (sje).
* (T25216) Started the renaming of the language code for Norman from nrm to
  nrf.

=== Breaking changes in 1.37 ===
* The Revision class, emitting deprecation warnings since 1.35, was removed
  entirely. As part of this, the following hooks that included a Revision object
  were removed:
    - ArticleRevisionUndeleted - use RevisionUndeleted
    - ArticleRollbackComplete - use RollbackComplete
    - DiffRevisionTools - use DiffTools
    - DiffViewHeader - use DifferenceEngineViewHeader
    - HistoryRevisionTools - use HistoryTools
    - NewRevisionFromEditComplete - use RevisionFromEditComplete
    - PageContentInsertComplete - use PageSaveComplete
    - PageContentSaveComplete - use PageSaveComplete
    - ParserFetchTemplate - use BeforeParserFetchTemplateRevisionRecord
    - RevisionInsertComplete - use RevisionRecordInserted
    - TitleMoveComplete - use PageMoveComplete
    - TitleMoveCompleting - use PageMoveCompleting
    - UndeleteShowRevision - no replacement
    - UserRetrieveNewTalks - no replacement
  … the following methods and variables have been removed:
    - Article::$mRevision
    - Article::getRevisionFetched()
    - ContribsPager::tryToCreateValidRevision()
    - EditPage::$mBaseRevision
    - EditPage::getBaseRevision()
    - LinksUpdate::getRevision()
    - LinksUpdate::setRevision()
    - PageArchive::getArchivedRevision()
    - PageArchive::getPreviousRevision()
    - PageArchive::getRevision()
    - Parser::$mRevisionObject
    - Parser::fetchCurrentRevisionOfTitle()
    - Parser::getRevisionObject()
    - Parser::statelessFetchRevision()
    - ParserOptions::getCurrentRevisionCallback()
    - ParserOptions::setCurrentRevisionCallback()
    - Title::countAuthorsBetween()
    - Title::getFirstRevision()
    - User::getNewMessageLinks()
    - User::getNewMessageRevisionId()
    - User::setNewtalk()
    - WikiPage::getOldestRevision()
    - WikiPage::getRevision()
    - WikiPage::getUndoContent()
    - WikiPage::updateIfNewerOn()
  … and the following methods no longer accept Revision objects as parameters:
    - CategoryMembershipChange::__construct()
    - ContentHandler::getUndoContent()
    - DerivedPageDataUpdater::prepareUpdate()
    - DifferenceEngine::getRevisionHeader()
    - Linker::buildRollbackLink()
    - Linker::generateRollback()
    - Linker::getRevDeleteLink()
    - Linker::getRollbackEditCount()
    - Linker::revComment()
    - Linker::revUserLink()
    - Linker::revUserTools()
    - WikiPage::doDeleteUpdates()
    - WikiPage::doEditUpdates()
    - WikiPage::hasDifferencesOutsideMainSlot()
    - WikiPage::onArticleEdit()
    - WikiPage::prepareContentForEdit()
    - WikiPage::updateRevisionOn()
  The following methods return arrays that formerly included a 'revision'
  key that would emit deprecation warnings when accessed and return a
  Revision object. The Revision object has been removed from the arrays,
  and the 'revision-record' key should be used to get the relevant
  RevisionRecord instead:
    - PageUpdater::doCreate()
    - PageUpdater::doModify()
    - Parser::statelessFetchTemplate()
    - WikiPage::doEditContent()
  Finally, the ParserOptions `templateCallback` option is a callback that is
  called in Parser::fetchTemplateAndTitle() and should return an array - the
  'revision' key to that array used to be a Revision object and was used if
  no 'revision-record' was returned - is now ignored.
* Previously, the classes RevisionTestModifyableContent and
  RevisionTestModifyableContentHandler were loaded for use in tests, but were
  only used within the tests for the since-removed Revision class. This content
  and content handler class were removed without deprecation.
* WANObjectCache::HOLDOFF_NONE, deprecated since 1.35, was removed. Use
  WANObjectCache::HOLDOFF_TTL_NONE instead.
* Calling ResourceLoader::makeVersionQuery() without $modules parameter,
  deprecated since MediaWiki 1.34, is no longer supported.
* LocalFile::recordUpload2(), deprecated since 1.35, was removed.
* The following methods and fields in the Language class, deprecated since 1.35,
  have been removed:
   - ::classFromCode()
   - ::clearCaches()
   - ::convertTitle()
   - ::findVariantLink()
   - ::$mConverter
   - ::updateConversionTable()
* The following methods in the Parser class have been removed after having been
  deprecated in 1.35:
   - fetchTemplate()
   - Title()
* (T273354) When an edit is prevented by an 'EditFilterMergedContent' hook
  handler without changing the status, the edit form will now be displayed.
* User::clearNotification() which had been deprecated in 1.35 has been removed.
  Use WatchlistManager::clearTitleUserNotification() instead.
* User::getNewtalk() which had been deprecated in 1.35 has been removed. Use
  TalkPageNotificationManager::userHasNewMessages() instead.
* The Autopromote class, deprecated since 1.35, was removed. Use
  UserGroupManager instead.
* The CachedAction, SpecialCachedPage, CacheHelper, and ICacheHelper classes,
  all emitting deprecation warnings since 1.36, have been removed.
* The hooks BeforeHttpsRedirect, CanIPUseHTTPS and UserRequiresHTTPS, deprecated
  in 1.35, were removed.
* The TitleArrayFromResult hook, deprecated in 1.36, was removed.
* The deprecated "es6-promise" alias ResourceLoader module has been removed. Use
  the "es6-polyfills" module directly intead.
* The deprecated "mediawiki.legacy.protect" ResourceLoader module, deprecated
  since 1.36, has been removed. Use "mediawiki.action.protect" instead.
* The JavaScript alias $j for references to jQuery, deprecated since 1.23, has
  been removed. Use $ instead.
* The AuthenticationProvider interface and the SessionProvider class no longer
  extend the PSR LoggerAwareInterface concept, so they can't be typehinted as
  LoggerAwareInterface.
* User::getGrantName(), emitting deprecation warnings since 1.36, has been
  removed. Use MWGrants::grantName() instead.
* The following ApiBase methods, deprecated since 1.35, have been removed:
  - ApiBase::explodeMultiValue
  - ApiBase::parseMultiValue
  - ApiBase::validateLimit
  - ApiBase::validateTimestamp
* The User::idCacheByName() public static field was removed without deprecation.
  Instead of using it, get a UserIdentity by name from the UserIdentityLookup
  service.
* IDatabase::upsert() and IDatabase::replace() now only accept a single unique
  key. Previously, a warning was issued if there were multiple unique keys
  provided.
* The MediaWiki:Autoblock_whitelist block exemption control was moved in 1.36 to
  MediaWiki:Block-autoblock-exemptionlist. The backward-compatibility of reading
  the old MediaWiki:Autoblock_whitelist page has now been dropped.
* The following overridable methods in File hierarchy have changed signatures:
  - File::deleteFile() - now accepts UserIdentity instead of User
  - File::getDescription() - now accepts Authority instead of User
  - File::userCan() - now accepts Authority instead of User
  - LocalFile::deleteOldFile() - now accepts UserIdentity instead of User
* The following global methods, each deprecated since 1.36, have been removed:
  - wfAppendToArrayIfNotDefault()
  - wfAcceptToPrefs()
  - wfConfiguredReadOnlyReason()
  - wfDebugMem()
  - wfGetPrecompiledData()
  - wfNegotiateType()
* The following deprecated methods of the Title class have been removed:
  - ::nameOf(), deprecated in 1.36
  - ::getPreviousRevisionID(), deprecated in 1.34
  - ::getNextRevisionID(), deprecated in 1.34
  - ::getEarliestRevTime(), deprecated in 1.35
* UploadBase::stashFile(), deprecated since 1.28, was removed.
* wfGetRusage(), deprecated since 1.35, has been removed.
* The following CLI options were removed from tests/phpunit.php:
    - use-filebackend
    - use-jobqueue
    - use-bagostuff
  The following options (inherited from Maintenance) were also removed:
    - conf
    - dbuser
    - dbpass
    - dbdefaultgroup
    - globals
    - memory-limit
    - profiler
    - server
  The following options were changed to environment variables:
    - wiki => PHPUNIT_WIKI
    - use-normal-tables => PHPUNIT_USE_NORMAL_TABLES
    - use-filebackend => PHPUNIT_USE_FILEBACKEND
    - use-bagostuff => PHPUNIT_USE_BAGOSTUFF
    - use-jobqueue => PHPUNIT_USE_JOBQUEUE
  This is so that we can use the default PHPUnit entry point (T90875).
* The PHPUNIT_REUSE_DB / --reuse-db option was removed from the phpunit.php
  runner. It had been broken for at least three years already. The original use
  case was speeding up tests on Oracle, but Oracle support was dropped several
  releases ago.
* The MediaWikiPHPUnitTest__endTestHook and MediaWikiPHPUnitTest__startTestHook
  PHPUnit hooks were removed. MediaWikiHooksPHPUnitExtension was also removed.
* EntryPoint::getTextFormatters() was made private without a deprecation period;
  it had no known external callers.
* DatabaseBlock::chooseBlock(), deprecated since 1.35, was removed.
* SpecialPageFactory::getRestrictedPages(), deprecated since 1.36, was removed.
* SpecialBlock::validateTarget(), deprecated since 1.36, was removed.
* The PatchFileLocation trait was removed without deprecation.
* ActorMigrationBase::getExistingActorId() and ::getNewActorId(), emitting
  deprecation warnings since 1.36, were removed.
* Hook handlers implementing the MediaWikiServicesHook hook are now prohibited
  from having services injected. This is because by definition, this hook runs
  before the service container is fully initialized.
* The protected property LocalFile::$metadata was removed without deprecation.
* WatchedItem::getUser(), emitting deprecation warnings since 1.36, has been
  removed.
* AuthManager::singleton(), emitting deprecation warnings since 1.36, has been
  removed.
* The AugmentPageProps class was removed without deprecation. It had no known
  uses.
* Html::infobox(), deprecated since 1.36, was removed.
* ParserOptions::__construct() now requires that the first parameter is a
  UserIdentity object - passing `null` used to fallback to the global
  $wgUser but was deprecated since 1.36.
* ParserOptions::newCanonical() no longer supports the first parameter being
  null (or omitted entirely), which would fallback to the global $wgUser but
  was deprecated since 1.35.
* The SkinTemplatePreventOtherActiveTabs hook, deprecated in 1.35, was removed
  entirely.
* The SkinTemplateTabAction hook, deprecated in 1.35, was removed entirely.
* The SkinTemplateBuildNavUrlsNav_urlsAfterPermalink hook, deprecated in 1.35,
  was removed entirely.
* The SkinTemplateToolboxEndHook, deprecated in 1.35, was removed entirely.
* The following methods of RevisionStore class, formerly emitting deprecation
  warnings, were removed:
  - ::newMutableRevisionFromArray()
  - ::loadRevisionFromPageId()
  - ::loadRevisionFromTitle()
  - ::loadRevisionFromTimestamp()
  - ::listRevisionSizes()
* LogEntry::getPerformer(), deprecated since 1.36, was removed along with
  methods in sub-classes: DatabaseLogEntry, ManualLogEntry, RCDatabaseLogEntry.
* Skin::getRelevantUser() now returns an instance of UserIdentity, and not
  necessarily a User object. There is no known usages in MediaWiki ecosystem
  that were not satisfied with UserIdentity.
* Direct construction of MergeHistory class, deprecated since 1.35, is no longer
  supported. Use MergeHistoryFactory instead. MergeHistory::checkPermissions,
  deprecated since 1.36, was removed.
* Skin::generateDebugHTML(), deprecated since 1.35, was removed. Call
  MWDebug::getHTMLDebugLog() directly.
* The ApiTestCase class no longer interacts with the global $wgUser.
  Previously, the global variable was set at the start of each test, and in
  ApiTestCase::doApiRequest() if a performer was specified $wgUser was
  updated to match, and if no performer was specified $wgUser was used
  instead. Now, $wgUser is not updated, and if no performer is specified
  the reusable TestUser object for the sysop is relied on. Extensions
  or skins that rely on the global $wgUser variable (which has been
  deprecated since 1.35) should instead retrieve the acting user from the
  relevant context source.
* SkinTemplate::makeArticleUrlDetails(), deprecated since 1.35, was removed.
* Skin::makeNSUrl(), deprecated since 1.35, was removed.
* Skin::getRevisionId(), deprecated since 1.34, was removed. Use
  OutputPage::getRevisionId() instead.
* Skin::isRevisionCurrent(), deprecated since 1.34, was removed. Use
  OutputPage::isRevisionCurrent() instead.
* AbstractBlock::parseTarget(), deprecated since 1.36, was removed.
* The ArticleEditUpdates hook, deprecated since 1.35, was removed.
* The `@stable to extend` class CentralIdLookup has following changes:
  - The protected ::checkAudience() method now returns an Authority instead of a
    User instance.
  - A number of its `@stable to override` methods now accept an Authority
    instead of a User instance as the $audience parameter.
  - A number of methods now accept a UserIdentity instead of their User
    parameter.
  - The ::localUserFromCentralId() method now returns UserIdentity and not
    necessarily a User object.
  All extensions that extend this class or use this method were updated to be
  ready to the new behavior.
* WatchedItemStoreInterface::enqueueWatchlistExpiryJob(), deprecated since 1.36,
  was removed.
* ResultWrapper is now abstract. It cannot be directly constructed (T286694).
* The SecondaryDataUpdates hook, deprecated in 1.32, was removed entirely.
* Content::getDeletionUpdates(), was removed. Use
  ContentHandler::getDeletionUpdates() instead.
* Content::getSecondaryDataUpdates(), was removed. Use
  ContentHandler::getSecondaryDataUpdates() instead.
* wfDiff(), deprecated since 1.25, has been removed.
* Language::$mLangObjCache, deprecated since 1.35, was removed.
* Language::$transformData, deprecated since 1.35, was removed.
